
_interrupt:

;IR.c,75 :: 		void interrupt() {                 // interrepts are here, but serve no function yet
;IR.c,76 :: 		if (TMR0IF_bit) {                // handle timer 0 overflow
	BTFSS       TMR0IF_bit+0, 2 
	GOTO        L_interrupt0
;IR.c,77 :: 		cnt++;                       // Increment counter - gives extra 2 bytes counter option
	INFSNZ      _cnt+0, 1 
	INCF        _cnt+1, 1 
;IR.c,78 :: 		TMR0IF_bit = 0;              // Clear TMR0IF
	BCF         TMR0IF_bit+0, 2 
;IR.c,79 :: 		}
L_interrupt0:
;IR.c,80 :: 		if (INT0F_bit){                  // handle interrupt on B0 pin
	BTFSS       INT0F_bit+0, 1 
	GOTO        L_interrupt1
;IR.c,81 :: 		INT0F_bit = 0;               // clear interrupt
	BCF         INT0F_bit+0, 1 
;IR.c,82 :: 		if (INTEDG0_bit){
	BTFSS       INTEDG0_bit+0, 6 
	GOTO        L_interrupt2
;IR.c,83 :: 		INTEDG0_bit = 0;         // interrupt on B0 falling edge
	BCF         INTEDG0_bit+0, 6 
;IR.c,84 :: 		}
	GOTO        L_interrupt3
L_interrupt2:
;IR.c,86 :: 		INTEDG0_bit = 1;         // interrupt on B0 rising edge
	BSF         INTEDG0_bit+0, 6 
;IR.c,87 :: 		}
L_interrupt3:
;IR.c,88 :: 		}
L_interrupt1:
;IR.c,89 :: 		}
L_end_interrupt:
L__interrupt214:
	RETFIE      1
; end of _interrupt

_main:

;IR.c,92 :: 		void main() {
;IR.c,93 :: 		ANSELA = 0;                   // Configure PORT pins as digital
	CLRF        ANSELA+0 
;IR.c,94 :: 		ANSELB = 0;                   // Configure PORT pins as digital
	CLRF        ANSELB+0 
;IR.c,95 :: 		ANSELC = 0;                   // Configure PORT pins as digital
	CLRF        ANSELC+0 
;IR.c,96 :: 		ANSELD = 0;                   // Configure PORT pins as digital
	CLRF        ANSELD+0 
;IR.c,97 :: 		ADCON0 = 0;                   // A/D off
	CLRF        ADCON0+0 
;IR.c,98 :: 		ADCON1 = 0x0f;                // all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;IR.c,100 :: 		CM1CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;IR.c,101 :: 		CM2CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;IR.c,102 :: 		T0CON = 0x86;                 // timer on 16 bit prescale 128:1
	MOVLW       134
	MOVWF       T0CON+0 
;IR.c,103 :: 		TMR0L = 96;                   // Timer0 initial value
	MOVLW       96
	MOVWF       TMR0L+0 
;IR.c,104 :: 		TMR0H = 0xff;
	MOVLW       255
	MOVWF       TMR0H+0 
;IR.c,105 :: 		INTCON = 0xB0;                // Enable TMRO and INT interrupts
	MOVLW       176
	MOVWF       INTCON+0 
;IR.c,106 :: 		cnt = 0;                      // Initialize cnt
	CLRF        _cnt+0 
	CLRF        _cnt+1 
;IR.c,108 :: 		LATA = 0;                     // all off
	CLRF        LATA+0 
;IR.c,109 :: 		LATB = 0x80;                  // disable GLCD if fitted
	MOVLW       128
	MOVWF       LATB+0 
;IR.c,110 :: 		LATD = 0;                     // all off
	CLRF        LATD+0 
;IR.c,111 :: 		LATC = 0;                     // all off
	CLRF        LATC+0 
;IR.c,112 :: 		LATE = 0;                     // all off
	CLRF        LATE+0 
;IR.c,113 :: 		TRISA = 0xC1;                 // all output except OSC pins
	MOVLW       193
	MOVWF       TRISA+0 
;IR.c,114 :: 		TRISB = 0x81;                 // all output except b0
	MOVLW       129
	MOVWF       TRISB+0 
;IR.c,115 :: 		TRISC = 0x01;                 // all output except c0
	MOVLW       1
	MOVWF       TRISC+0 
;IR.c,116 :: 		TRISD = 0xff;                 // all input
	MOVLW       255
	MOVWF       TRISD+0 
;IR.c,117 :: 		TRISE = 0;                    // all output
	CLRF        TRISE+0 
;IR.c,118 :: 		PWM1_Init(38000);             // 38kHz on RC2
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       209
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;IR.c,120 :: 		PWM1_Set_Duty(80);            // 30%
	MOVLW       80
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;IR.c,121 :: 		PWM2_Init(38000);             // 38kHz on RC1 (or possibly RB3)
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       209
	MOVWF       PR2+0, 0
	CALL        _PWM2_Init+0, 0
;IR.c,123 :: 		PWM2_Set_Duty(80);            // 30%
	MOVLW       80
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;IR.c,124 :: 		ir_in_direction = 1;          // IR input
	BSF         TRISC0_bit+0, 0 
;IR.c,125 :: 		UART1_Init(9600);             // Initialize UART module at 9600 bps
	BSF         BAUDCON+0, 3, 0
	MOVLW       3
	MOVWF       SPBRGH+0 
	MOVLW       64
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;IR.c,126 :: 		Delay_ms(100);                // Wait for UART module to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main4:
	DECFSZ      R13, 1, 1
	BRA         L_main4
	DECFSZ      R12, 1, 1
	BRA         L_main4
	DECFSZ      R11, 1, 1
	BRA         L_main4
;IR.c,127 :: 		UART1_Write_Text("\r\n\nIR Utilities\r\n\n");
	MOVLW       ?lstr1_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,129 :: 		Delay_ms(1000);                // Wait for LCD to stabilize
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main5:
	DECFSZ      R13, 1, 1
	BRA         L_main5
	DECFSZ      R12, 1, 1
	BRA         L_main5
	DECFSZ      R11, 1, 1
	BRA         L_main5
;IR.c,130 :: 		Lcd_Init();                            // Initialize Lcd
	CALL        _Lcd_Init+0, 0
;IR.c,131 :: 		Lcd_Cmd(_LCD_CLEAR);                   // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IR.c,132 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);              // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IR.c,133 :: 		while(1){
L_main6:
;IR.c,134 :: 		Lcd_Out(1,1, "0LED 1Sh 2T 3NEC");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,135 :: 		Lcd_Out(2,1, "4Sony 5RC5 6RC6 ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,137 :: 		UART1_Write_Text("0 Simple IR test\r\n");
	MOVLW       ?lstr4_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,138 :: 		UART1_Write_Text("1 Sharp Rx (beta)\r\n");
	MOVLW       ?lstr5_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,139 :: 		UART1_Write_Text("2 PT2248/9 Rx\r\n");
	MOVLW       ?lstr6_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,140 :: 		UART1_Write_Text("3 NEC  Rx\r\n");
	MOVLW       ?lstr7_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,141 :: 		UART1_Write_Text("4 Sony Rx\r\n");
	MOVLW       ?lstr8_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,142 :: 		UART1_Write_Text("5 RC5  Rx\r\n");
	MOVLW       ?lstr9_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,143 :: 		UART1_Write_Text("6 RC6 m0, RC6 m6-32 \r\n");
	MOVLW       ?lstr10_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,144 :: 		UART1_Write_Text("7 RC6 mode 6-20 (Sky)\r\n");
	MOVLW       ?lstr11_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,145 :: 		UART1_Write_Text("8 Timing print\r\n");
	MOVLW       ?lstr12_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr12_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,147 :: 		cmd = get_cmd();                         // read command from UART or switches
	CALL        _get_cmd+0, 0
	MOVF        R0, 0 
	MOVWF       _cmd+0 
;IR.c,148 :: 		switch (cmd){
	GOTO        L_main8
;IR.c,149 :: 		case '0': simple_ir(); break;
L_main10:
	CALL        _simple_ir+0, 0
	GOTO        L_main9
;IR.c,150 :: 		case '1': sharp_print(); break;
L_main11:
	CALL        _sharp_print+0, 0
	GOTO        L_main9
;IR.c,151 :: 		case '2': tosh_print(); break;
L_main12:
	CALL        _tosh_print+0, 0
	GOTO        L_main9
;IR.c,152 :: 		case '3': nec_print(); break;
L_main13:
	CALL        _nec_print+0, 0
	GOTO        L_main9
;IR.c,153 :: 		case '4': sony_print(); break;
L_main14:
	CALL        _sony_print+0, 0
	GOTO        L_main9
;IR.c,154 :: 		case '5': rc5_print(); break;
L_main15:
	CALL        _rc5_print+0, 0
	GOTO        L_main9
;IR.c,155 :: 		case '6': rc6_print(); break;
L_main16:
	CALL        _rc6_print+0, 0
	GOTO        L_main9
;IR.c,156 :: 		case '7': sky_print(); break;
L_main17:
	CALL        _sky_print+0, 0
	GOTO        L_main9
;IR.c,157 :: 		case '8': timing_print(); break;
L_main18:
	CALL        _timing_print+0, 0
	GOTO        L_main9
;IR.c,158 :: 		default:  break;
L_main19:
	GOTO        L_main9
;IR.c,159 :: 		}
L_main8:
	MOVF        _cmd+0, 0 
	XORLW       48
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _cmd+0, 0 
	XORLW       49
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	MOVF        _cmd+0, 0 
	XORLW       50
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	MOVF        _cmd+0, 0 
	XORLW       51
	BTFSC       STATUS+0, 2 
	GOTO        L_main13
	MOVF        _cmd+0, 0 
	XORLW       52
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
	MOVF        _cmd+0, 0 
	XORLW       53
	BTFSC       STATUS+0, 2 
	GOTO        L_main15
	MOVF        _cmd+0, 0 
	XORLW       54
	BTFSC       STATUS+0, 2 
	GOTO        L_main16
	MOVF        _cmd+0, 0 
	XORLW       55
	BTFSC       STATUS+0, 2 
	GOTO        L_main17
	MOVF        _cmd+0, 0 
	XORLW       56
	BTFSC       STATUS+0, 2 
	GOTO        L_main18
	GOTO        L_main19
L_main9:
;IR.c,161 :: 		}
	GOTO        L_main6
;IR.c,163 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_get_cmd:

;IR.c,166 :: 		char get_cmd(void){
;IR.c,169 :: 		retval = 0;                             // init
	CLRF        get_cmd_retval_L0+0 
;IR.c,170 :: 		while(!retval){                         // loop until something found
L_get_cmd22:
	MOVF        get_cmd_retval_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd23
;IR.c,171 :: 		if (UART1_Data_Ready()){              // anything received by UART?
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_cmd24
;IR.c,172 :: 		retval = UART1_Read();            // then get the character
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       get_cmd_retval_L0+0 
;IR.c,173 :: 		}
L_get_cmd24:
;IR.c,175 :: 		if(PORTD == 0x01) retval='0';         // button D0
	MOVF        PORTD+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd25
	MOVLW       48
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd25:
;IR.c,176 :: 		if(PORTD == 0x02) retval='1';         // button D1
	MOVF        PORTD+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd26
	MOVLW       49
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd26:
;IR.c,177 :: 		if(PORTD == 0x04) retval='2';         // button D2
	MOVF        PORTD+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd27
	MOVLW       50
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd27:
;IR.c,178 :: 		if(PORTD == 0x08) retval='3';         // button D3
	MOVF        PORTD+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd28
	MOVLW       51
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd28:
;IR.c,179 :: 		if(PORTD == 0x10) retval='4';         // button D4
	MOVF        PORTD+0, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd29
	MOVLW       52
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd29:
;IR.c,180 :: 		if(PORTD == 0x20) retval='5';         // button D5
	MOVF        PORTD+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd30
	MOVLW       53
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd30:
;IR.c,181 :: 		if(PORTD == 0x40) retval='6';         // button D6
	MOVF        PORTD+0, 0 
	XORLW       64
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd31
	MOVLW       54
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd31:
;IR.c,182 :: 		if(PORTD == 0x80) retval='7';         // button D7
	MOVF        PORTD+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd32
	MOVLW       55
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd32:
;IR.c,183 :: 		}
	GOTO        L_get_cmd22
L_get_cmd23:
;IR.c,184 :: 		return retval;                          // return ASCII character
	MOVF        get_cmd_retval_L0+0, 0 
	MOVWF       R0 
;IR.c,185 :: 		}
L_end_get_cmd:
	RETURN      0
; end of _get_cmd

_simple_ir:

;IR.c,187 :: 		void simple_ir(void){
;IR.c,188 :: 		UART1_Write_Text("\r\nwatch LED on RE0\r\n");
	MOVLW       ?lstr13_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr13_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,189 :: 		Lcd_Out(1,1, " Simple IR test ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr14_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr14_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,190 :: 		Lcd_Out(2,1, "watch LED on RE0");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr15_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr15_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,191 :: 		while(1){
L_simple_ir33:
;IR.c,192 :: 		if(ir_in){                          // read IR input
	BTFSS       RC0_bit+0, 0 
	GOTO        L_simple_ir35
;IR.c,193 :: 		RE0_bit = 0;                   // LED off
	BCF         RE0_bit+0, 0 
;IR.c,194 :: 		}
	GOTO        L_simple_ir36
L_simple_ir35:
;IR.c,196 :: 		RE0_bit = 1;                   // LED on
	BSF         RE0_bit+0, 0 
;IR.c,197 :: 		}
L_simple_ir36:
;IR.c,198 :: 		}
	GOTO        L_simple_ir33
;IR.c,199 :: 		}
L_end_simple_ir:
	RETURN      0
; end of _simple_ir

_timing_print:

;IR.c,202 :: 		void timing_print(void){
;IR.c,207 :: 		UART1_Write_Text("\r\nTiming print\r\n");
	MOVLW       ?lstr16_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr16_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,208 :: 		UART1_Write_Text("uS timings are approximate\r\n");
	MOVLW       ?lstr17_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr17_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,209 :: 		UART1_Write_Text("Waiting for IR\r\n");
	MOVLW       ?lstr18_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr18_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,210 :: 		Lcd_Out(1,1, "timing to RS232 ");     // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr19_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr19_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,211 :: 		Lcd_Out(2,1, "  9600 8 n 1    ");     // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr20_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr20_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,212 :: 		while(ir_in);                            // wait for IR to go low
L_timing_print37:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_timing_print38
	GOTO        L_timing_print37
L_timing_print38:
;IR.c,214 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	CLRF        timing_print_ir_bit_L0+0 
L_timing_print39:
	MOVLW       33
	SUBWF       timing_print_ir_bit_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_timing_print40
;IR.c,215 :: 		TMR0H = 0;                           // zero timer 0
	CLRF        TMR0H+0 
;IR.c,216 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,217 :: 		while(!ir_in);                       // wait for IR to go high
L_timing_print42:
	BTFSC       RC0_bit+0, 0 
	GOTO        L_timing_print43
	GOTO        L_timing_print42
L_timing_print43:
;IR.c,218 :: 		ir_mark[ir_bit] = TMR0L;             // read timer 0
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        TMR0L+0, 0 
	MOVWF       POSTINC1+0 
	MOVLW       0
	MOVWF       POSTINC1+0 
;IR.c,219 :: 		ir_mark[ir_bit] +=(TMR0H<<8);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVFF       R3, FSR0
	MOVFF       R4, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVFF       R3, FSR1
	MOVFF       R4, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;IR.c,220 :: 		TMR0H = 0;                           // zero timer 0
	CLRF        TMR0H+0 
;IR.c,221 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,222 :: 		while(ir_in);                        // wait for IR to go low
L_timing_print44:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_timing_print45
	GOTO        L_timing_print44
L_timing_print45:
;IR.c,223 :: 		ir_space[ir_bit] = TMR0L;            // read timer 0
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        TMR0L+0, 0 
	MOVWF       POSTINC1+0 
	MOVLW       0
	MOVWF       POSTINC1+0 
;IR.c,224 :: 		ir_space[ir_bit] += (TMR0H<<8);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVFF       R3, FSR0
	MOVFF       R4, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVFF       R3, FSR1
	MOVFF       R4, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;IR.c,214 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	INCF        timing_print_ir_bit_L0+0, 1 
;IR.c,225 :: 		}
	GOTO        L_timing_print39
L_timing_print40:
;IR.c,227 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	CLRF        timing_print_ir_bit_L0+0 
L_timing_print46:
	MOVLW       33
	SUBWF       timing_print_ir_bit_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_timing_print47
;IR.c,228 :: 		IntToStr(ir_bit,fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,229 :: 		UART1_Write_Text("\r\nbit");
	MOVLW       ?lstr21_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr21_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,230 :: 		UART1_Write_Text(fb_string);         // print bit number
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,231 :: 		IntToStr(ir_mark[ir_bit],fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,232 :: 		UART1_Write_Text("   mark");
	MOVLW       ?lstr22_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr22_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,233 :: 		UART1_Write_Text(fb_string);         // print mark time
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,234 :: 		IntToStr(ir_space[ir_bit],fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,235 :: 		UART1_Write_Text("    space");
	MOVLW       ?lstr23_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr23_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,236 :: 		UART1_Write_Text(fb_string);         // print space time
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,238 :: 		UART1_Write_Text("   (");
	MOVLW       ?lstr24_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr24_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,239 :: 		print_ir_time(ir_mark[ir_bit]);      // convert T0 value to microseconds
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+1 
	CALL        _print_ir_time+0, 0
;IR.c,240 :: 		print_ir_time(ir_space[ir_bit]);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+1 
	CALL        _print_ir_time+0, 0
;IR.c,241 :: 		UART1_Write_Text(" uS)");
	MOVLW       ?lstr25_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr25_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,227 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	INCF        timing_print_ir_bit_L0+0, 1 
;IR.c,243 :: 		}
	GOTO        L_timing_print46
L_timing_print47:
;IR.c,244 :: 		UART1_Write_Text("\r\n\ndone\r\n");
	MOVLW       ?lstr26_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr26_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,245 :: 		}
L_end_timing_print:
	RETURN      0
; end of _timing_print

_print_ir_time:

;IR.c,249 :: 		void print_ir_time(unsigned int ir_time){
;IR.c,253 :: 		time_ul = ir_time;                        // int to long
	MOVF        FARG_print_ir_time_ir_time+0, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        FARG_print_ir_time_ir_time+1, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVLW       0
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,254 :: 		time_ul *= 65UL;
	MOVF        print_ir_time_time_ul_L0+0, 0 
	MOVWF       R0 
	MOVF        print_ir_time_time_ul_L0+1, 0 
	MOVWF       R1 
	MOVF        print_ir_time_time_ul_L0+2, 0 
	MOVWF       R2 
	MOVF        print_ir_time_time_ul_L0+3, 0 
	MOVWF       R3 
	MOVLW       65
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       0
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        R1, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVF        R2, 0 
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVF        R3, 0 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,255 :: 		time_ul /= 4UL;
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	MOVF        R4, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        R5, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVF        R6, 0 
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVF        R7, 0 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,257 :: 		IntToStr(time_ui,fb_string);              // convert to string
	MOVF        R4, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        R5, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,258 :: 		UART1_Write_Text(fb_string);              // and print it
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,259 :: 		}
L_end_print_ir_time:
	RETURN      0
; end of _print_ir_time

_hexout:

;IR.c,262 :: 		void hexout(unsigned char hexval){
;IR.c,266 :: 		temp_hex = hexval;                     // to integer
	MOVF        FARG_hexout_hexval+0, 0 
	MOVWF       hexout_temp_hex_L0+0 
	MOVLW       0
	MOVWF       hexout_temp_hex_L0+1 
;IR.c,267 :: 		IntToHex(temp_hex, hextxt);            // integer to ASCII hex
	MOVF        hexout_temp_hex_L0+0, 0 
	MOVWF       FARG_IntToHex_input+0 
	MOVF        hexout_temp_hex_L0+1, 0 
	MOVWF       FARG_IntToHex_input+1 
	MOVLW       hexout_hextxt_L0+0
	MOVWF       FARG_IntToHex_output+0 
	MOVLW       hi_addr(hexout_hextxt_L0+0)
	MOVWF       FARG_IntToHex_output+1 
	CALL        _IntToHex+0, 0
;IR.c,268 :: 		UART1_Write_Text(hextxt+2);
	MOVLW       hexout_hextxt_L0+2
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(hexout_hextxt_L0+2)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,269 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr27_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr27_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,270 :: 		keephex[0] = hextxt[2];                // store ascii hex for later
	MOVF        hexout_hextxt_L0+2, 0 
	MOVWF       _keephex+0 
;IR.c,271 :: 		keephex[1] = hextxt[3];
	MOVF        hexout_hextxt_L0+3, 0 
	MOVWF       _keephex+1 
;IR.c,272 :: 		keephex[2] = 0;                        // null terminate
	CLRF        _keephex+2 
;IR.c,273 :: 		}
L_end_hexout:
	RETURN      0
; end of _hexout

_nec_print:

;IR.c,287 :: 		void nec_print(void){
;IR.c,291 :: 		UART1_Write_Text("\r\nWaiting for NEC IR\r\n");
	MOVLW       ?lstr28_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr28_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,292 :: 		Lcd_Out(1,1, "NEC protocol IR ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr29_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr29_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,293 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr30_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr30_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,295 :: 		while(1){
L_nec_print49:
;IR.c,296 :: 		while(ir_in);                         // wait for IR to go low
L_nec_print51:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_nec_print52
	GOTO        L_nec_print51
L_nec_print52:
;IR.c,298 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       nec_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       nec_print_temp_ir_L0+1 
;IR.c,299 :: 		if ((temp_ir > 500) && (temp_ir < 800)){       // expect 9mS mark
	MOVLW       128
	XORLW       1
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print222
	MOVF        R0, 0 
	SUBLW       244
L__nec_print222:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print55
	MOVLW       128
	XORWF       nec_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       3
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print223
	MOVLW       32
	SUBWF       nec_print_temp_ir_L0+0, 0 
L__nec_print223:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print55
L__nec_print206:
;IR.c,300 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       nec_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       nec_print_temp_ir_L0+1 
;IR.c,301 :: 		if ((temp_ir > 200) && (temp_ir < 400)){   // expect 4.5mS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print224
	MOVF        R0, 0 
	SUBLW       200
L__nec_print224:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print58
	MOVLW       128
	XORWF       nec_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print225
	MOVLW       144
	SUBWF       nec_print_temp_ir_L0+0, 0 
L__nec_print225:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print58
L__nec_print205:
;IR.c,302 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
	CLRF        nec_print_count_byte_L0+0 
L_nec_print59:
	MOVLW       4
	SUBWF       nec_print_count_byte_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print60
;IR.c,303 :: 		ir_result[count_byte] = get_nec_byte();
	MOVLW       _ir_result+0
	MOVWF       FLOC__nec_print+0 
	MOVLW       hi_addr(_ir_result+0)
	MOVWF       FLOC__nec_print+1 
	MOVF        nec_print_count_byte_L0+0, 0 
	ADDWF       FLOC__nec_print+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FLOC__nec_print+1, 1 
	CALL        _get_nec_byte+0, 0
	MOVFF       FLOC__nec_print+0, FSR1
	MOVFF       FLOC__nec_print+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;IR.c,302 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
	INCF        nec_print_count_byte_L0+0, 1 
;IR.c,304 :: 		}
	GOTO        L_nec_print59
L_nec_print60:
;IR.c,305 :: 		}
L_nec_print58:
;IR.c,306 :: 		UART1_Write_Text("\r\nNEC ");
	MOVLW       ?lstr31_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr31_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,307 :: 		Lcd_Out(2,1, "NEC            ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr32_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr32_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,308 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++){
	CLRF        nec_print_count_byte_L0+0 
L_nec_print62:
	MOVLW       4
	SUBWF       nec_print_count_byte_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print63
;IR.c,309 :: 		hexout(ir_result[count_byte]);
	MOVLW       _ir_result+0
	MOVWF       FSR0 
	MOVLW       hi_addr(_ir_result+0)
	MOVWF       FSR0H 
	MOVF        nec_print_count_byte_L0+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,310 :: 		Lcd_Chr(2,(count_byte * 3)+5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MULWF       nec_print_count_byte_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       5
	ADDWF       FARG_Lcd_Chr_column+0, 1 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,311 :: 		Lcd_Chr(2,(count_byte * 3)+6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MULWF       nec_print_count_byte_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       6
	ADDWF       FARG_Lcd_Chr_column+0, 1 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,308 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++){
	INCF        nec_print_count_byte_L0+0, 1 
;IR.c,312 :: 		}
	GOTO        L_nec_print62
L_nec_print63:
;IR.c,313 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_nec_print65:
	DECFSZ      R13, 1, 1
	BRA         L_nec_print65
	DECFSZ      R12, 1, 1
	BRA         L_nec_print65
	NOP
;IR.c,314 :: 		}
L_nec_print55:
;IR.c,315 :: 		}
	GOTO        L_nec_print49
;IR.c,317 :: 		}
L_end_nec_print:
	RETURN      0
; end of _nec_print

_get_nec_byte:

;IR.c,320 :: 		unsigned char get_nec_byte(void){
;IR.c,325 :: 		for(n=0 ; n<8 ; n++){
	CLRF        get_nec_byte_n_L0+0 
L_get_nec_byte66:
	MOVLW       8
	SUBWF       get_nec_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_nec_byte67
;IR.c,326 :: 		temp_ir = get_mark();                         // expect ~600uS
	CALL        _get_mark+0, 0
;IR.c,327 :: 		temp_ir = get_space();                        // 500uS = 0, 1.6uS = 1
	CALL        _get_space+0, 0
;IR.c,328 :: 		ir_byte >>= 1;                                // shift in a zero
	RRCF        get_nec_byte_ir_byte_L0+0, 1 
	BCF         get_nec_byte_ir_byte_L0+0, 7 
;IR.c,329 :: 		if (temp_ir > 70){                            // check > 900uS
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_nec_byte227
	MOVF        R0, 0 
	SUBLW       70
L__get_nec_byte227:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_nec_byte69
;IR.c,330 :: 		ir_byte += 0x80;                          // change 0 to a 1 if so
	MOVLW       128
	ADDWF       get_nec_byte_ir_byte_L0+0, 1 
;IR.c,331 :: 		}
L_get_nec_byte69:
;IR.c,325 :: 		for(n=0 ; n<8 ; n++){
	INCF        get_nec_byte_n_L0+0, 1 
;IR.c,332 :: 		}
	GOTO        L_get_nec_byte66
L_get_nec_byte67:
;IR.c,333 :: 		return ir_byte;                                   // return final byte
	MOVF        get_nec_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,334 :: 		}
L_end_get_nec_byte:
	RETURN      0
; end of _get_nec_byte

_get_mark:

;IR.c,337 :: 		int get_mark(void){
;IR.c,338 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IR.c,339 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,340 :: 		while(!ir_in);                       // wait for IR to go high
L_get_mark70:
	BTFSC       RC0_bit+0, 0 
	GOTO        L_get_mark71
	GOTO        L_get_mark70
L_get_mark71:
;IR.c,341 :: 		LATE.F0 = 0;                         // LED off
	BCF         LATE+0, 0 
;IR.c,342 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IR.c,343 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IR.c,344 :: 		return retint;
;IR.c,345 :: 		}
L_end_get_mark:
	RETURN      0
; end of _get_mark

_get_space:

;IR.c,348 :: 		int get_space(void){
;IR.c,349 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IR.c,350 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,351 :: 		while(ir_in);                        // wait for IR to go low
L_get_space72:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_get_space73
	GOTO        L_get_space72
L_get_space73:
;IR.c,352 :: 		LATE.F0 = 1;                         // LED on
	BSF         LATE+0, 0 
;IR.c,353 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IR.c,354 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IR.c,355 :: 		return retint;
;IR.c,356 :: 		}
L_end_get_space:
	RETURN      0
; end of _get_space

_sharp_print:

;IR.c,368 :: 		void sharp_print(void)
;IR.c,372 :: 		UART1_Write_Text("\r\nWaiting for Sharp IR\r\n");
	MOVLW       ?lstr34_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr34_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,373 :: 		Lcd_Out(1,1, "Sharp protocol  ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr35_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr35_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,374 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr36_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr36_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,376 :: 		while(1){
L_sharp_print74:
;IR.c,377 :: 		while(ir_in);                         // wait for IR to go low
L_sharp_print76:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_sharp_print77
	GOTO        L_sharp_print76
L_sharp_print77:
;IR.c,379 :: 		ir_result[0] = get_sharp_byte(5);         // 5 bit address
	MOVLW       5
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,380 :: 		ir_result[1] = get_sharp_byte(8);         // 8 bit command
	MOVLW       8
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,381 :: 		ir_result[2] = get_sharp_byte(2);         // 2 bits extension or check
	MOVLW       2
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,382 :: 		ir_result[3] = get_sharp_byte(1);         // 1 bit inter-message gap
	MOVLW       1
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,383 :: 		if(ir_result[2]==1){                      // is this a data message?
	MOVF        _ir_result+2, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_sharp_print78
;IR.c,384 :: 		UART1_Write_Text("   add=");
	MOVLW       ?lstr37_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr37_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,385 :: 		Lcd_Out(2,1, "add=   cmd=     ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr38_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr38_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,386 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,387 :: 		Lcd_Chr(2,5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,388 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,389 :: 		UART1_Write_Text(" cmd=");
	MOVLW       ?lstr39_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr39_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,390 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,391 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,392 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,393 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr40_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr40_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,394 :: 		}
L_sharp_print78:
;IR.c,395 :: 		Delay_ms(400);                           // allow repeat messages to be lost
	MOVLW       17
	MOVWF       R11, 0
	MOVLW       60
	MOVWF       R12, 0
	MOVLW       203
	MOVWF       R13, 0
L_sharp_print79:
	DECFSZ      R13, 1, 1
	BRA         L_sharp_print79
	DECFSZ      R12, 1, 1
	BRA         L_sharp_print79
	DECFSZ      R11, 1, 1
	BRA         L_sharp_print79
;IR.c,396 :: 		}
	GOTO        L_sharp_print74
;IR.c,397 :: 		}
L_end_sharp_print:
	RETURN      0
; end of _sharp_print

_get_sharp_byte:

;IR.c,400 :: 		unsigned char get_sharp_byte(char nbits){
;IR.c,405 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sharp_byte_ir_byte_L0+0 
;IR.c,406 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_sharp_byte_n_L0+0 
L_get_sharp_byte80:
	MOVF        FARG_get_sharp_byte_nbits+0, 0 
	SUBWF       get_sharp_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sharp_byte81
;IR.c,407 :: 		temp_ir = get_mark();                     // expect ~320uS
	CALL        _get_mark+0, 0
;IR.c,408 :: 		temp_ir = get_space();                    // 680uS = 0, 1680uS = 1
	CALL        _get_space+0, 0
;IR.c,409 :: 		ir_byte >>= 1;
	RRCF        get_sharp_byte_ir_byte_L0+0, 1 
	BCF         get_sharp_byte_ir_byte_L0+0, 7 
;IR.c,410 :: 		if (temp_ir > 70){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sharp_byte232
	MOVF        R0, 0 
	SUBLW       70
L__get_sharp_byte232:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sharp_byte83
;IR.c,411 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sharp_byte_ir_byte_L0+0, 1 
;IR.c,412 :: 		}
L_get_sharp_byte83:
;IR.c,406 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_sharp_byte_n_L0+0, 1 
;IR.c,413 :: 		}
	GOTO        L_get_sharp_byte80
L_get_sharp_byte81:
;IR.c,414 :: 		ir_byte >>= 8-nbits;                          // convert 1/2/5/8 bits to 8
	MOVF        FARG_get_sharp_byte_nbits+0, 0 
	SUBLW       8
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVF        get_sharp_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__get_sharp_byte233:
	BZ          L__get_sharp_byte234
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L__get_sharp_byte233
L__get_sharp_byte234:
	MOVF        R0, 0 
	MOVWF       get_sharp_byte_ir_byte_L0+0 
;IR.c,415 :: 		return ir_byte;
;IR.c,416 :: 		}
L_end_get_sharp_byte:
	RETURN      0
; end of _get_sharp_byte

_sony_print:

;IR.c,440 :: 		void sony_print(void){
;IR.c,443 :: 		UART1_Write_Text("\r\nWaiting for Sony IR\r\n");
	MOVLW       ?lstr41_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr41_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,444 :: 		Lcd_Out(1,1, "Sony protocol   ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr42_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr42_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,445 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr43_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr43_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,447 :: 		while(1){
L_sony_print84:
;IR.c,448 :: 		while(ir_in);                         // wait for IR to go low
L_sony_print86:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_sony_print87
	GOTO        L_sony_print86
L_sony_print87:
;IR.c,450 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sony_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sony_print_temp_ir_L0+1 
;IR.c,451 :: 		if ((temp_ir > 150) && (temp_ir < 250)){       // expect 2.4mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_print236
	MOVF        R0, 0 
	SUBLW       150
L__sony_print236:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_print90
	MOVLW       128
	XORWF       sony_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_print237
	MOVLW       250
	SUBWF       sony_print_temp_ir_L0+0, 0 
L__sony_print237:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_print90
L__sony_print207:
;IR.c,452 :: 		ir_result[0] = get_sony_byte(7);           // 7 bit command
	MOVLW       7
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,453 :: 		ir_result[1] = get_sony_byte(5);           // 5 bit address
	MOVLW       5
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,454 :: 		UART1_Write_Text("\r\nSony cmd=");
	MOVLW       ?lstr44_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr44_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,455 :: 		Lcd_Out(2,1, "cmd=   addr=    ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr45_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr45_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,456 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,457 :: 		Lcd_Chr(2,5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,458 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,459 :: 		UART1_Write_Text(" addr=");
	MOVLW       ?lstr46_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr46_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,460 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,461 :: 		Lcd_Chr(2,13,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,462 :: 		Lcd_Chr(2,14,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,463 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sony_print91:
	DECFSZ      R13, 1, 1
	BRA         L_sony_print91
	DECFSZ      R12, 1, 1
	BRA         L_sony_print91
	NOP
;IR.c,464 :: 		}
L_sony_print90:
;IR.c,465 :: 		}
	GOTO        L_sony_print84
;IR.c,467 :: 		}
L_end_sony_print:
	RETURN      0
; end of _sony_print

_get_sony_byte:

;IR.c,470 :: 		unsigned char get_sony_byte(char nbits){
;IR.c,475 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sony_byte_ir_byte_L0+0 
;IR.c,476 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_sony_byte_n_L0+0 
L_get_sony_byte92:
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBWF       get_sony_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte93
;IR.c,477 :: 		temp_ir = get_space();                    // expect ~510uS
	CALL        _get_space+0, 0
;IR.c,478 :: 		temp_ir = get_mark();                     // 650uS = 0, 1.2uS = 1
	CALL        _get_mark+0, 0
;IR.c,479 :: 		ir_byte >>= 1;
	RRCF        get_sony_byte_ir_byte_L0+0, 1 
	BCF         get_sony_byte_ir_byte_L0+0, 7 
;IR.c,480 :: 		if (temp_ir > 60){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sony_byte239
	MOVF        R0, 0 
	SUBLW       60
L__get_sony_byte239:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte95
;IR.c,481 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sony_byte_ir_byte_L0+0, 1 
;IR.c,482 :: 		}
L_get_sony_byte95:
;IR.c,476 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_sony_byte_n_L0+0, 1 
;IR.c,483 :: 		}
	GOTO        L_get_sony_byte92
L_get_sony_byte93:
;IR.c,484 :: 		ir_byte >>= 8-nbits;                          // convert 5/7 bits to 8
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBLW       8
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVF        get_sony_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__get_sony_byte240:
	BZ          L__get_sony_byte241
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L__get_sony_byte240
L__get_sony_byte241:
	MOVF        R0, 0 
	MOVWF       get_sony_byte_ir_byte_L0+0 
;IR.c,485 :: 		return ir_byte;
;IR.c,486 :: 		}
L_end_get_sony_byte:
	RETURN      0
; end of _get_sony_byte

_rc5_print:

;IR.c,496 :: 		void rc5_print(void){
;IR.c,501 :: 		UART1_Write_Text("\r\nWaiting for RC5 IR\r\n");
	MOVLW       ?lstr48_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr48_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,502 :: 		Lcd_Out(1,1, "RC5 protocol IR ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr49_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr49_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,503 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr50_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr50_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,505 :: 		while(1){
L_rc5_print96:
;IR.c,506 :: 		while(ir_in);                         // wait for IR to go low
L_rc5_print98:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_rc5_print99
	GOTO        L_rc5_print98
L_rc5_print99:
;IR.c,508 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,509 :: 		irnowm = 0;                                    // init
	CLRF        _irnowm+0 
;IR.c,510 :: 		temp_ir = get_mark();                          // second half of start bit 1
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc5_print_temp_ir_L0+1 
;IR.c,511 :: 		if ((temp_ir > 40) && (temp_ir < 80)){         // expect 890uS mark start bit1
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_print243
	MOVF        R0, 0 
	SUBLW       40
L__rc5_print243:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_print102
	MOVLW       128
	XORWF       rc5_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_print244
	MOVLW       80
	SUBWF       rc5_print_temp_ir_L0+0, 0 
L__rc5_print244:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_print102
L__rc5_print208:
;IR.c,512 :: 		rc5_byte1 = get_rc5_byte(7);               // start bit2 '1' + toggle + 5 bit address
	MOVLW       7
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_rc5_byte1_L0+0 
;IR.c,513 :: 		rc5_byte2 = get_rc5_byte(6);               // 6 bit command
	MOVLW       6
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_rc5_byte2_L0+0 
;IR.c,514 :: 		UART1_Write_Text("\r\nrc5");
	MOVLW       ?lstr51_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr51_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,515 :: 		Lcd_Out(2,1, "t=0 ad=   cmd=  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr52_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr52_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,516 :: 		if (rc5_byte1 & 0x20){
	BTFSS       rc5_print_rc5_byte1_L0+0, 5 
	GOTO        L_rc5_print103
;IR.c,517 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr53_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr53_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,518 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,519 :: 		}
	GOTO        L_rc5_print104
L_rc5_print103:
;IR.c,521 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr54_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr54_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,522 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,523 :: 		}
L_rc5_print104:
;IR.c,524 :: 		UART1_Write_Text(" addr=");
	MOVLW       ?lstr55_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr55_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,525 :: 		hexout(rc5_byte1 & 0x1F);                  // 5 bits address
	MOVLW       31
	ANDWF       rc5_print_rc5_byte1_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,526 :: 		Lcd_Chr(2,8,keephex[0]);                   // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,527 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,528 :: 		UART1_Write_Text(" cmd=");
	MOVLW       ?lstr56_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr56_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,529 :: 		hexout(rc5_byte2);
	MOVF        rc5_print_rc5_byte2_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,530 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,531 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,532 :: 		Delay_ms(100);                              // wait for repeat messages to clear
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_rc5_print105:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_print105
	DECFSZ      R12, 1, 1
	BRA         L_rc5_print105
	DECFSZ      R11, 1, 1
	BRA         L_rc5_print105
;IR.c,533 :: 		}
L_rc5_print102:
;IR.c,534 :: 		}
	GOTO        L_rc5_print96
;IR.c,536 :: 		}
L_end_rc5_print:
	RETURN      0
; end of _rc5_print

_get_rc5_byte:

;IR.c,539 :: 		unsigned char get_rc5_byte(char nbits){
;IR.c,542 :: 		irbyte = 0;                                  // initialise
	CLRF        _irbyte+0 
;IR.c,543 :: 		for(n = 0 ; n < nbits ; n++){
	CLRF        get_rc5_byte_n_L0+0 
L_get_rc5_byte106:
	MOVF        FARG_get_rc5_byte_nbits+0, 0 
	SUBWF       get_rc5_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_rc5_byte107
;IR.c,544 :: 		getrc5bit();
	CALL        _getrc5bit+0, 0
;IR.c,543 :: 		for(n = 0 ; n < nbits ; n++){
	INCF        get_rc5_byte_n_L0+0, 1 
;IR.c,545 :: 		}
	GOTO        L_get_rc5_byte106
L_get_rc5_byte107:
;IR.c,546 :: 		return irbyte;
	MOVF        _irbyte+0, 0 
	MOVWF       R0 
;IR.c,547 :: 		}
L_end_get_rc5_byte:
	RETURN      0
; end of _get_rc5_byte

_getrc5bit:

;IR.c,550 :: 		void getrc5bit(void){
;IR.c,552 :: 		if(!irnowm){
	MOVF        _irnowm+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit109
;IR.c,554 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit110
;IR.c,556 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,557 :: 		temp_bit_s = get_space();                         // get 1st half of bit
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,558 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,559 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,560 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit247
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit247:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit111
	CLRF        _irwas2t+0 
L_getrc5bit111:
;IR.c,561 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,562 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,563 :: 		}
	GOTO        L_getrc5bit112
L_getrc5bit110:
;IR.c,566 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,567 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,568 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,569 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit248
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit248:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit113
	CLRF        _irwas2t+0 
L_getrc5bit113:
;IR.c,570 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,571 :: 		}
L_getrc5bit112:
;IR.c,572 :: 		}
	GOTO        L_getrc5bit114
L_getrc5bit109:
;IR.c,575 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit115
;IR.c,577 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,578 :: 		temp_bit_m = get_mark();                          // get 1st half of bit
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,579 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,580 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,581 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit249
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit249:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit116
	CLRF        _irwas2t+0 
L_getrc5bit116:
;IR.c,582 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,583 :: 		}
	GOTO        L_getrc5bit117
L_getrc5bit115:
;IR.c,586 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,587 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,588 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,589 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit250
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit250:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit118
	CLRF        _irwas2t+0 
L_getrc5bit118:
;IR.c,590 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,591 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,592 :: 		}
L_getrc5bit117:
;IR.c,593 :: 		}
L_getrc5bit114:
;IR.c,594 :: 		}
L_end_getrc5bit:
	RETURN      0
; end of _getrc5bit

_rc6_print:

;IR.c,606 :: 		void rc6_print(void){
;IR.c,611 :: 		UART1_Write_Text("\r\nWaiting for RC6 IR\r\n");
	MOVLW       ?lstr58_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr58_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,612 :: 		Lcd_Out(1,1, "RC6m0, RC6m6-32 ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr59_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr59_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,613 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr60_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr60_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,615 :: 		while(1){
L_rc6_print119:
;IR.c,616 :: 		while(ir_in);                         // wait for IR to go low
L_rc6_print121:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_rc6_print122
	GOTO        L_rc6_print121
L_rc6_print122:
;IR.c,619 :: 		leader6 = 0;        // init
	CLRF        rc6_print_leader6_L0+0 
;IR.c,621 :: 		while(!leader6){
L_rc6_print123:
	MOVF        rc6_print_leader6_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print124
;IR.c,622 :: 		temp_ir = get_mark();                      // get leader
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,623 :: 		if ((temp_ir > 140) && (temp_ir < 200)){   // expect 2.66mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print252
	MOVF        R0, 0 
	SUBLW       140
L__rc6_print252:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print127
	MOVLW       128
	XORWF       rc6_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print253
	MOVLW       200
	SUBWF       rc6_print_temp_ir_L0+0, 0 
L__rc6_print253:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print127
L__rc6_print210:
;IR.c,624 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,625 :: 		if ((temp_ir > 40) && (temp_ir < 60)){   // expect 889uS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print254
	MOVF        R0, 0 
	SUBLW       40
L__rc6_print254:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print130
	MOVLW       128
	XORWF       rc6_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print255
	MOVLW       60
	SUBWF       rc6_print_temp_ir_L0+0, 0 
L__rc6_print255:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print130
L__rc6_print209:
;IR.c,626 :: 		leader6 = 1;                           // leader found - allow exit loop
	MOVLW       1
	MOVWF       rc6_print_leader6_L0+0 
;IR.c,627 :: 		}
L_rc6_print130:
;IR.c,628 :: 		}
L_rc6_print127:
;IR.c,629 :: 		}
	GOTO        L_rc6_print123
L_rc6_print124:
;IR.c,631 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,632 :: 		irnowm = 0xff;                                 // init
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,633 :: 		rc6_mode = get_rc6_byte(4);                    // start bit2 '1' + 3 bits mode
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_rc6_mode_L0+0 
;IR.c,634 :: 		rc6_mode &= 0x07;                              // remove start bit '1' to leave 3 bits mode
	MOVLW       7
	ANDWF       R0, 0 
	MOVWF       rc6_print_rc6_mode_L0+0 
;IR.c,637 :: 		if (irwas2t){                                  // actually detecting 3t, single toggle bit is double size
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print131
;IR.c,638 :: 		ir_toggle = 1;                             // have found a trailer / toggle bit of 1
	MOVLW       1
	MOVWF       _ir_toggle+0 
;IR.c,639 :: 		irnowm = 0;                                // leave in space state
	CLRF        _irnowm+0 
;IR.c,640 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,641 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,642 :: 		if(temp_bit_s < 70){
	MOVLW       128
	XORWF       _temp_bit_s+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print256
	MOVLW       70
	SUBWF       _temp_bit_s+0, 0 
L__rc6_print256:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print132
;IR.c,643 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,644 :: 		}
L_rc6_print132:
;IR.c,645 :: 		}
	GOTO        L_rc6_print133
L_rc6_print131:
;IR.c,647 :: 		ir_toggle = 0;                             // have found a trailer / toggle bit of 0
	CLRF        _ir_toggle+0 
;IR.c,648 :: 		irnowm = 0;                                // leave in space state
	CLRF        _irnowm+0 
;IR.c,649 :: 		temp_ir = get_space();                     // skip over the space
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,650 :: 		temp_ir = get_mark();                      // read the mark
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,651 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,652 :: 		if(temp_bit_m < 70){
	MOVLW       128
	XORWF       _temp_bit_m+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print257
	MOVLW       70
	SUBWF       _temp_bit_m+0, 0 
L__rc6_print257:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print134
;IR.c,653 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,654 :: 		}
L_rc6_print134:
;IR.c,655 :: 		}
L_rc6_print133:
;IR.c,657 :: 		if (rc6_mode == 0){
	MOVF        rc6_print_rc6_mode_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print135
;IR.c,659 :: 		ir_result[1] = get_rc6_byte(8);            // control byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,660 :: 		ir_result[2] = get_rc6_byte(8);            // information byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,662 :: 		UART1_Write_Text("rc6 mode 0");
	MOVLW       ?lstr61_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr61_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,663 :: 		Lcd_Out(1,1, "RC6 mode 0      ");          // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr62_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr62_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,664 :: 		Lcd_Out(2,1, "t=0 ct=   inf=  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr63_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr63_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,665 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print136
;IR.c,666 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr64_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr64_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,667 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,668 :: 		}
	GOTO        L_rc6_print137
L_rc6_print136:
;IR.c,670 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr65_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr65_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,671 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,672 :: 		}
L_rc6_print137:
;IR.c,673 :: 		UART1_Write_Text(" ctrl=");
	MOVLW       ?lstr66_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr66_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,674 :: 		hexout(ir_result[1]);                      // 8 bits control byte
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,675 :: 		Lcd_Chr(2,8,keephex[0]);                   // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,676 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,677 :: 		UART1_Write_Text(" inf=");
	MOVLW       ?lstr67_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr67_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,678 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,679 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,680 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,681 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_rc6_print138:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_print138
	DECFSZ      R12, 1, 1
	BRA         L_rc6_print138
	NOP
;IR.c,682 :: 		}
L_rc6_print135:
;IR.c,684 :: 		if (rc6_mode == 6){
	MOVF        rc6_print_rc6_mode_L0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print139
;IR.c,686 :: 		ir_result[1] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,687 :: 		ir_result[2] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,688 :: 		ir_result[3] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,689 :: 		ir_result[4] = get_rc6_byte(7);               // only 7 bits of byte
	MOVLW       7
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+4 
;IR.c,691 :: 		ir_result[3] <<= 1;                           // leave room for last bit
	MOVF        _ir_result+3, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       _ir_result+3 
;IR.c,692 :: 		if (ir_result[3] & 0x02){                     // penultimate bit was 1
	BTFSS       R1, 1 
	GOTO        L_rc6_print140
;IR.c,693 :: 		if (!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print141
;IR.c,694 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,695 :: 		}
L_rc6_print141:
;IR.c,696 :: 		get_mark();
	CALL        _get_mark+0, 0
;IR.c,697 :: 		}
	GOTO        L_rc6_print142
L_rc6_print140:
;IR.c,699 :: 		if (irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print143
;IR.c,700 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,701 :: 		}
	GOTO        L_rc6_print144
L_rc6_print143:
;IR.c,704 :: 		}
L_rc6_print144:
;IR.c,705 :: 		}
L_rc6_print142:
;IR.c,707 :: 		UART1_Write_Text("rc6 mode 6-32");
	MOVLW       ?lstr68_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr68_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,708 :: 		Lcd_Out(1,1, "RC6 mode 6-32   ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr69_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr69_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,709 :: 		Lcd_Out(2,1, "t=0             ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr70_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr70_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,710 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print145
;IR.c,711 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr71_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr71_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,712 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,713 :: 		}
	GOTO        L_rc6_print146
L_rc6_print145:
;IR.c,715 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr72_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr72_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,716 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,717 :: 		}
L_rc6_print146:
;IR.c,718 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr73_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr73_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,719 :: 		hexout(ir_result[1]);                         // 4 bits
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,720 :: 		Lcd_Chr(2,8,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,721 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,722 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,723 :: 		Lcd_Chr(2,10,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,724 :: 		Lcd_Chr(2,11,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,725 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,726 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,727 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,728 :: 		hexout(ir_result[4]);
	MOVF        _ir_result+4, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,729 :: 		Lcd_Chr(2,14,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,730 :: 		Lcd_Chr(2,15,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,731 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_rc6_print147:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_print147
	DECFSZ      R12, 1, 1
	BRA         L_rc6_print147
	NOP
;IR.c,732 :: 		}
L_rc6_print139:
;IR.c,733 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr74_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr74_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,734 :: 		}
	GOTO        L_rc6_print119
;IR.c,735 :: 		}
L_end_rc6_print:
	RETURN      0
; end of _rc6_print

_get_rc6_byte:

;IR.c,738 :: 		unsigned char get_rc6_byte(char nbits){
;IR.c,741 :: 		irbyte = 0;                                  // initialise
	CLRF        _irbyte+0 
;IR.c,742 :: 		for(n = 0 ; n < nbits ; n++){
	CLRF        get_rc6_byte_n_L0+0 
L_get_rc6_byte148:
	MOVF        FARG_get_rc6_byte_nbits+0, 0 
	SUBWF       get_rc6_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_rc6_byte149
;IR.c,743 :: 		getrc6bit();
	CALL        _getrc6bit+0, 0
;IR.c,742 :: 		for(n = 0 ; n < nbits ; n++){
	INCF        get_rc6_byte_n_L0+0, 1 
;IR.c,744 :: 		}
	GOTO        L_get_rc6_byte148
L_get_rc6_byte149:
;IR.c,745 :: 		return irbyte;
	MOVF        _irbyte+0, 0 
	MOVWF       R0 
;IR.c,746 :: 		}
L_end_get_rc6_byte:
	RETURN      0
; end of _get_rc6_byte

_getrc6bit:

;IR.c,749 :: 		void getrc6bit(void){
;IR.c,751 :: 		if(!irnowm){
	MOVF        _irnowm+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit151
;IR.c,753 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit152
;IR.c,755 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,756 :: 		temp_bit_s = get_space();                         // get 1st half of bit
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,757 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,758 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,759 :: 		if(temp_bit_m < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit260
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit260:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit153
	CLRF        _irwas2t+0 
L_getrc6bit153:
;IR.c,760 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,761 :: 		}
	GOTO        L_getrc6bit154
L_getrc6bit152:
;IR.c,764 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,765 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,766 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,767 :: 		if(temp_bit_s < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit261
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit261:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit155
	CLRF        _irwas2t+0 
L_getrc6bit155:
;IR.c,768 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,769 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,770 :: 		}
L_getrc6bit154:
;IR.c,771 :: 		}
	GOTO        L_getrc6bit156
L_getrc6bit151:
;IR.c,774 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit157
;IR.c,776 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,777 :: 		temp_bit_m = get_mark();                          // get 1st half of bit
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,778 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,779 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,780 :: 		if(temp_bit_s < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit262
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit262:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit158
	CLRF        _irwas2t+0 
L_getrc6bit158:
;IR.c,781 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,782 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,783 :: 		}
	GOTO        L_getrc6bit159
L_getrc6bit157:
;IR.c,786 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,787 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,788 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,789 :: 		if(temp_bit_m < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit263
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit263:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit160
	CLRF        _irwas2t+0 
L_getrc6bit160:
;IR.c,790 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,791 :: 		}
L_getrc6bit159:
;IR.c,792 :: 		}
L_getrc6bit156:
;IR.c,793 :: 		}
L_end_getrc6bit:
	RETURN      0
; end of _getrc6bit

_sky_print:

;IR.c,796 :: 		void sky_print(void){
;IR.c,801 :: 		UART1_Write_Text("\r\nWaiting for RC6 IR\r\n");
	MOVLW       ?lstr75_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr75_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,802 :: 		Lcd_Out(1,1, "RC6 mode6-20 Sky");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr76_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr76_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,803 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr77_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr77_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,805 :: 		while(1){
L_sky_print161:
;IR.c,806 :: 		while(ir_in);                         // wait for IR to go low
L_sky_print163:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_sky_print164
	GOTO        L_sky_print163
L_sky_print164:
;IR.c,809 :: 		leader6 = 0;        // init
	CLRF        sky_print_leader6_L0+0 
;IR.c,811 :: 		while(!leader6){
L_sky_print165:
	MOVF        sky_print_leader6_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print166
;IR.c,812 :: 		temp_ir = get_mark();                      // get leader
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,813 :: 		if ((temp_ir > 140) && (temp_ir < 200)){   // expect 2.66mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print265
	MOVF        R0, 0 
	SUBLW       140
L__sky_print265:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print169
	MOVLW       128
	XORWF       sky_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print266
	MOVLW       200
	SUBWF       sky_print_temp_ir_L0+0, 0 
L__sky_print266:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print169
L__sky_print212:
;IR.c,814 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,815 :: 		if ((temp_ir > 40) && (temp_ir < 60)){   // expect 889uS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print267
	MOVF        R0, 0 
	SUBLW       40
L__sky_print267:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print172
	MOVLW       128
	XORWF       sky_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print268
	MOVLW       60
	SUBWF       sky_print_temp_ir_L0+0, 0 
L__sky_print268:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print172
L__sky_print211:
;IR.c,816 :: 		leader6 = 1;                           // leader found - allow exit loop
	MOVLW       1
	MOVWF       sky_print_leader6_L0+0 
;IR.c,817 :: 		}
L_sky_print172:
;IR.c,818 :: 		}
L_sky_print169:
;IR.c,819 :: 		}
	GOTO        L_sky_print165
L_sky_print166:
;IR.c,821 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,822 :: 		irnowm = 0xff;                                 // init
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,823 :: 		rc6_mode = get_rc6_byte(4);                    // start bit2 '1' + 3 bits mode
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_rc6_mode_L0+0 
;IR.c,824 :: 		rc6_mode &= 0x07;                              // remove start bit '1' to leave 3 bits mode
	MOVLW       7
	ANDWF       R0, 0 
	MOVWF       sky_print_rc6_mode_L0+0 
;IR.c,827 :: 		if (irwas2t){                                  // actually detecting 3t, single toggle bit is double size
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print173
;IR.c,828 :: 		ir_toggle = 1;                             // have found a trailer / toggle bit of 1
	MOVLW       1
	MOVWF       _ir_toggle+0 
;IR.c,829 :: 		irnowm = 0;                                // leave in mark state
	CLRF        _irnowm+0 
;IR.c,830 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,831 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,832 :: 		if(temp_bit_s < 70){
	MOVLW       128
	XORWF       _temp_bit_s+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print269
	MOVLW       70
	SUBWF       _temp_bit_s+0, 0 
L__sky_print269:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print174
;IR.c,833 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,834 :: 		}
L_sky_print174:
;IR.c,835 :: 		}
	GOTO        L_sky_print175
L_sky_print173:
;IR.c,837 :: 		ir_toggle = 0;                             // have found a trailer / toggle bit of 0
	CLRF        _ir_toggle+0 
;IR.c,838 :: 		irnowm = 0;                                // leave in mark state
	CLRF        _irnowm+0 
;IR.c,839 :: 		temp_ir = get_space();                     // skip over the mark
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,840 :: 		temp_ir = get_mark();                      // read the space
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,841 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,842 :: 		if(temp_bit_m < 70){
	MOVLW       128
	XORWF       _temp_bit_m+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print270
	MOVLW       70
	SUBWF       _temp_bit_m+0, 0 
L__sky_print270:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print176
;IR.c,843 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,844 :: 		}
L_sky_print176:
;IR.c,845 :: 		}
L_sky_print175:
;IR.c,847 :: 		if (rc6_mode == 0){
	MOVF        sky_print_rc6_mode_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print177
;IR.c,849 :: 		ir_result[1] = get_rc6_byte(8);               // control byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,850 :: 		ir_result[2] = get_rc6_byte(8);               // information byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,852 :: 		UART1_Write_Text("rc6 mode 0");
	MOVLW       ?lstr78_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr78_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,853 :: 		Lcd_Out(1,1, "RC6 mode 0      ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr79_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr79_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,854 :: 		Lcd_Out(2,1, "t=0 ct=   inf=  ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr80_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr80_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,855 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print178
;IR.c,856 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr81_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr81_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,857 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,858 :: 		}
	GOTO        L_sky_print179
L_sky_print178:
;IR.c,860 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr82_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr82_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,861 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,862 :: 		}
L_sky_print179:
;IR.c,863 :: 		UART1_Write_Text(" ctrl=");
	MOVLW       ?lstr83_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr83_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,864 :: 		hexout(ir_result[1]);                         // 8 bits control byte
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,865 :: 		Lcd_Chr(2,8,keephex[0]);               // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,866 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,867 :: 		UART1_Write_Text(" inf=");
	MOVLW       ?lstr84_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr84_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,868 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,869 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,870 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,871 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sky_print180:
	DECFSZ      R13, 1, 1
	BRA         L_sky_print180
	DECFSZ      R12, 1, 1
	BRA         L_sky_print180
	NOP
;IR.c,872 :: 		}
L_sky_print177:
;IR.c,874 :: 		if (rc6_mode == 6){
	MOVF        sky_print_rc6_mode_L0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print181
;IR.c,876 :: 		ir_result[1] = get_rc6_byte(4);               // first nibble
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,877 :: 		ir_result[2] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,878 :: 		ir_result[3] = get_rc6_byte(7);               // only 7 bits of byte
	MOVLW       7
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,880 :: 		ir_result[3] <<= 1;                           // leave room for last bit
	MOVF        R0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       _ir_result+3 
;IR.c,881 :: 		if (ir_result[3] & 0x02){                     // penultimate bit was 1
	BTFSS       R1, 1 
	GOTO        L_sky_print182
;IR.c,882 :: 		if (!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print183
;IR.c,883 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,884 :: 		}
L_sky_print183:
;IR.c,885 :: 		get_mark();
	CALL        _get_mark+0, 0
;IR.c,886 :: 		}
	GOTO        L_sky_print184
L_sky_print182:
;IR.c,888 :: 		if (irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print185
;IR.c,889 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,890 :: 		}
	GOTO        L_sky_print186
L_sky_print185:
;IR.c,893 :: 		}
L_sky_print186:
;IR.c,894 :: 		}
L_sky_print184:
;IR.c,896 :: 		UART1_Write_Text("RC6 mode 6-20");
	MOVLW       ?lstr85_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr85_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,897 :: 		Lcd_Out(1,1, "RC6 mode6-20 Sky");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr86_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr86_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,898 :: 		Lcd_Out(2,1, "t=0             ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr87_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr87_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,899 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print187
;IR.c,900 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr88_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr88_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,901 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,902 :: 		}
	GOTO        L_sky_print188
L_sky_print187:
;IR.c,904 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr89_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr89_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,905 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,906 :: 		}
L_sky_print188:
;IR.c,907 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr90_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr90_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,908 :: 		hexout(ir_result[1]);                         // 4 bits
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,909 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,910 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,911 :: 		Lcd_Chr(2,10,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,912 :: 		Lcd_Chr(2,11,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,913 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,914 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,915 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,916 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sky_print189:
	DECFSZ      R13, 1, 1
	BRA         L_sky_print189
	DECFSZ      R12, 1, 1
	BRA         L_sky_print189
	NOP
;IR.c,917 :: 		}
L_sky_print181:
;IR.c,918 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr91_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr91_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,919 :: 		}
	GOTO        L_sky_print161
;IR.c,920 :: 		}
L_end_sky_print:
	RETURN      0
; end of _sky_print

_tosh_print:

;IR.c,930 :: 		void tosh_print(void){
;IR.c,934 :: 		UART1_Write_Text("\r\nWaiting for Toshiba IR\r\n");
	MOVLW       ?lstr92_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr92_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,935 :: 		Lcd_Out(1,1, "Toshiba protocol");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr93_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr93_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,936 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr94_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr94_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,938 :: 		while(1){
L_tosh_print190:
;IR.c,939 :: 		while(ir_in);                              // wait for IR to go low
L_tosh_print192:
	BTFSS       RC0_bit+0, 0 
	GOTO        L_tosh_print193
	GOTO        L_tosh_print192
L_tosh_print193:
;IR.c,940 :: 		irnowm = 1;                                // initilise
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,941 :: 		tosh_result[0] = get_tosh_byte(3);         // 3 bit code
	MOVLW       3
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+0 
;IR.c,942 :: 		tosh_result[1] = get_tosh_byte(3);         // 3 bit header
	MOVLW       3
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+1 
;IR.c,943 :: 		tosh_result[2] = get_tosh_byte(6);         // 6 bit data
	MOVLW       6
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+2 
;IR.c,944 :: 		UART1_Write_Text("\r\nToshiba code=");
	MOVLW       ?lstr95_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr95_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,945 :: 		Lcd_Out(2,1, "code=  h=  d=   ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr96_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr96_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,946 :: 		hexout(tosh_result[0]);
	MOVF        tosh_print_tosh_result_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,947 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,948 :: 		UART1_Write_Text(" header=");
	MOVLW       ?lstr97_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr97_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,949 :: 		hexout(tosh_result[1]);
	MOVF        tosh_print_tosh_result_L0+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,950 :: 		Lcd_Chr(2,10,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,951 :: 		UART1_Write_Text(" data=");
	MOVLW       ?lstr98_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr98_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,952 :: 		hexout(tosh_result[2]);
	MOVF        tosh_print_tosh_result_L0+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,953 :: 		Lcd_Chr(2,14,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,954 :: 		Lcd_Chr(2,15,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,955 :: 		Delay_ms(1);             // wait for repeat messages to clear
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_tosh_print194:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_print194
	DECFSZ      R12, 1, 1
	BRA         L_tosh_print194
	NOP
;IR.c,956 :: 		}
	GOTO        L_tosh_print190
;IR.c,958 :: 		}
L_end_tosh_print:
	RETURN      0
; end of _tosh_print

_get_tosh_byte:

;IR.c,962 :: 		unsigned char get_tosh_byte(char nbits){
;IR.c,967 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_tosh_byte_ir_byte_L0+0 
;IR.c,968 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_tosh_byte_n_L0+0 
L_get_tosh_byte195:
	MOVF        FARG_get_tosh_byte_nbits+0, 0 
	SUBWF       get_tosh_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte196
;IR.c,969 :: 		if (irnowm){
	MOVF        _irnowm+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_tosh_byte198
;IR.c,970 :: 		temp_ir = get_space();                // keep looking for long pulse mark or space
	CALL        _get_space+0, 0
;IR.c,971 :: 		irnowm = 0;                           // keep pace
	CLRF        _irnowm+0 
;IR.c,972 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte273
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte273:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte199
;IR.c,973 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,974 :: 		irnowm = 1;                       // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,975 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte274
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte274:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte200
;IR.c,976 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
;IR.c,977 :: 		irnowm = 0;                   // keep pace
	CLRF        _irnowm+0 
;IR.c,978 :: 		}
L_get_tosh_byte200:
;IR.c,979 :: 		}
L_get_tosh_byte199:
;IR.c,980 :: 		}
	GOTO        L_get_tosh_byte201
L_get_tosh_byte198:
;IR.c,982 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,983 :: 		irnowm = 1;                           // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,984 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte275
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte275:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte202
;IR.c,985 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
;IR.c,986 :: 		irnowm = 0;                       // keep pace
	CLRF        _irnowm+0 
;IR.c,987 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte276
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte276:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte203
;IR.c,988 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,989 :: 		irnowm = 1;                   // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,990 :: 		}
L_get_tosh_byte203:
;IR.c,991 :: 		}
L_get_tosh_byte202:
;IR.c,993 :: 		}
L_get_tosh_byte201:
;IR.c,996 :: 		ir_byte <<= 1;                            // shift in a zero
	RLCF        get_tosh_byte_ir_byte_L0+0, 1 
	BCF         get_tosh_byte_ir_byte_L0+0, 0 
;IR.c,997 :: 		if (irnowm){
	MOVF        _irnowm+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_tosh_byte204
;IR.c,998 :: 		ir_byte += 0x01;                      // change to a 1
	INCF        get_tosh_byte_ir_byte_L0+0, 1 
;IR.c,999 :: 		}
L_get_tosh_byte204:
;IR.c,968 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_tosh_byte_n_L0+0, 1 
;IR.c,1000 :: 		}
	GOTO        L_get_tosh_byte195
L_get_tosh_byte196:
;IR.c,1001 :: 		return ir_byte;
	MOVF        get_tosh_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,1002 :: 		}
L_end_get_tosh_byte:
	RETURN      0
; end of _get_tosh_byte
