#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
#line 15 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
sbit ir_in at RA3_bit;
sbit ir_in_direction at TRISA3_bit;


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;


sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;





char fb_string[10];
char irnowm;
char irwas2t;
char irbyte;
char cmd;
unsigned int cnt;
unsigned int retint;
signed int temp_bit_s;
signed int temp_bit_m;
char keephex[3];
unsigned char ir_byte;
char ir_toggle;
unsigned char ir_result[11];
char mmc_zeros;


void timing_print(void);
void print_ir_time(unsigned int ir_time);
void sharp_print(void);
void sam_print(void);
void sony_print(void);
int get_mark(void);
int get_space(void);
unsigned char get_sharp_byte(char nbits);
unsigned char get_sam_byte(void);
unsigned char get_sony_byte(char nbits);
unsigned char get_rc5_byte(char nbits);
unsigned char get_rc6_byte(char nbits);
unsigned char get_tosh_byte(char nbits);
void getrc5bit(void);
void getrc6bit(void);
void nec_print(void);
unsigned char get_nec_byte(void);
void rc5_print(void);
void rc6_print(void);
void sky_print(void);
void tosh_print(void);
void mmc_print(void);
void simple_ir(void);
char get_cmd(void);
void mmc_header(void);
unsigned char get_mmc_byte(char ndbits);
char get_mmc_bit();
void get_quiet(void);

void interrupt() {
 if (TMR0IF_bit) {
 cnt++;
 TMR0IF_bit = 0;
 }


 if (INT0F_bit){
 INT0F_bit = 0;
 if (INTEDG0_bit){
 INTEDG0_bit = 0;
 }
 else{
 INTEDG0_bit = 1;
 }
 }
}


void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ADCON0 = 0;
 ADCON1 = 0x0f;

 CM1CON0 = 0;
 CM2CON0 = 0;
 T0CON = 0x86;
 TMR0L = 96;
 TMR0H = 0xff;
 INTCON = 0xB0;
 cnt = 0;

 LATA = 0;
 LATB = 0x80;
 LATD = 0;
 LATC = 0;
 LATE = 0;
 TRISA = 0xC1;
 TRISB = 0x81;
 TRISC = 0x01;
 TRISD = 0xff;
 TRISE = 0;
 PWM1_Init(38000);
 PWM1_Start;
 PWM1_Set_Duty(80);
 PWM2_Init(38000);
 PWM2_Start;
 PWM2_Set_Duty(80);
 ir_in_direction = 1;
 UART1_Init(2400);
 Delay_ms(100);
 UART1_Write_Text("\r\n\nIR Utilities\r\n\n");

 Delay_ms(1000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 while(1){
 Lcd_Out(1,1, "0LED 1Sa 2T 3NEC");
 Lcd_Out(2,1, "4Sony 5RC5 6RC6 ");

 UART1_Write_Text("0 Simple IR test\r\n");
 UART1_Write_Text("1 Samsung Rx\r\n");
 UART1_Write_Text("2 PT2248/9 Rx\r\n");
 UART1_Write_Text("3 NEC  Rx\r\n");
 UART1_Write_Text("4 Sony Rx\r\n");
 UART1_Write_Text("5 RC5  Rx\r\n");
 UART1_Write_Text("6 RC6 m0, RC6 m6-32, MCE \r\n");
 UART1_Write_Text("7 RC6 mode 6-20 (Sky)\r\n");
 UART1_Write_Text("8 Sharp Rx (beta)\r\n");
 UART1_Write_Text("9 Timing print\r\n");
 UART1_Write_Text("m MMC print\r\n");

 cmd = get_cmd();
 switch (cmd){
 case '0': simple_ir(); break;
 case '1': sam_print(); break;
 case '2': tosh_print(); break;
 case '3': nec_print(); break;
 case '4': sony_print(); break;
 case '5': rc5_print(); break;
 case '6': rc6_print(); break;
 case '7': sky_print(); break;
 case '8': sharp_print(); break;
 case '9': timing_print(); break;
 case 'm': mmc_print(); break;
 default: break;
 }

 }
 while(1);
}



void p_wait(void){
 UART1_Write_Text("Waiting for IR\r\n");
}


char get_cmd(void){
char retval;

 retval = 0;
 while(!retval){
 if (UART1_Data_Ready()){
 retval = UART1_Read();
 }

 if(PORTD == 0x01) retval='0';
 if(PORTD == 0x02) retval='1';
 if(PORTD == 0x04) retval='2';
 if(PORTD == 0x08) retval='3';
 if(PORTD == 0x10) retval='4';
 if(PORTD == 0x20) retval='5';
 if(PORTD == 0x40) retval='6';
 if(PORTD == 0x80) retval='7';
 }
 return retval;
}

void simple_ir(void){
 UART1_Write_Text("\r\nwatch LED on RE0\r\n");
 Lcd_Out(1,1, " Simple IR test ");
 Lcd_Out(2,1, "watch LED on RE0");
 while(1){
 if(ir_in){
 LATE0_bit = 0;
 }
 else{
 LATE0_bit = 1;
 }
 }
}


void timing_print(void){
unsigned char ir_bit;
unsigned int ir_mark[ 30 +2];
unsigned int ir_space[ 30 +2];

 UART1_Write_Text("\r\nTiming print\r\n");
 p_wait();
 Lcd_Out(1,1, "timing to RS232 ");
 Lcd_Out(2,1, "  9600 8 n 1    ");
 while(ir_in);

 for( ir_bit=0 ; ir_bit<( 30 +1) ; ir_bit++){
 TMR0H = 0;
 TMR0L = 0;
 while(!ir_in);
 ir_mark[ir_bit] = TMR0L;
 ir_mark[ir_bit] +=(TMR0H<<8);
 TMR0H = 0;
 TMR0L = 0;
 while(ir_in);
 ir_space[ir_bit] = TMR0L;
 ir_space[ir_bit] += (TMR0H<<8);
 }

 for( ir_bit=0 ; ir_bit<( 30 +1) ; ir_bit++){
 IntToStr(ir_bit,fb_string);
 UART1_Write_Text("\r\nbit");
 UART1_Write_Text(fb_string);
 IntToStr(ir_mark[ir_bit],fb_string);
 UART1_Write_Text("   mark");
 UART1_Write_Text(fb_string);
 IntToStr(ir_space[ir_bit],fb_string);
 UART1_Write_Text("    space");
 UART1_Write_Text(fb_string);

 UART1_Write_Text("   (");
 print_ir_time(ir_mark[ir_bit]);
 print_ir_time(ir_space[ir_bit]);
 UART1_Write_Text(" uS)");

 }
 UART1_Write_Text("\r\n\ndone\r\n");
}



void print_ir_time(unsigned int ir_time){
unsigned long time_ul;
unsigned int time_ui;

 time_ul = ir_time;
 time_ul *= 65UL;
 time_ul /= 4UL;
 time_ui = time_ul;
 IntToStr(time_ui,fb_string);
 UART1_Write_Text(fb_string);
}


void hexout(unsigned char hexval){
int temp_hex;
char hextxt[7];

 temp_hex = hexval;
 IntToHex(temp_hex, hextxt);
 UART1_Write_Text(hextxt+2);
 UART1_Write_Text(" ");
 keephex[0] = hextxt[2];
 keephex[1] = hextxt[3];
 keephex[2] = 0;
}
#line 306 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
void nec_print(void){
signed int temp_ir;
char count_byte;

 p_wait();
 Lcd_Out(1,1, "NEC protocol IR ");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);

 temp_ir = get_mark();
 if ((temp_ir > 500) && (temp_ir < 800)){
 temp_ir = get_space();
 if ((temp_ir > 200) && (temp_ir < 400)){
 for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
 ir_result[count_byte] = get_nec_byte();
 }
 }
 UART1_Write_Text("\r\nNEC ");
 Lcd_Out(2,1, "NEC            ");
 for(count_byte = 0 ; count_byte < 4 ; count_byte++){
 hexout(ir_result[count_byte]);
 Lcd_Chr(2,(count_byte * 3)+5,keephex[0]);
 Lcd_Chr(2,(count_byte * 3)+6,keephex[1]);
 }
 Delay_ms(10);
 }
 }
 UART1_Write_Text("\r\n");
}


unsigned char get_nec_byte(void){
char n;
unsigned char ir_byte;
signed int temp_ir;

 for(n=0 ; n<8 ; n++){
 temp_ir = get_mark();
 temp_ir = get_space();
 ir_byte >>= 1;
 if (temp_ir > 70){
 ir_byte += 0x80;
 }
 }
 return ir_byte;
}


int get_mark(void){
 TMR0H = 0;
 TMR0L = 0;
 while(!ir_in);
 LATE.F0 = 0;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}


int get_space(void){
 TMR0H = 0;
 TMR0L = 0;
 while(ir_in);
 LATE.F0 = 1;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}


void get_quiet(void){
char quiet_flag;

 quiet_flag = 1;
 TMR0H = 0;
 TMR0L = 0;
 while(quiet_flag){
 retint = TMR0L;
 retint += (TMR0H<<8);
 if (retint > 0x4000){
 quiet_flag = 0;
 }
 }
}
#line 403 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
void sharp_print(void)
{
signed int temp_ir;

 p_wait();
 Lcd_Out(1,1, "Sharp protocol  ");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);

 ir_result[0] = get_sharp_byte(5);
 ir_result[1] = get_sharp_byte(8);
 ir_result[2] = get_sharp_byte(2);
 ir_result[3] = get_sharp_byte(1);
 if(ir_result[2]==1){
 UART1_Write_Text("   add=");
 Lcd_Out(2,1, "add=   cmd=     ");
 hexout(ir_result[0]);
 Lcd_Chr(2,5,keephex[0]);
 Lcd_Chr(2,6,keephex[1]);
 UART1_Write_Text(" cmd=");
 hexout(ir_result[1]);
 Lcd_Chr(2,12,keephex[0]);
 Lcd_Chr(2,13,keephex[1]);
 UART1_Write_Text("\r\n");
 }
 Delay_ms(400);
 }
}


unsigned char get_sharp_byte(char nbits){
char n;
unsigned char ir_byte;
signed int temp_ir;

 ir_byte = 0;
 for(n=0 ; n<nbits ; n++){
 temp_ir = get_mark();
 temp_ir = get_space();
 ir_byte >>= 1;
 if (temp_ir > 70){
 ir_byte += 0x80;
 }
 }
 ir_byte >>= 8-nbits;
 return ir_byte;
}
#line 475 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
void sony_print(void){
signed int temp_ir;

 p_wait();
 Lcd_Out(1,1, "Sony protocol   ");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);

 temp_ir = get_mark();
 if ((temp_ir > 150) && (temp_ir < 200)){
 ir_result[0] = get_sony_byte(7);
 ir_result[1] = get_sony_byte(5);
 UART1_Write_Text("\r\nSony cmd=");
 Lcd_Out(2,1, "cmd=   addr=    ");
 hexout(ir_result[0]);
 Lcd_Chr(2,5,keephex[0]);
 Lcd_Chr(2,6,keephex[1]);
 UART1_Write_Text(" addr=");
 hexout(ir_result[1]);
 Lcd_Chr(2,13,keephex[0]);
 Lcd_Chr(2,14,keephex[1]);
 Delay_ms(10);
 }
 }
 UART1_Write_Text("\r\n");
}


unsigned char get_sony_byte(char nbits){
char n;
unsigned char ir_byte;
signed int temp_ir;

 ir_byte = 0;
 for(n=0 ; n<nbits ; n++){
 temp_ir = get_space();
 temp_ir = get_mark();
 ir_byte >>= 1;
 if (temp_ir > 60){
 ir_byte += 0x80;
 }
 }
 ir_byte >>= 8-nbits;
 return ir_byte;
}









void sam_print(void){
signed int temp_ir;

 p_wait();
 Lcd_Out(1,1, "Samsung protocol");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);

 temp_ir = get_mark();
 ir_result[4] = get_space();
 if ((temp_ir > 200) && (temp_ir < 350)){
 ir_result[0] = get_sam_byte();
 ir_result[1] = get_sam_byte();
 ir_result[2] = get_sam_byte();
 ir_result[3] = get_sam_byte();
 UART1_Write_Text("\r\nSam ");
 Lcd_Out(2,1, "c   c   d   d~  ");
 hexout(ir_result[0]);
 Lcd_Chr(2,2,keephex[0]);
 Lcd_Chr(2,3,keephex[1]);
 hexout(ir_result[1]);
 Lcd_Chr(2,6,keephex[0]);
 Lcd_Chr(2,7,keephex[1]);
 hexout(ir_result[2]);
 Lcd_Chr(2,10,keephex[0]);
 Lcd_Chr(2,11,keephex[1]);
 hexout(ir_result[3]);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);
 Delay_ms(10);
 }
 }
 UART1_Write_Text("\r\n");
}


unsigned char get_sam_byte(void){
char n;
unsigned char ir_byte;
signed int temp_ir;

 ir_byte = 0;
 for(n=0 ; n<8 ; n++){
 temp_ir = get_mark();
 temp_ir = get_space();
 ir_byte >>= 1;
 if (temp_ir > 60){
 ir_byte += 0x80;
 }
 }
 return ir_byte;
}









void rc5_print(void){
signed int temp_ir;
unsigned char rc5_byte1;
unsigned char rc5_byte2;

 p_wait();
 Lcd_Out(1,1, "RC5 protocol IR ");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);

 irwas2t = 0;
 irnowm = 0;
 temp_ir = get_mark();
 if ((temp_ir > 40) && (temp_ir < 80)){
 rc5_byte1 = get_rc5_byte(7);
 rc5_byte2 = get_rc5_byte(6);
 UART1_Write_Text("\r\nrc5");
 Lcd_Out(2,1, "t=0 ad=   cmd=  ");
 if (rc5_byte1 & 0x20){
 UART1_Write_Text(" t=1");
 Lcd_Chr(2,3,'1');
 }
 else{
 UART1_Write_Text(" t=0");
 Lcd_Chr(2,3,'0');
 }
 UART1_Write_Text(" addr=");
 hexout(rc5_byte1 & 0x1F);
 Lcd_Chr(2,8,keephex[0]);
 Lcd_Chr(2,9,keephex[1]);
 UART1_Write_Text(" cmd=");
 hexout(rc5_byte2);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);
 Delay_ms(100);
 }
 }
 UART1_Write_Text("\r\n");
}


unsigned char get_rc5_byte(char nbits){
char n;

 irbyte = 0;
 for(n = 0 ; n < nbits ; n++){
 getrc5bit();
 }
 return irbyte;
}


void getrc5bit(void){

 if(!irnowm){

 if(!irwas2t){

 irnowm = 0;
 temp_bit_s = get_space();
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 80) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 else{

 irnowm = 0xff;
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 80) irwas2t = 0;
 irbyte <<= 1;
 }
 }
 else{

 if(!irwas2t){

 irnowm = 0xff;
 temp_bit_m = get_mark();
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 80) irwas2t = 0;
 irbyte <<= 1;
 }
 else{

 irnowm = 0;
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 80) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 }
}
#line 705 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IR/IR.c"
void rc6_print(void){
signed int temp_ir;
unsigned char rc6_mode;
char leader6;

 p_wait();
 Lcd_Out(1,1, "RC6m0, RC6m6-32 ");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);


 leader6 = 0;

 while(!leader6){
 temp_ir = get_mark();
 if ((temp_ir > 140) && (temp_ir < 200)){
 temp_ir = get_space();
 if ((temp_ir > 40) && (temp_ir < 60)){
 leader6 = 1;
 }
 }
 }

 irwas2t = 0;
 irnowm = 0xff;
 rc6_mode = get_rc6_byte(4);
 rc6_mode &= 0x07;


 if (irwas2t){
 ir_toggle = 1;
 irnowm = 0;
 temp_ir = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 70){
 irwas2t = 0;
 }
 }
 else{
 ir_toggle = 0;
 irnowm = 0xff;
 temp_ir = get_space();
 temp_ir = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 70){
 irwas2t = 0;
 }
 }

 if (rc6_mode == 0){

 ir_result[1] = get_rc6_byte(8);
 ir_result[2] = get_rc6_byte(8);

 UART1_Write_Text("rc6 mode 0");
 Lcd_Out(1,1, "RC6 mode 0      ");
 Lcd_Out(2,1, "t=0 ct=   inf=  ");
 if (ir_toggle){
 UART1_Write_Text(" t=1");
 Lcd_Chr(2,3,'1');
 }
 else{
 UART1_Write_Text(" t=0");
 Lcd_Chr(2,3,'0');
 }
 UART1_Write_Text(" ctrl=");
 hexout(ir_result[1]);
 Lcd_Chr(2,8,keephex[0]);
 Lcd_Chr(2,9,keephex[1]);
 UART1_Write_Text(" inf=");
 hexout(ir_result[2]);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);
 Delay_ms(10);
 }

 if (rc6_mode == 6){

 ir_result[1] = get_rc6_byte(8);
 ir_result[2] = get_rc6_byte(8);
 ir_result[3] = get_rc6_byte(8);
 ir_result[4] = get_rc6_byte(7);

 ir_result[4] <<= 1;
 if (ir_result[4] & 0x02){
 if (!irwas2t){
 ir_result[4]++;
 }
 get_mark();
 }
 else{
 if (irwas2t){
 ir_result[4]++;
 }
 else{
 get_mark;
 }
 }

 UART1_Write_Text("rc6 mode 6-32 and MCE");
 Lcd_Out(1,1, "RC6 m6-32 (&MCE)");
 Lcd_Out(2,1, "t=0             ");
 if (ir_toggle){
 UART1_Write_Text(" t=1");
 Lcd_Chr(2,3,'1');
 }
 else{
 UART1_Write_Text(" t=0");
 Lcd_Chr(2,3,'0');
 }
 UART1_Write_Text(" ");
 hexout(ir_result[1]);
 Lcd_Chr(2,8,keephex[0]);
 Lcd_Chr(2,9,keephex[1]);
 hexout(ir_result[2]);
 Lcd_Chr(2,10,keephex[0]);
 Lcd_Chr(2,11,keephex[1]);
 hexout(ir_result[3]);
 Lcd_Chr(2,12,keephex[0]);
 Lcd_Chr(2,13,keephex[1]);
 hexout(ir_result[4]);
 Lcd_Chr(2,14,keephex[0]);
 Lcd_Chr(2,15,keephex[1]);
 Delay_ms(10);
 }
 UART1_Write_Text("\r\n");
 }
}


unsigned char get_rc6_byte(char nbits){
char n;

 irbyte = 0;
 for(n = 0 ; n < nbits ; n++){
 getrc6bit();
 }
 return irbyte;
}


void getrc6bit(void){

 if(!irnowm){

 if(!irwas2t){

 irnowm = 0;
 temp_bit_s = get_space();
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 40) irwas2t = 0;
 irbyte <<= 1;
 }
 else{

 irnowm = 0xff;
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 40) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 }
 else{

 if(!irwas2t){

 irnowm = 0xff;
 temp_bit_m = get_mark();
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 40) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 else{

 irnowm = 0;
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 40) irwas2t = 0;
 irbyte <<= 1;
 }
 }
}


void sky_print(void){
signed int temp_ir;
unsigned char rc6_mode;
char leader6;

 p_wait();
 Lcd_Out(1,1, "RC6 mode6-20 Sky");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);


 leader6 = 0;

 while(!leader6){
 temp_ir = get_mark();
 if ((temp_ir > 140) && (temp_ir < 200)){
 temp_ir = get_space();
 if ((temp_ir > 40) && (temp_ir < 60)){
 leader6 = 1;
 }
 }
 }

 irwas2t = 0;
 irnowm = 0xff;
 rc6_mode = get_rc6_byte(4);
 rc6_mode &= 0x07;


 if (irwas2t){
 ir_toggle = 1;
 irnowm = 0;
 temp_ir = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 70){
 irwas2t = 0;
 }
 }
 else{
 ir_toggle = 0;
 irnowm = 0;
 temp_ir = get_space();
 temp_ir = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 70){
 irwas2t = 0;
 }
 }

 if (rc6_mode == 0){

 ir_result[1] = get_rc6_byte(8);
 ir_result[2] = get_rc6_byte(8);

 UART1_Write_Text("rc6 mode 0");
 Lcd_Out(1,1, "RC6 mode 0      ");
 Lcd_Out(2,1, "t=0 ct=   inf=  ");
 if (ir_toggle){
 UART1_Write_Text(" t=1");
 Lcd_Chr(2,3,'1');
 }
 else{
 UART1_Write_Text(" t=0");
 Lcd_Chr(2,3,'0');
 }
 UART1_Write_Text(" ctrl=");
 hexout(ir_result[1]);
 Lcd_Chr(2,8,keephex[0]);
 Lcd_Chr(2,9,keephex[1]);
 UART1_Write_Text(" inf=");
 hexout(ir_result[2]);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);
 Delay_ms(10);
 }

 if (rc6_mode == 6){

 ir_result[1] = get_rc6_byte(4);
 ir_result[2] = get_rc6_byte(8);
 ir_result[3] = get_rc6_byte(7);

 ir_result[3] <<= 1;
 if (ir_result[3] & 0x02){
 if (!irwas2t){
 ir_result[3]++;
 }
 get_mark();
 }
 else{
 if (irwas2t){
 ir_result[3]++;
 }
 else{
 get_mark;
 }
 }

 UART1_Write_Text("RC6 mode 6-20");
 Lcd_Out(1,1, "RC6 mode6-20 Sky");
 Lcd_Out(2,1, "t=0             ");
 if (ir_toggle){
 UART1_Write_Text(" t=1");
 Lcd_Chr(2,3,'1');
 }
 else{
 UART1_Write_Text(" t=0");
 Lcd_Chr(2,3,'0');
 }
 UART1_Write_Text(" ");
 hexout(ir_result[1]);
 Lcd_Chr(2,9,keephex[1]);
 hexout(ir_result[2]);
 Lcd_Chr(2,10,keephex[0]);
 Lcd_Chr(2,11,keephex[1]);
 hexout(ir_result[3]);
 Lcd_Chr(2,12,keephex[0]);
 Lcd_Chr(2,13,keephex[1]);
 Delay_ms(10);
 }
 UART1_Write_Text("\r\n");
 }
}









void tosh_print(void){
signed int temp_ir;
unsigned char tosh_result[4];

 p_wait();
 Lcd_Out(1,1, "Toshiba protocol");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 while(ir_in);
 irnowm = 1;
 tosh_result[0] = get_tosh_byte(3);
 tosh_result[1] = get_tosh_byte(3);
 tosh_result[2] = get_tosh_byte(6);
 UART1_Write_Text("\r\nToshiba code=");
 Lcd_Out(2,1, "code=  h=  d=   ");
 hexout(tosh_result[0]);
 Lcd_Chr(2,6,keephex[1]);
 UART1_Write_Text(" header=");
 hexout(tosh_result[1]);
 Lcd_Chr(2,10,keephex[1]);
 UART1_Write_Text(" data=");
 hexout(tosh_result[2]);
 Lcd_Chr(2,14,keephex[0]);
 Lcd_Chr(2,15,keephex[1]);
 Delay_ms(1);
 }
 UART1_Write_Text("\r\n");
}



unsigned char get_tosh_byte(char nbits){
char n;
unsigned char ir_byte;
signed int temp_ir;

 ir_byte = 0;
 for(n=0 ; n<nbits ; n++){
 if (irnowm){
 temp_ir = get_space();
 irnowm = 0;
 if (temp_ir < 60) {
 temp_ir = get_mark();
 irnowm = 1;
 if (temp_ir < 60) {
 temp_ir = get_space();
 irnowm = 0;
 }
 }
 }
 else{
 temp_ir = get_mark();
 irnowm = 1;
 if (temp_ir < 60) {
 temp_ir = get_space();
 irnowm = 0;
 if (temp_ir < 60) {
 temp_ir = get_mark();
 irnowm = 1;
 }
 }

 }


 ir_byte <<= 1;
 if (irnowm){
 ir_byte += 0x01;
 }
 }
 return ir_byte;
}



void mmc_print(void){
char quiet_gap;
int temp_ir;

 p_wait();
 Lcd_Out(1,1, "BTC kbd protocol");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 get_quiet();
 mmc_header();
 ir_result[0] = get_mmc_byte(3);
 ir_result[1] = get_mmc_byte(8);
 ir_result[2] = get_mmc_byte(8);
 mmc_header();
 ir_result[3] = get_mmc_byte(3);
 ir_result[4] = get_mmc_byte(8);
 ir_result[5] = get_mmc_byte(8);
 UART1_Write_Text("\r\nmmc= ");
 Lcd_Out(2,1, "                ");
 hexout(ir_result[0]);
 Lcd_Chr(2,1,keephex[1]);
 hexout(ir_result[1]);
 Lcd_Chr(2,3,keephex[0]);
 Lcd_Chr(2,4,keephex[1]);
 hexout(ir_result[2]);
 Lcd_Chr(2,6,keephex[0]);
 Lcd_Chr(2,7,keephex[1]);

 UART1_Write_Text("- ");
 hexout(ir_result[3]);
 Lcd_Chr(2,10,keephex[1]);
 hexout(ir_result[4]);
 Lcd_Chr(2,12,keephex[0]);
 Lcd_Chr(2,13,keephex[1]);
 hexout(ir_result[5]);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);

 Delay_ms(1);
 }

}

void mmc_header(void){
char leader_m;
signed int temp_ir;


 leader_m = 0;

 while(!leader_m){
 temp_ir = get_mark();
 if ((temp_ir > 60) && (temp_ir < 90)){
 temp_ir = get_space();
 if ((temp_ir > 50) && (temp_ir < 90)){
 leader_m = 1;
 }
 }
 }
 mmc_zeros = 0;
}

unsigned char get_mmc_byte(char ndbits){
char n;
unsigned char ir_byte;
unsigned char temp_ir;

 ir_byte = 0;
 for(n = 0 ; n < ndbits ; n++){
 temp_ir = get_mmc_bit();
 ir_byte <<= 1;
 if (temp_ir == 1){
 ir_byte |= 1;
 }
 }
 return ir_byte;
}

char get_mmc_bit(){
int temp_ir;
unsigned char retval;

 if(mmc_zeros){
 retval = 0;
 mmc_zeros--;
 }
 else{
 mmc_zeros = 0;
 temp_ir = get_mark();
 temp_ir = get_space();
 if ((temp_ir > 10) && (temp_ir < 45)){
 retval = 1;
 }
 if ((temp_ir > 45) && (temp_ir < 90)){
 retval = 1;
 mmc_zeros = 1;
 }
 if ((temp_ir > 90) && (temp_ir < 140)){
 retval = 1;
 mmc_zeros = 2;
 }
 if ((temp_ir > 140) && (temp_ir < 200)){
 retval = 1;
 mmc_zeros = 3;
 }
 if ((temp_ir > 200) && (temp_ir < 250)){
 retval = 1;
 mmc_zeros = 4;
 }
 if (temp_ir > 250) {
 retval = 1;
 mmc_zeros = 4;
 }
 }
 return retval;
}
