
_interrupt:
	MOVWF      R15+0
	SWAPF      STATUS+0, 0
	CLRF       STATUS+0
	MOVWF      ___saveSTATUS+0
	MOVF       PCLATH+0, 0
	MOVWF      ___savePCLATH+0
	CLRF       PCLATH+0

;IR683sony.c,26 :: 		void interrupt() {
;IR683sony.c,28 :: 		if (INTCON.T0IF) {
	BTFSS      INTCON+0, 2
	GOTO       L_interrupt0
;IR683sony.c,29 :: 		counter++;                    // increment counter
	INCF       _counter+0, 1
;IR683sony.c,30 :: 		INTCON.T0IF = 0;                 // Clear Timer0 overflow interrupt flag
	BCF        INTCON+0, 2
;IR683sony.c,31 :: 		}
L_interrupt0:
;IR683sony.c,32 :: 		}
L_end_interrupt:
L__interrupt28:
	MOVF       ___savePCLATH+0, 0
	MOVWF      PCLATH+0
	SWAPF      ___saveSTATUS+0, 0
	MOVWF      STATUS+0
	SWAPF      R15+0, 1
	SWAPF      R15+0, 0
	RETFIE
; end of _interrupt

_main:

;IR683sony.c,34 :: 		void main() {
;IR683sony.c,36 :: 		CMCON0 = 7;                   // disable comparator
	MOVLW      7
	MOVWF      CMCON0+0
;IR683sony.c,37 :: 		ANSEL = 0;                    // disable analogue
	CLRF       ANSEL+0
;IR683sony.c,38 :: 		OSCCON = 0x71;                // 8MHz internal clock
	MOVLW      113
	MOVWF      OSCCON+0
;IR683sony.c,39 :: 		OPTION_REG = 0x04;            // TMR0 prescaler set to 1:32
	MOVLW      4
	MOVWF      OPTION_REG+0
;IR683sony.c,40 :: 		TRISIO = 0x01;                // IR b0 = input, rest output
	MOVLW      1
	MOVWF      TRISIO+0
;IR683sony.c,41 :: 		GPIO = 0;                     // all outputs off
	CLRF       GPIO+0
;IR683sony.c,45 :: 		INTCON.GIE = 1;               // Global interrupt enable
	BSF        INTCON+0, 7
;IR683sony.c,46 :: 		INTCON.T0IE = 1;              // Enable Timer0 overflow interrupt
	BSF        INTCON+0, 5
;IR683sony.c,48 :: 		while(1){
L_main1:
;IR683sony.c,49 :: 		ir_command = 0;                                        // initialise to prevent false trigger
	CLRF       _ir_command+0
;IR683sony.c,50 :: 		ir_address = 0;                                        // initialise to prevent false trigger
	CLRF       _ir_address+0
;IR683sony.c,51 :: 		get_mark_time();                                       // get Sony leader - 2.4mS Mark, 1.2mS space
	CALL       _get_mark_time+0
;IR683sony.c,52 :: 		if ((mark_time > 0x80) && (mark_time < 0xB0)){         // ignore anything but 2.4mS mark
	MOVF       _mark_time+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main30
	MOVF       _mark_time+0, 0
	SUBLW      128
L__main30:
	BTFSC      STATUS+0, 0
	GOTO       L_main5
	MOVLW      0
	SUBWF      _mark_time+1, 0
	BTFSS      STATUS+0, 2
	GOTO       L__main31
	MOVLW      176
	SUBWF      _mark_time+0, 0
L__main31:
	BTFSC      STATUS+0, 0
	GOTO       L_main5
L__main26:
;IR683sony.c,54 :: 		for(bitcount = 0 ; bitcount < 7 ; bitcount++){    // 7 bit command
	CLRF       _bitcount+0
L_main6:
	MOVLW      7
	SUBWF      _bitcount+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main7
;IR683sony.c,55 :: 		get_mark_time();                               // get a Sony IR bit
	CALL       _get_mark_time+0
;IR683sony.c,56 :: 		ir_command >>= 1;                              // shift
	RRF        _ir_command+0, 1
	BCF        _ir_command+0, 7
;IR683sony.c,57 :: 		ir_command &= 0x7f;                            // top bit zero
	MOVLW      127
	ANDWF      _ir_command+0, 1
;IR683sony.c,58 :: 		if (mark_time > 0x40){                         // > 40 is assumed to be a 1
	MOVF       _mark_time+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main32
	MOVF       _mark_time+0, 0
	SUBLW      64
L__main32:
	BTFSC      STATUS+0, 0
	GOTO       L_main9
;IR683sony.c,59 :: 		ir_command ^= 0x80;                        // top bit 1
	MOVLW      128
	XORWF      _ir_command+0, 1
;IR683sony.c,60 :: 		}
L_main9:
;IR683sony.c,54 :: 		for(bitcount = 0 ; bitcount < 7 ; bitcount++){    // 7 bit command
	INCF       _bitcount+0, 1
;IR683sony.c,61 :: 		}
	GOTO       L_main6
L_main7:
;IR683sony.c,62 :: 		ir_command >>= 1;                                  // shift 1 unused bit
	RRF        _ir_command+0, 1
	BCF        _ir_command+0, 7
;IR683sony.c,63 :: 		ir_command &= 0x7F;                                // clear top bit
	MOVLW      127
	ANDWF      _ir_command+0, 1
;IR683sony.c,65 :: 		for(bitcount = 0 ; bitcount < 5 ; bitcount++){     // 5 bit address
	CLRF       _bitcount+0
L_main10:
	MOVLW      5
	SUBWF      _bitcount+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main11
;IR683sony.c,66 :: 		get_mark_time();                               // get a Sony IR bit
	CALL       _get_mark_time+0
;IR683sony.c,67 :: 		ir_address >>= 1;                              // shift
	RRF        _ir_address+0, 1
	BCF        _ir_address+0, 7
;IR683sony.c,68 :: 		ir_address &= 0x7f;                            // top bit zero
	MOVLW      127
	ANDWF      _ir_address+0, 1
;IR683sony.c,69 :: 		if (mark_time > 0x40){
	MOVF       _mark_time+1, 0
	SUBLW      0
	BTFSS      STATUS+0, 2
	GOTO       L__main33
	MOVF       _mark_time+0, 0
	SUBLW      64
L__main33:
	BTFSC      STATUS+0, 0
	GOTO       L_main13
;IR683sony.c,70 :: 		ir_address ^= 0x80;                        // top bit 1
	MOVLW      128
	XORWF      _ir_address+0, 1
;IR683sony.c,71 :: 		}
L_main13:
;IR683sony.c,65 :: 		for(bitcount = 0 ; bitcount < 5 ; bitcount++){     // 5 bit address
	INCF       _bitcount+0, 1
;IR683sony.c,72 :: 		}
	GOTO       L_main10
L_main11:
;IR683sony.c,73 :: 		ir_address >>= 3;                                  // shift 3 unused bits
	RRF        _ir_address+0, 1
	BCF        _ir_address+0, 7
	RRF        _ir_address+0, 1
	BCF        _ir_address+0, 7
	RRF        _ir_address+0, 1
	BCF        _ir_address+0, 7
;IR683sony.c,74 :: 		ir_address &= 0x1F;                                // clear top 3 bits
	MOVLW      31
	ANDWF      _ir_address+0, 1
;IR683sony.c,76 :: 		}
L_main5:
;IR683sony.c,78 :: 		if(ir_address == 1){                                   // TV
	MOVF       _ir_address+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main14
;IR683sony.c,79 :: 		if(ir_command == 0){                               // button 1
	MOVF       _ir_command+0, 0
	XORLW      0
	BTFSS      STATUS+0, 2
	GOTO       L_main15
;IR683sony.c,80 :: 		shadow ^= 0x02;                                // toggle output 1
	MOVLW      2
	XORWF      _shadow+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _shadow+0
;IR683sony.c,81 :: 		GPIO = shadow;
	MOVF       R0+0, 0
	MOVWF      GPIO+0
;IR683sony.c,82 :: 		}
L_main15:
;IR683sony.c,83 :: 		if(ir_command == 1){                               // button 2
	MOVF       _ir_command+0, 0
	XORLW      1
	BTFSS      STATUS+0, 2
	GOTO       L_main16
;IR683sony.c,84 :: 		shadow ^= 0x04;                                // toggle output 2
	MOVLW      4
	XORWF      _shadow+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _shadow+0
;IR683sony.c,85 :: 		GPIO = shadow;
	MOVF       R0+0, 0
	MOVWF      GPIO+0
;IR683sony.c,86 :: 		}
L_main16:
;IR683sony.c,87 :: 		if(ir_command == 2){                               // button 3
	MOVF       _ir_command+0, 0
	XORLW      2
	BTFSS      STATUS+0, 2
	GOTO       L_main17
;IR683sony.c,88 :: 		shadow ^= 0x10;                                // toggle output 4
	MOVLW      16
	XORWF      _shadow+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _shadow+0
;IR683sony.c,89 :: 		GPIO = shadow;
	MOVF       R0+0, 0
	MOVWF      GPIO+0
;IR683sony.c,90 :: 		}
L_main17:
;IR683sony.c,91 :: 		if(ir_command == 3){                               // button 4
	MOVF       _ir_command+0, 0
	XORLW      3
	BTFSS      STATUS+0, 2
	GOTO       L_main18
;IR683sony.c,92 :: 		shadow ^= 0x20;                                // toggle output 5
	MOVLW      32
	XORWF      _shadow+0, 0
	MOVWF      R0+0
	MOVF       R0+0, 0
	MOVWF      _shadow+0
;IR683sony.c,93 :: 		GPIO = shadow;
	MOVF       R0+0, 0
	MOVWF      GPIO+0
;IR683sony.c,94 :: 		}
L_main18:
;IR683sony.c,95 :: 		if(ir_command == 8){                               // button 9
	MOVF       _ir_command+0, 0
	XORLW      8
	BTFSS      STATUS+0, 2
	GOTO       L_main19
;IR683sony.c,96 :: 		shadow = 0x36;                                 // all outputs on
	MOVLW      54
	MOVWF      _shadow+0
;IR683sony.c,97 :: 		GPIO = shadow;
	MOVLW      54
	MOVWF      GPIO+0
;IR683sony.c,98 :: 		}
L_main19:
;IR683sony.c,99 :: 		if(ir_command == 9){                               // button 0
	MOVF       _ir_command+0, 0
	XORLW      9
	BTFSS      STATUS+0, 2
	GOTO       L_main20
;IR683sony.c,100 :: 		shadow = 0x00;                                 // all outputs off
	CLRF       _shadow+0
;IR683sony.c,101 :: 		GPIO = shadow;
	CLRF       GPIO+0
;IR683sony.c,102 :: 		}
L_main20:
;IR683sony.c,103 :: 		Delay_ms(200);                                      // avoid double toggle
	MOVLW      3
	MOVWF      R11+0
	MOVLW      8
	MOVWF      R12+0
	MOVLW      119
	MOVWF      R13+0
L_main21:
	DECFSZ     R13+0, 1
	GOTO       L_main21
	DECFSZ     R12+0, 1
	GOTO       L_main21
	DECFSZ     R11+0, 1
	GOTO       L_main21
;IR683sony.c,104 :: 		}
L_main14:
;IR683sony.c,105 :: 		}
	GOTO       L_main1
;IR683sony.c,106 :: 		}
L_end_main:
	GOTO       $+0
; end of _main

_get_mark_time:

;IR683sony.c,109 :: 		void get_mark_time(void){
;IR683sony.c,110 :: 		while(ir_rx);                           // wait for a mark
L_get_mark_time22:
	BTFSS      GPIO+0, 0
	GOTO       L_get_mark_time23
	GOTO       L_get_mark_time22
L_get_mark_time23:
;IR683sony.c,111 :: 		counter=0;
	CLRF       _counter+0
;IR683sony.c,112 :: 		TMR0 = 0;
	CLRF       TMR0+0
;IR683sony.c,113 :: 		while(!ir_rx);                          // wait for space
L_get_mark_time24:
	BTFSC      GPIO+0, 0
	GOTO       L_get_mark_time25
	GOTO       L_get_mark_time24
L_get_mark_time25:
;IR683sony.c,114 :: 		mark_time = (counter << 8) + TMR0;      // collect integer mark time
	MOVF       _counter+0, 0
	MOVWF      _mark_time+1
	CLRF       _mark_time+0
	MOVF       TMR0+0, 0
	ADDWF      _mark_time+0, 1
	BTFSC      STATUS+0, 0
	INCF       _mark_time+1, 1
;IR683sony.c,116 :: 		}
L_end_get_mark_time:
	RETURN
; end of _get_mark_time
