#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRTx/IRTx.c"
#line 25 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRTx/IRTx.c"
void send_tosh(void);
void send_nec(void);
void send_sharp(void);
void send_sony(void);
void send_rc5(void);
void send_rc6m0(void);
void send_rc6m6(void);
void set_36(void);
void set_38(void);
void set_40(void);
void tosh_0(void);
void tosh_1(void);
void tosh_bit(char rc5_bitval);
void rc5_0(void);
void rc5_1(void);
void ir_rc5_bit(char rc5_bitval);
void rc6_0(void);
void rc6_1(void);
void ir_rc6_bit(char rc6_bitval);
void rc6_double_0(void);
void rc6_double_1(void);
void rc6_double_bit(char bitval);


unsigned char select;
unsigned char ir_byte[5];
unsigned char toggle;

void main() {
 ANSELC = 0;
 TRISC = 0;
 ANSELD = 0;
 TRISD = 0xff;
 toggle = 0;

 UART1_Init(9600);
 Delay_ms(100);

 UART1_Write_Text("\r\n\nEasyPIC7 IR Transmit\r\n\n");
 UART1_Write_Text("Set pull-downs on all PORT D inputs\r\n");
 UART1_Write_Text("Set button press level to high\r\n");
 UART1_Write_Text("Connect IR LED with 33 Ohm resitor in series onto pin C2\r\n");
 UART1_Write_Text("Take a Button on PORTD high as below:\r\n\n");
 UART1_Write_Text("0 Simple Test 20mS mark, 100mS space 38KHz\r\n");
 UART1_Write_Text("1 Sharp 0x13 0xa4\r\n");
 UART1_Write_Text("2 PT2248 Toshiba\r\n");
 UART1_Write_Text("3 NEC 1234 56 (A9)\r\n");
 UART1_Write_Text("4 Turn Sony TV on/off\r\n");
 UART1_Write_Text("5 RC5\r\n");
 UART1_Write_Text("6 RC6 mode 0 12 34\r\n");
 UART1_Write_Text("7 RC6 mode 6A-32\r\n");

 PWM1_Init(38000);
 PWM1_Set_Duty(80);

 while(1){
 select = PORTD;

 if(select == 1){
 set_38();
 PWM1_Start();
 Delay_ms(20);
 PWM1_Stop();
 Delay_ms(100);
 }
 if(select == 2){
 ir_byte[1]=0x13;
 ir_byte[2]=0xa4;
 send_sharp();
 }
 if(select == 4){
 ir_byte[1]=4;
 ir_byte[2]=4;
 ir_byte[3]=8;
 send_tosh();
 }
 if(select == 8){
 ir_byte[1]=0x12;
 ir_byte[2]=0x34;
 ir_byte[3]=0x56;
 send_nec();
 }
 if(select == 16){
 ir_byte[1]=0x15;
 ir_byte[2]=1;
 send_sony();
 send_sony();
 }
 if(select == 32){
 ir_byte[1]=0x00;
 ir_byte[2]=0x0d;
 send_rc5();
 }
 if(select == 64){
 ir_byte[1]=0x12;
 ir_byte[2]=0x34;
 send_rc6m0();
 }
 if(select == 128){
 ir_byte[1]=0x00;
 ir_byte[2]=0x22;
 ir_byte[3]=0x10;
 ir_byte[4]=0x0c;
 send_rc6m6();
 }
 select = 0;
 }

 while (1);
}



void set_36(){
 PR2 = 220;
}


void set_38(){
 PR2 = 210;
}


void set_40(){
 PR2 = 200;
}




void send_tosh(void){
char bitnum;

 set_38();
 Delay_ms(100);

 for(bitnum=0 ; bitnum < 3 ; bitnum++){
 tosh_bit(ir_byte[1] >> (2-bitnum));
 }
 for(bitnum=0 ; bitnum < 3 ; bitnum++){
 tosh_bit(ir_byte[2] >> (2-bitnum));
 }
 for(bitnum=0 ; bitnum < 6 ; bitnum++){
 tosh_bit(ir_byte[3] >> (5-bitnum));
 }
 PWM1_Stop();
 Delay_ms(100);
}




void send_rc6m0(void){
char bitnum;

 set_36();
 Delay_ms(100);
 PWM1_Start();
 Delay_us(2666);
 PWM1_Stop();
 Delay_us(889);
 rc6_1();
 rc6_0();
 rc6_0();
 rc6_0();
 rc6_double_bit(toggle);
 toggle++;

 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[1] >> (7-bitnum));
 }
 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[2] >> (7-bitnum));
 }
 PWM1_Stop();
 Delay_ms(100);
}



void send_rc6m6(void){
char bitnum;

 set_36();
 Delay_ms(100);
 PWM1_Start();
 Delay_us(2666);
 PWM1_Stop();
 Delay_us(889);
 rc6_1();
 rc6_1();
 rc6_1();
 rc6_0();
 rc6_double_bit(toggle);
 toggle++;

 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[1] >> (7-bitnum));
 }
 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[2] >> (7-bitnum));
 }
 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[3] >> (7-bitnum));
 }
 for(bitnum=0 ; bitnum < 8 ; bitnum++){
 ir_rc6_bit(ir_byte[4] >> (7-bitnum));
 }
 PWM1_Stop();
 Delay_ms(100);
}



void send_rc5(void){
char bitnum;

 set_36();
 Delay_ms(100);
 rc5_1();
 rc5_1();
 ir_rc5_bit(toggle);
 toggle++;

 for(bitnum=0 ; bitnum < 5 ; bitnum++){
 ir_rc5_bit(ir_byte[1] >> (4-bitnum));
 }
 for(bitnum=0 ; bitnum < 6 ; bitnum++){
 ir_rc5_bit(ir_byte[2] >> (5-bitnum));
 }
 PWM1_Stop();
 Delay_ms(100);
}


void tosh_0(void){
 PWM1_Start();
 Delay_us(422);
 PWM1_Stop();
 Delay_us(1266);
}


void tosh_1(void){
 PWM1_Start();
 Delay_us(1266);
 PWM1_Stop();
 Delay_us(422);
}


void tosh_bit(char tosh_bitval){

 if(tosh_bitval & 1){
 tosh_1();
 }
 else{
 tosh_0();
 }
}



void rc5_0(void){
 PWM1_Start();
 Delay_us(889);
 PWM1_Stop();
 Delay_us(889);
}


void rc5_1(void){
 PWM1_Stop();
 Delay_us(889);
 PWM1_Start();
 Delay_us(889);
}


void ir_rc5_bit(char rc5_bitval){

 if(rc5_bitval & 1){
 rc5_1();
 }
 else{
 rc5_0();
 }
}


void rc6_double_bit(char bitval){

 if(bitval & 1){
 rc6_double_1();
 }
 else{
 rc6_double_0();
 }
}


void rc6_double_1(void){
 PWM1_Start();
 Delay_us(889);
 PWM1_Stop();
 Delay_us(889);
}


void rc6_double_0(void){
 PWM1_Stop();
 Delay_us(889);
 PWM1_Start();
 Delay_us(889);
}


void rc6_1(void){
 PWM1_Start();
 Delay_us(444);
 PWM1_Stop();
 Delay_us(444);
}


void rc6_0(void){
 PWM1_Stop();
 Delay_us(444);
 PWM1_Start();
 Delay_us(444);
}


void ir_rc6_bit(char rc6_bitval){

 if(rc6_bitval & 1){
 rc6_1();
 }
 else{
 rc6_0();
 }
}



void send_nec(void){
char bitnum;
char bytenum;

 set_38();
 ir_byte[4] = ~ir_byte[3];
 Delay_ms(100);
 PWM1_Start();
 Delay_us(9000);
 PWM1_Stop();
 Delay_us(4500);
 for(bytenum = 1; bytenum < 5; bytenum++){
 for(bitnum = 0; bitnum < 8; bitnum++){
 PWM1_Start();
 Delay_us(560);
 PWM1_Stop();
 if(ir_byte[bytenum] & (1 << bitnum)){
 Delay_us(1680);
 }
 else{
 Delay_us(560);
 }


 }
 }
 PWM1_Start();
 Delay_us(560);
 PWM1_Stop();
 Delay_us(1680);
 Delay_ms(100);
}










void send_sony(void){
char bitnum;

 set_40();
 PWM1_Start();
 Delay_us(2400);
 PWM1_Stop();
 Delay_us(600);
 for(bitnum = 0; bitnum < 7; bitnum++){
 PWM1_Start();
 if(ir_byte[1] & (1 << bitnum)){
 Delay_us(1200);
 }
 else{
 Delay_us(600);
 }
 PWM1_Stop();
 Delay_us(600);
 }
 for(bitnum = 0; bitnum < 5; bitnum++){
 PWM1_Start();
 if(ir_byte[2] & (1 << bitnum)){
 Delay_us(1200);
 }
 else{
 Delay_us(600);
 }
 PWM1_Stop();
 Delay_us(600);
 }
 Delay_ms(26);
}


void send_sharp(void){
char bitnum;

 set_38();
 for(bitnum = 0; bitnum < 5; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 if(ir_byte[1] & (1 << bitnum)){
 Delay_us(1680);
 }
 else{
 Delay_us(680);
 }
 }
 for(bitnum = 0; bitnum < 8; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 if(ir_byte[2] & (1 << bitnum)){
 Delay_us(1680);
 }
 else{
 Delay_us(680);
 }
 }


 for(bitnum = 0; bitnum < 2; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 Delay_us(1680);
 PWM1_Start();
 Delay_us(680);
 PWM1_Stop();
 }


 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 Delay_ms(40);


 for(bitnum = 0; bitnum < 5; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 if(ir_byte[1] & (1 << bitnum)){
 Delay_us(1680);
 }
 else{
 Delay_us(680);
 }
 }


 for(bitnum = 0; bitnum < 8; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 if(ir_byte[2] & (1 << bitnum)){
 Delay_us(680);
 }
 else{
 Delay_us(1680);
 }
 }


 for(bitnum = 0; bitnum < 2; bitnum++){
 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 Delay_us(680);
 PWM1_Start();
 Delay_us(1680);
 PWM1_Stop();
 }


 PWM1_Start();
 Delay_us(320);
 PWM1_Stop();
 Delay_ms(40);
}
