#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRnec/IRnec.c"
#line 13 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRnec/IRnec.c"
sbit ir_in at RC0_bit;
sbit ir_in_direction at TRISC0_bit;


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;


sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;





char irnowm;
char irwas2t;
char irbyte;
unsigned int retint;
signed int temp_bit_s;
signed int temp_bit_m;
char keephex[3];
unsigned char ir_byte;
unsigned char ir_result[6];
unsigned char button;


int get_mark(void);
int get_space(void);
void nec_read(void);
unsigned char get_nec_byte(void);

void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ADCON0 = 0;
 ADCON1 = 0x0f;

 CM1CON0 = 0;
 CM2CON0 = 0;
 T0CON = 0x86;
 TMR0L = 96;
 TMR0H = 0xff;
 INTCON = 0x00;

 LATA = 0;
 LATB = 0x80;
 LATD = 0;
 LATC = 0;
 LATE = 0;
 TRISA = 0xC1;
 TRISB = 0x81;
 TRISC = 0x01;
 TRISD = 0x00;
 TRISE = 0;
 ir_in_direction = 1;

 Delay_ms(1000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(2,1, "waiting for IR  ");
 while(1){
 ir_result[0]=0;
 ir_result[1]=0;
 ir_result[2]=0;
 ir_result[3]=0;
 nec_read();



 if((ir_result[0]==0x10)&&(ir_result[1]==0xee)){
 button = ir_result[2];
 switch(button){
 case 0x04: LATD.F0 = ~LATD.F0;break;
 case 0x05: LATD.F1 = ~LATD.F1;break;
 case 0x06: LATD.F2 = ~LATD.F2;break;
 case 0x08: LATD.F3 = ~LATD.F3;break;
 case 0x09: LATD.F4 = ~LATD.F4;break;
 case 0x0a: LATD.F5 = ~LATD.F5;break;

 default: break;
 }
 }
 Delay_ms(500);
 }
 while(1);
}



void hexout(unsigned char hexval){
int temp_hex;
char hextxt[7];

 temp_hex = hexval;
 IntToHex(temp_hex, hextxt);
 keephex[0] = hextxt[2];
 keephex[1] = hextxt[3];
 keephex[2] = 0;
}
#line 137 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRnec/IRnec.c"
void nec_read(void){
signed int temp_nec;
char count_byte;

 Lcd_Out(1,1, "NEC protocol IR ");

 while(ir_in);

 temp_nec = get_mark();
 if ((temp_nec > 500) && (temp_nec < 800)){
 temp_nec = get_space();
 if ((temp_nec > 200) && (temp_nec < 400)){
 for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
 ir_result[count_byte] = get_nec_byte();
 }
 }
 Lcd_Out(2,1, "NEC            ");
 for(count_byte = 0 ; count_byte < 4 ; count_byte++){
 hexout(ir_result[count_byte]);
 Lcd_Chr(2,(count_byte * 3)+5,keephex[0]);
 Lcd_Chr(2,(count_byte * 3)+6,keephex[1]);
 }
 Delay_ms(10);
 }
}


unsigned char get_nec_byte(void){
char n;
unsigned char ir_byte;
signed int temp_ir;

 for(n=0 ; n<8 ; n++){
 temp_ir = get_mark();
 temp_ir = get_space();
 ir_byte >>= 1;
 if (temp_ir > 70){
 ir_byte += 0x80;
 }
 }
 return ir_byte;
}


int get_mark(void){
 TMR0H = 0;
 TMR0L = 0;
 while(!ir_in);
 LATE.F0 = 0;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}


int get_space(void){
 TMR0H = 0;
 TMR0L = 0;
 while(ir_in);
 LATE.F0 = 1;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}
