#line 1 "C:/PIC/MikroC/PIC18/PIC18F45K22/EasyIR/IRrc5/IRrc5.c"







sbit ir_in at RC0_bit;
sbit ir_in_direction at TRISC0_bit;


sbit LCD_RS at LATB4_bit;
sbit LCD_EN at LATB5_bit;
sbit LCD_D4 at LATB0_bit;
sbit LCD_D5 at LATB1_bit;
sbit LCD_D6 at LATB2_bit;
sbit LCD_D7 at LATB3_bit;


sbit LCD_RS_Direction at TRISB4_bit;
sbit LCD_EN_Direction at TRISB5_bit;
sbit LCD_D7_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB0_bit;


char irnowm;
char irwas2t;
char irbyte;
unsigned int retint;
signed int temp_bit_s;
signed int temp_bit_m;
char keephex[3];
unsigned char ir_byte;
char ir_toggle;
unsigned char ir_result[5];
unsigned char button;


int get_mark(void);
int get_space(void);
unsigned char get_rc5_byte(char nbits);
void getrc5bit(void);
void rc5_read(void);


void main() {
 ANSELA = 0;
 ANSELB = 0;
 ANSELC = 0;
 ANSELD = 0;
 ADCON0 = 0;
 ADCON1 = 0x0f;

 CM1CON0 = 0;
 CM2CON0 = 0;
 T0CON = 0x86;
 TMR0L = 96;
 TMR0H = 0xff;
 INTCON = 0x00;

 LATA = 0;
 LATB = 0x80;
 LATD = 0;
 LATC = 0;
 LATE = 0;
 TRISA = 0xC1;
 TRISB = 0x81;
 TRISC = 0x01;
 TRISD = 0x00;
 TRISE = 0;
 ir_in_direction = 1;

 Delay_ms(1000);
 Lcd_Init();
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1,1, "RC5 protocol  IR");
 Lcd_Out(2,1, "waiting for IR  ");

 while(1){
 ir_result[0]=0;
 ir_result[1]=0;
 rc5_read();
 if(ir_result[0]==0x0f){
 button = ir_result[1];
 switch (button){
 case 0x10: LATD.F0 = ~ LATD.F0; break;
 case 0x11: LATD.F1 = ~ LATD.F1; break;
 case 0x18: LATD.F2 = ~ LATD.F2; break;
 case 0x19: LATD.F3 = ~ LATD.F3; break;
 case 0x16: LATD.F4 = ~ LATD.F4; break;
 case 0x17: LATD.F5 = ~ LATD.F5; break;
 default: break;
 }
 Delay_ms(500);
 }
 }
}


void hexout(unsigned char hexval){
int temp_hex;
char hextxt[7];

 temp_hex = hexval;
 IntToHex(temp_hex, hextxt);
 keephex[0] = hextxt[2];
 keephex[1] = hextxt[3];
 keephex[2] = 0;
}


int get_mark(void){
 TMR0H = 0;
 TMR0L = 0;
 while(!ir_in);
 LATE.F0 = 0;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}


int get_space(void){
 TMR0H = 0;
 TMR0L = 0;
 while(ir_in);
 LATE.F0 = 1;
 retint = TMR0L;
 retint += (TMR0H<<8);
 return retint;
}










void rc5_read(void){
signed int temp_ir;
unsigned char rc5_byte1;
unsigned char rc5_byte2;

 rc5_byte1=0;
 rc5_byte2=0;
 while(ir_in);

 irwas2t = 0;
 irnowm = 0;
 temp_ir = get_mark();
 if ((temp_ir > 40) && (temp_ir < 80)){
 rc5_byte1 = get_rc5_byte(7);
 rc5_byte2 = get_rc5_byte(6);
 Lcd_Out(2,1, "t=0 ad=   cmd=  ");
 if (rc5_byte1 & 0x20){
 Lcd_Chr(2,3,'1');
 }
 else{
 Lcd_Chr(2,3,'0');
 }
 hexout(rc5_byte1 & 0x1F);
 Lcd_Chr(2,8,keephex[0]);
 Lcd_Chr(2,9,keephex[1]);
 hexout(rc5_byte2);
 Lcd_Chr(2,15,keephex[0]);
 Lcd_Chr(2,16,keephex[1]);
 Delay_ms(100);
 }
 ir_result[0]=rc5_byte1&0x1f;
 ir_result[1]=rc5_byte2&0x3f;
}


unsigned char get_rc5_byte(char nbits){
char n;

 irbyte = 0;
 for(n = 0 ; n < nbits ; n++){
 getrc5bit();
 }
 return irbyte;
}


void getrc5bit(void){

 if(!irnowm){

 if(!irwas2t){

 irnowm = 0;
 temp_bit_s = get_space();
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 80) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 else{

 irnowm = 0xff;
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 80) irwas2t = 0;
 irbyte <<= 1;
 }
 }
 else{

 if(!irwas2t){

 irnowm = 0xff;
 temp_bit_m = get_mark();
 temp_bit_s = get_space();
 irwas2t = 0xff;
 if(temp_bit_s < 80) irwas2t = 0;
 irbyte <<= 1;
 }
 else{

 irnowm = 0;
 temp_bit_m = get_mark();
 irwas2t = 0xff;
 if(temp_bit_m < 80) irwas2t = 0;
 irbyte <<= 1;
 irbyte ++;
 }
 }
}
