
_main:

;IRtx683sony.c,18 :: 		void main() {
;IRtx683sony.c,23 :: 		OSCCON = 0x71;                      // Internal 8MHz osc.
	MOVLW      113
	MOVWF      OSCCON+0
;IRtx683sony.c,25 :: 		ADCON0 = 0;                         // all pins digital
	CLRF       ADCON0+0
;IRtx683sony.c,26 :: 		ANSEL = 0;                          // all pins digital
	CLRF       ANSEL+0
;IRtx683sony.c,27 :: 		CMCON0 = 7;                         // Comparators off.
	MOVLW      7
	MOVWF      CMCON0+0
;IRtx683sony.c,28 :: 		GPIO = 0;                           // all pins low
	CLRF       GPIO+0
;IRtx683sony.c,29 :: 		TRISIO = 0xfb;                      // all input, bar GP2
	MOVLW      251
	MOVWF      TRISIO+0
;IRtx683sony.c,30 :: 		WPU = 0x33;                         // weak pull-ups on button inputs
	MOVLW      51
	MOVWF      WPU+0
;IRtx683sony.c,31 :: 		OPTION_REG.B7 = 0;                  // ~GPPU bit is cleared to enable weak pull-ups
	BCF        OPTION_REG+0, 7
;IRtx683sony.c,33 :: 		T2CON = 0x04;                       // prescaler + turn on TMR2;
	MOVLW      4
	MOVWF      T2CON+0
;IRtx683sony.c,34 :: 		PR2 = 0x31;                         // freq 0x31 for 40kHz
	MOVLW      49
	MOVWF      PR2+0
;IRtx683sony.c,35 :: 		CCPR1L = 0x17;                      // set low time 0x17 for 40kHz
	MOVLW      23
	MOVWF      CCPR1L+0
;IRtx683sony.c,36 :: 		CCP1CON = 0x30;                     // duty lowest bits + PWM mode (PWM off)
	MOVLW      48
	MOVWF      CCP1CON+0
;IRtx683sony.c,38 :: 		while (1){
L_main0:
;IRtx683sony.c,39 :: 		if((GPIO & 0x33) != 0x33){          // wait for switch to go low
	MOVLW      51
	ANDWF      GPIO+0, 0
	MOVWF      R1+0
	MOVF       R1+0, 0
	XORLW      51
	BTFSC      STATUS+0, 2
	GOTO       L_main2
;IRtx683sony.c,40 :: 		sony_address = 0;               // initialise
	CLRF       main_sony_address_L0+0
;IRtx683sony.c,41 :: 		sony_command = 0;               // initialise
	CLRF       main_sony_command_L0+0
;IRtx683sony.c,42 :: 		if (!GPIO.B0){                  // PIC button 1
	BTFSC      GPIO+0, 0
	GOTO       L_main3
;IRtx683sony.c,43 :: 		sony_address = 1;           // TV = 1
	MOVLW      1
	MOVWF      main_sony_address_L0+0
;IRtx683sony.c,44 :: 		sony_command = 0;           // Sony button 1
	CLRF       main_sony_command_L0+0
;IRtx683sony.c,45 :: 		}
L_main3:
;IRtx683sony.c,46 :: 		if (!GPIO.B1){                  // PIC button 2
	BTFSC      GPIO+0, 1
	GOTO       L_main4
;IRtx683sony.c,47 :: 		sony_address = 1;           // TV = 1
	MOVLW      1
	MOVWF      main_sony_address_L0+0
;IRtx683sony.c,48 :: 		sony_command = 1;           // TV button 2
	MOVLW      1
	MOVWF      main_sony_command_L0+0
;IRtx683sony.c,49 :: 		}
L_main4:
;IRtx683sony.c,50 :: 		if (!GPIO.B4){                  // PIC button 3
	BTFSC      GPIO+0, 4
	GOTO       L_main5
;IRtx683sony.c,51 :: 		sony_address = 1;           // TV = 1
	MOVLW      1
	MOVWF      main_sony_address_L0+0
;IRtx683sony.c,52 :: 		sony_command = 2;           // TV button 3
	MOVLW      2
	MOVWF      main_sony_command_L0+0
;IRtx683sony.c,53 :: 		}
L_main5:
;IRtx683sony.c,54 :: 		if (!GPIO.B5){                  // PIC button 4
	BTFSC      GPIO+0, 5
	GOTO       L_main6
;IRtx683sony.c,55 :: 		sony_address = 1;           // TV = 1
	MOVLW      1
	MOVWF      main_sony_address_L0+0
;IRtx683sony.c,56 :: 		sony_command = 3;           // TV button 4
	MOVLW      3
	MOVWF      main_sony_command_L0+0
;IRtx683sony.c,57 :: 		}
L_main6:
;IRtx683sony.c,58 :: 		pwm_start();                    // 40KHz mark for 2.4mS start bit
	CALL       _pwm_start+0
;IRtx683sony.c,59 :: 		Delay_us(2400);
	MOVLW      7
	MOVWF      R12+0
	MOVLW      58
	MOVWF      R13+0
L_main7:
	DECFSZ     R13+0, 1
	GOTO       L_main7
	DECFSZ     R12+0, 1
	GOTO       L_main7
	NOP
;IRtx683sony.c,60 :: 		pwm_stop();                     // space  for 1.2mS start bit
	CALL       _pwm_stop+0
;IRtx683sony.c,61 :: 		Delay_us(1200);
	MOVLW      4
	MOVWF      R12+0
	MOVLW      28
	MOVWF      R13+0
L_main8:
	DECFSZ     R13+0, 1
	GOTO       L_main8
	DECFSZ     R12+0, 1
	GOTO       L_main8
	NOP
;IRtx683sony.c,62 :: 		for(n=0; n<7 ; n++){            // 7 command bits
	CLRF       main_n_L0+0
L_main9:
	MOVLW      7
	SUBWF      main_n_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main10
;IRtx683sony.c,63 :: 		if(sony_command & (1<<n)){  // check each bit
	MOVF       main_n_L0+0, 0
	MOVWF      R2+0
	MOVLW      1
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__main25:
	BTFSC      STATUS+0, 2
	GOTO       L__main26
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main25
L__main26:
	MOVF       main_sony_command_L0+0, 0
	ANDWF      R0+0, 1
	MOVLW      0
	ANDWF      R0+1, 1
	MOVF       R0+0, 0
	IORWF      R0+1, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main12
;IRtx683sony.c,64 :: 		send_1();
	CALL       _send_1+0
;IRtx683sony.c,65 :: 		}
	GOTO       L_main13
L_main12:
;IRtx683sony.c,67 :: 		send_0();
	CALL       _send_0+0
;IRtx683sony.c,68 :: 		}
L_main13:
;IRtx683sony.c,62 :: 		for(n=0; n<7 ; n++){            // 7 command bits
	INCF       main_n_L0+0, 1
;IRtx683sony.c,69 :: 		}
	GOTO       L_main9
L_main10:
;IRtx683sony.c,70 :: 		for(n=0; n<5 ; n++){            // 5 address bits
	CLRF       main_n_L0+0
L_main14:
	MOVLW      5
	SUBWF      main_n_L0+0, 0
	BTFSC      STATUS+0, 0
	GOTO       L_main15
;IRtx683sony.c,71 :: 		if(sony_address & (1<<n)){  // check each bit
	MOVF       main_n_L0+0, 0
	MOVWF      R2+0
	MOVLW      1
	MOVWF      R0+0
	MOVLW      0
	MOVWF      R0+1
	MOVF       R2+0, 0
L__main27:
	BTFSC      STATUS+0, 2
	GOTO       L__main28
	RLF        R0+0, 1
	RLF        R0+1, 1
	BCF        R0+0, 0
	ADDLW      255
	GOTO       L__main27
L__main28:
	MOVF       main_sony_address_L0+0, 0
	ANDWF      R0+0, 1
	MOVLW      0
	ANDWF      R0+1, 1
	MOVF       R0+0, 0
	IORWF      R0+1, 0
	BTFSC      STATUS+0, 2
	GOTO       L_main17
;IRtx683sony.c,72 :: 		send_1();
	CALL       _send_1+0
;IRtx683sony.c,73 :: 		}
	GOTO       L_main18
L_main17:
;IRtx683sony.c,75 :: 		send_0();
	CALL       _send_0+0
;IRtx683sony.c,76 :: 		}
L_main18:
;IRtx683sony.c,70 :: 		for(n=0; n<5 ; n++){            // 5 address bits
	INCF       main_n_L0+0, 1
;IRtx683sony.c,77 :: 		}
	GOTO       L_main14
L_main15:
;IRtx683sony.c,78 :: 		pwm_stop();                     // allow gap between messages
	CALL       _pwm_stop+0
;IRtx683sony.c,79 :: 		Delay_ms(300);                  // limit message rate with suitable message free time
	MOVLW      4
	MOVWF      R11+0
	MOVLW      12
	MOVWF      R12+0
	MOVLW      51
	MOVWF      R13+0
L_main19:
	DECFSZ     R13+0, 1
	GOTO       L_main19
	DECFSZ     R12+0, 1
	GOTO       L_main19
	DECFSZ     R11+0, 1
	GOTO       L_main19
	NOP
	NOP
;IRtx683sony.c,80 :: 		}
L_main2:
;IRtx683sony.c,81 :: 		}
	GOTO       L_main0
;IRtx683sony.c,82 :: 		}
L_end_main:
	GOTO       $+0
; end of _main

_send_0:

;IRtx683sony.c,85 :: 		void send_0(void){
;IRtx683sony.c,86 :: 		pwm_start();                    // 40KHz mark for .6 mS
	CALL       _pwm_start+0
;IRtx683sony.c,87 :: 		Delay_us(600);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      141
	MOVWF      R13+0
L_send_020:
	DECFSZ     R13+0, 1
	GOTO       L_send_020
	DECFSZ     R12+0, 1
	GOTO       L_send_020
	NOP
	NOP
;IRtx683sony.c,88 :: 		pwm_stop();                     // space  for .6 mS
	CALL       _pwm_stop+0
;IRtx683sony.c,89 :: 		Delay_us(600);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      141
	MOVWF      R13+0
L_send_021:
	DECFSZ     R13+0, 1
	GOTO       L_send_021
	DECFSZ     R12+0, 1
	GOTO       L_send_021
	NOP
	NOP
;IRtx683sony.c,90 :: 		}
L_end_send_0:
	RETURN
; end of _send_0

_send_1:

;IRtx683sony.c,93 :: 		void send_1(void){
;IRtx683sony.c,94 :: 		pwm_start();                    // 40KHz mark for 1.2 mS
	CALL       _pwm_start+0
;IRtx683sony.c,95 :: 		Delay_us(1200);
	MOVLW      4
	MOVWF      R12+0
	MOVLW      28
	MOVWF      R13+0
L_send_122:
	DECFSZ     R13+0, 1
	GOTO       L_send_122
	DECFSZ     R12+0, 1
	GOTO       L_send_122
	NOP
;IRtx683sony.c,96 :: 		pwm_stop();                     // space  for .6 mS
	CALL       _pwm_stop+0
;IRtx683sony.c,97 :: 		Delay_us(600);
	MOVLW      2
	MOVWF      R12+0
	MOVLW      141
	MOVWF      R13+0
L_send_123:
	DECFSZ     R13+0, 1
	GOTO       L_send_123
	DECFSZ     R12+0, 1
	GOTO       L_send_123
	NOP
	NOP
;IRtx683sony.c,98 :: 		}
L_end_send_1:
	RETURN
; end of _send_1

_pwm_start:

;IRtx683sony.c,102 :: 		void pwm_start(void){
;IRtx683sony.c,103 :: 		CCP1CON = 0x3c;
	MOVLW      60
	MOVWF      CCP1CON+0
;IRtx683sony.c,104 :: 		}
L_end_pwm_start:
	RETURN
; end of _pwm_start

_pwm_stop:

;IRtx683sony.c,107 :: 		void pwm_stop(void){
;IRtx683sony.c,108 :: 		CCP1CON = 0x30;
	MOVLW      48
	MOVWF      CCP1CON+0
;IRtx683sony.c,109 :: 		}
L_end_pwm_stop:
	RETURN
; end of _pwm_stop
