
_interrupt:

;IR.c,83 :: 		void interrupt() {                 // interrepts are here, but serve no function yet
;IR.c,84 :: 		if (TMR0IF_bit) {                // handle timer 0 overflow
	BTFSS       TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
	GOTO        L_interrupt0
;IR.c,85 :: 		cnt++;                       // Increment counter - gives extra 2 bytes counter option
	INFSNZ      _cnt+0, 1 
	INCF        _cnt+1, 1 
;IR.c,86 :: 		TMR0IF_bit = 0;              // Clear TMR0IF
	BCF         TMR0IF_bit+0, BitPos(TMR0IF_bit+0) 
;IR.c,87 :: 		}
L_interrupt0:
;IR.c,90 :: 		if (INT0F_bit){                  // handle interrupt on B0 pin
	BTFSS       INT0F_bit+0, BitPos(INT0F_bit+0) 
	GOTO        L_interrupt1
;IR.c,91 :: 		INT0F_bit = 0;               // clear interrupt
	BCF         INT0F_bit+0, BitPos(INT0F_bit+0) 
;IR.c,92 :: 		if (INTEDG0_bit){
	BTFSS       INTEDG0_bit+0, BitPos(INTEDG0_bit+0) 
	GOTO        L_interrupt2
;IR.c,93 :: 		INTEDG0_bit = 0;         // interrupt on B0 falling edge
	BCF         INTEDG0_bit+0, BitPos(INTEDG0_bit+0) 
;IR.c,94 :: 		}
	GOTO        L_interrupt3
L_interrupt2:
;IR.c,96 :: 		INTEDG0_bit = 1;         // interrupt on B0 rising edge
	BSF         INTEDG0_bit+0, BitPos(INTEDG0_bit+0) 
;IR.c,97 :: 		}
L_interrupt3:
;IR.c,98 :: 		}
L_interrupt1:
;IR.c,99 :: 		}
L_end_interrupt:
L__interrupt272:
	RETFIE      1
; end of _interrupt

_main:

;IR.c,102 :: 		void main() {
;IR.c,103 :: 		ANSELA = 0;                   // Configure PORT pins as digital
	CLRF        ANSELA+0 
;IR.c,104 :: 		ANSELB = 0;                   // Configure PORT pins as digital
	CLRF        ANSELB+0 
;IR.c,105 :: 		ANSELC = 0;                   // Configure PORT pins as digital
	CLRF        ANSELC+0 
;IR.c,106 :: 		ANSELD = 0;                   // Configure PORT pins as digital
	CLRF        ANSELD+0 
;IR.c,107 :: 		ADCON0 = 0;                   // A/D off
	CLRF        ADCON0+0 
;IR.c,108 :: 		ADCON1 = 0x0f;                // all digital
	MOVLW       15
	MOVWF       ADCON1+0 
;IR.c,110 :: 		CM1CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM1CON0+0 
;IR.c,111 :: 		CM2CON0 = 0;                  // disable 18F45K22 comparator
	CLRF        CM2CON0+0 
;IR.c,112 :: 		T0CON = 0x86;                 // timer on 16 bit prescale 128:1
	MOVLW       134
	MOVWF       T0CON+0 
;IR.c,113 :: 		TMR0L = 96;                   // Timer0 initial value
	MOVLW       96
	MOVWF       TMR0L+0 
;IR.c,114 :: 		TMR0H = 0xff;
	MOVLW       255
	MOVWF       TMR0H+0 
;IR.c,115 :: 		INTCON = 0xB0;                // Enable TMRO and INT interrupts
	MOVLW       176
	MOVWF       INTCON+0 
;IR.c,116 :: 		cnt = 0;                      // Initialize cnt
	CLRF        _cnt+0 
	CLRF        _cnt+1 
;IR.c,118 :: 		LATA = 0;                     // all off
	CLRF        LATA+0 
;IR.c,119 :: 		LATB = 0x80;                  // disable GLCD if fitted
	MOVLW       128
	MOVWF       LATB+0 
;IR.c,120 :: 		LATD = 0;                     // all off
	CLRF        LATD+0 
;IR.c,121 :: 		LATC = 0;                     // all off
	CLRF        LATC+0 
;IR.c,122 :: 		LATE = 0;                     // all off
	CLRF        LATE+0 
;IR.c,123 :: 		TRISA = 0xC1;                 // all output except OSC pins
	MOVLW       193
	MOVWF       TRISA+0 
;IR.c,124 :: 		TRISB = 0x81;                 // all output except b0
	MOVLW       129
	MOVWF       TRISB+0 
;IR.c,125 :: 		TRISC = 0x01;                 // all output except c0
	MOVLW       1
	MOVWF       TRISC+0 
;IR.c,126 :: 		TRISD = 0xff;                 // all input
	MOVLW       255
	MOVWF       TRISD+0 
;IR.c,127 :: 		TRISE = 0;                    // all output
	CLRF        TRISE+0 
;IR.c,128 :: 		PWM1_Init(38000);             // 38kHz on RC2
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       209
	MOVWF       PR2+0, 0
	CALL        _PWM1_Init+0, 0
;IR.c,130 :: 		PWM1_Set_Duty(80);            // 30%
	MOVLW       80
	MOVWF       FARG_PWM1_Set_Duty_new_duty+0 
	CALL        _PWM1_Set_Duty+0, 0
;IR.c,131 :: 		PWM2_Init(38000);             // 38kHz on RC1 (or possibly RB3)
	BCF         T2CON+0, 0, 0
	BCF         T2CON+0, 1, 0
	MOVLW       209
	MOVWF       PR2+0, 0
	CALL        _PWM2_Init+0, 0
;IR.c,133 :: 		PWM2_Set_Duty(80);            // 30%
	MOVLW       80
	MOVWF       FARG_PWM2_Set_Duty_new_duty+0 
	CALL        _PWM2_Set_Duty+0, 0
;IR.c,134 :: 		ir_in_direction = 1;          // IR input
	BSF         TRISA3_bit+0, BitPos(TRISA3_bit+0) 
;IR.c,135 :: 		UART1_Init(2400);             // Initialize UART module at 9600 bps
	BSF         BAUDCON+0, 3, 0
	MOVLW       13
	MOVWF       SPBRGH+0 
	MOVLW       4
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;IR.c,136 :: 		Delay_ms(100);                // Wait for UART module to stabilize
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_main4:
	DECFSZ      R13, 1, 1
	BRA         L_main4
	DECFSZ      R12, 1, 1
	BRA         L_main4
	DECFSZ      R11, 1, 1
	BRA         L_main4
;IR.c,137 :: 		UART1_Write_Text("\r\n\nIR Utilities\r\n\n");
	MOVLW       ?lstr1_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr1_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,139 :: 		Delay_ms(1000);                // Wait for LCD to stabilize
	MOVLW       41
	MOVWF       R11, 0
	MOVLW       150
	MOVWF       R12, 0
	MOVLW       127
	MOVWF       R13, 0
L_main5:
	DECFSZ      R13, 1, 1
	BRA         L_main5
	DECFSZ      R12, 1, 1
	BRA         L_main5
	DECFSZ      R11, 1, 1
	BRA         L_main5
;IR.c,140 :: 		Lcd_Init();                            // Initialize Lcd
	CALL        _Lcd_Init+0, 0
;IR.c,141 :: 		Lcd_Cmd(_LCD_CLEAR);                   // Clear display
	MOVLW       1
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IR.c,142 :: 		Lcd_Cmd(_LCD_CURSOR_OFF);              // Turn cursor off
	MOVLW       12
	MOVWF       FARG_Lcd_Cmd_out_char+0 
	CALL        _Lcd_Cmd+0, 0
;IR.c,143 :: 		while(1){
L_main6:
;IR.c,144 :: 		Lcd_Out(1,1, "0LED 1Sa 2T 3NEC");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr2_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr2_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,145 :: 		Lcd_Out(2,1, "4Sony 5RC5 6RC6 ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr3_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr3_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,147 :: 		UART1_Write_Text("0 Simple IR test\r\n");
	MOVLW       ?lstr4_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr4_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,148 :: 		UART1_Write_Text("1 Samsung Rx\r\n");
	MOVLW       ?lstr5_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr5_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,149 :: 		UART1_Write_Text("2 PT2248/9 Rx\r\n");
	MOVLW       ?lstr6_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr6_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,150 :: 		UART1_Write_Text("3 NEC  Rx\r\n");
	MOVLW       ?lstr7_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr7_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,151 :: 		UART1_Write_Text("4 Sony Rx\r\n");
	MOVLW       ?lstr8_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr8_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,152 :: 		UART1_Write_Text("5 RC5  Rx\r\n");
	MOVLW       ?lstr9_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr9_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,153 :: 		UART1_Write_Text("6 RC6 m0, RC6 m6-32, MCE \r\n");
	MOVLW       ?lstr10_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr10_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,154 :: 		UART1_Write_Text("7 RC6 mode 6-20 (Sky)\r\n");
	MOVLW       ?lstr11_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr11_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,155 :: 		UART1_Write_Text("8 Sharp Rx (beta)\r\n");
	MOVLW       ?lstr12_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr12_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,156 :: 		UART1_Write_Text("9 Timing print\r\n");
	MOVLW       ?lstr13_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr13_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,157 :: 		UART1_Write_Text("m MMC print\r\n");             // not yet developed - ignore
	MOVLW       ?lstr14_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr14_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,159 :: 		cmd = get_cmd();                         // read command from UART or switches
	CALL        _get_cmd+0, 0
	MOVF        R0, 0 
	MOVWF       _cmd+0 
;IR.c,160 :: 		switch (cmd){
	GOTO        L_main8
;IR.c,161 :: 		case '0': simple_ir(); break;
L_main10:
	CALL        _simple_ir+0, 0
	GOTO        L_main9
;IR.c,162 :: 		case '1': sam_print(); break;
L_main11:
	CALL        _sam_print+0, 0
	GOTO        L_main9
;IR.c,163 :: 		case '2': tosh_print(); break;
L_main12:
	CALL        _tosh_print+0, 0
	GOTO        L_main9
;IR.c,164 :: 		case '3': nec_print(); break;
L_main13:
	CALL        _nec_print+0, 0
	GOTO        L_main9
;IR.c,165 :: 		case '4': sony_print(); break;
L_main14:
	CALL        _sony_print+0, 0
	GOTO        L_main9
;IR.c,166 :: 		case '5': rc5_print(); break;
L_main15:
	CALL        _rc5_print+0, 0
	GOTO        L_main9
;IR.c,167 :: 		case '6': rc6_print(); break;
L_main16:
	CALL        _rc6_print+0, 0
	GOTO        L_main9
;IR.c,168 :: 		case '7': sky_print(); break;
L_main17:
	CALL        _sky_print+0, 0
	GOTO        L_main9
;IR.c,169 :: 		case '8': sharp_print(); break;
L_main18:
	CALL        _sharp_print+0, 0
	GOTO        L_main9
;IR.c,170 :: 		case '9': timing_print(); break;
L_main19:
	CALL        _timing_print+0, 0
	GOTO        L_main9
;IR.c,171 :: 		case 'm': mmc_print(); break;
L_main20:
	CALL        _mmc_print+0, 0
	GOTO        L_main9
;IR.c,172 :: 		default:  break;
L_main21:
	GOTO        L_main9
;IR.c,173 :: 		}
L_main8:
	MOVF        _cmd+0, 0 
	XORLW       48
	BTFSC       STATUS+0, 2 
	GOTO        L_main10
	MOVF        _cmd+0, 0 
	XORLW       49
	BTFSC       STATUS+0, 2 
	GOTO        L_main11
	MOVF        _cmd+0, 0 
	XORLW       50
	BTFSC       STATUS+0, 2 
	GOTO        L_main12
	MOVF        _cmd+0, 0 
	XORLW       51
	BTFSC       STATUS+0, 2 
	GOTO        L_main13
	MOVF        _cmd+0, 0 
	XORLW       52
	BTFSC       STATUS+0, 2 
	GOTO        L_main14
	MOVF        _cmd+0, 0 
	XORLW       53
	BTFSC       STATUS+0, 2 
	GOTO        L_main15
	MOVF        _cmd+0, 0 
	XORLW       54
	BTFSC       STATUS+0, 2 
	GOTO        L_main16
	MOVF        _cmd+0, 0 
	XORLW       55
	BTFSC       STATUS+0, 2 
	GOTO        L_main17
	MOVF        _cmd+0, 0 
	XORLW       56
	BTFSC       STATUS+0, 2 
	GOTO        L_main18
	MOVF        _cmd+0, 0 
	XORLW       57
	BTFSC       STATUS+0, 2 
	GOTO        L_main19
	MOVF        _cmd+0, 0 
	XORLW       109
	BTFSC       STATUS+0, 2 
	GOTO        L_main20
	GOTO        L_main21
L_main9:
;IR.c,175 :: 		}
	GOTO        L_main6
;IR.c,177 :: 		}
L_end_main:
	GOTO        $+0
; end of _main

_p_wait:

;IR.c,181 :: 		void p_wait(void){
;IR.c,182 :: 		UART1_Write_Text("Waiting for IR\r\n");
	MOVLW       ?lstr15_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr15_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,183 :: 		}
L_end_p_wait:
	RETURN      0
; end of _p_wait

_get_cmd:

;IR.c,186 :: 		char get_cmd(void){
;IR.c,189 :: 		retval = 0;                             // init
	CLRF        get_cmd_retval_L0+0 
;IR.c,190 :: 		while(!retval){                         // loop until something found
L_get_cmd24:
	MOVF        get_cmd_retval_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd25
;IR.c,191 :: 		if (UART1_Data_Ready()){              // anything received by UART?
	CALL        _UART1_Data_Ready+0, 0
	MOVF        R0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_cmd26
;IR.c,192 :: 		retval = UART1_Read();            // then get the character
	CALL        _UART1_Read+0, 0
	MOVF        R0, 0 
	MOVWF       get_cmd_retval_L0+0 
;IR.c,193 :: 		}
L_get_cmd26:
;IR.c,195 :: 		if(PORTD == 0x01) retval='0';         // button D0
	MOVF        PORTD+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd27
	MOVLW       48
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd27:
;IR.c,196 :: 		if(PORTD == 0x02) retval='1';         // button D1
	MOVF        PORTD+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd28
	MOVLW       49
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd28:
;IR.c,197 :: 		if(PORTD == 0x04) retval='2';         // button D2
	MOVF        PORTD+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd29
	MOVLW       50
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd29:
;IR.c,198 :: 		if(PORTD == 0x08) retval='3';         // button D3
	MOVF        PORTD+0, 0 
	XORLW       8
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd30
	MOVLW       51
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd30:
;IR.c,199 :: 		if(PORTD == 0x10) retval='4';         // button D4
	MOVF        PORTD+0, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd31
	MOVLW       52
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd31:
;IR.c,200 :: 		if(PORTD == 0x20) retval='5';         // button D5
	MOVF        PORTD+0, 0 
	XORLW       32
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd32
	MOVLW       53
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd32:
;IR.c,201 :: 		if(PORTD == 0x40) retval='6';         // button D6
	MOVF        PORTD+0, 0 
	XORLW       64
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd33
	MOVLW       54
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd33:
;IR.c,202 :: 		if(PORTD == 0x80) retval='7';         // button D7
	MOVF        PORTD+0, 0 
	XORLW       128
	BTFSS       STATUS+0, 2 
	GOTO        L_get_cmd34
	MOVLW       55
	MOVWF       get_cmd_retval_L0+0 
L_get_cmd34:
;IR.c,203 :: 		}
	GOTO        L_get_cmd24
L_get_cmd25:
;IR.c,204 :: 		return retval;                          // return ASCII character
	MOVF        get_cmd_retval_L0+0, 0 
	MOVWF       R0 
;IR.c,205 :: 		}
L_end_get_cmd:
	RETURN      0
; end of _get_cmd

_simple_ir:

;IR.c,207 :: 		void simple_ir(void){
;IR.c,208 :: 		UART1_Write_Text("\r\nwatch LED on RE0\r\n");
	MOVLW       ?lstr16_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr16_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,209 :: 		Lcd_Out(1,1, " Simple IR test ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr17_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr17_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,210 :: 		Lcd_Out(2,1, "watch LED on RE0");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr18_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr18_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,211 :: 		while(1){
L_simple_ir35:
;IR.c,212 :: 		if(ir_in){                          // read IR input
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_simple_ir37
;IR.c,213 :: 		LATE0_bit = 0;                   // LED off
	BCF         LATE0_bit+0, BitPos(LATE0_bit+0) 
;IR.c,214 :: 		}
	GOTO        L_simple_ir38
L_simple_ir37:
;IR.c,216 :: 		LATE0_bit = 1;                   // LED on
	BSF         LATE0_bit+0, BitPos(LATE0_bit+0) 
;IR.c,217 :: 		}
L_simple_ir38:
;IR.c,218 :: 		}
	GOTO        L_simple_ir35
;IR.c,219 :: 		}
L_end_simple_ir:
	RETURN      0
; end of _simple_ir

_timing_print:

;IR.c,222 :: 		void timing_print(void){
;IR.c,227 :: 		UART1_Write_Text("\r\nTiming print\r\n");
	MOVLW       ?lstr19_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr19_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,228 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,229 :: 		Lcd_Out(1,1, "timing to RS232 ");     // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr20_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr20_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,230 :: 		Lcd_Out(2,1, "  9600 8 n 1    ");     // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr21_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr21_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,231 :: 		while(ir_in);                            // wait for IR to go low
L_timing_print39:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_timing_print40
	GOTO        L_timing_print39
L_timing_print40:
;IR.c,233 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	CLRF        timing_print_ir_bit_L0+0 
L_timing_print41:
	MOVLW       31
	SUBWF       timing_print_ir_bit_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_timing_print42
;IR.c,234 :: 		TMR0H = 0;                           // zero timer 0
	CLRF        TMR0H+0 
;IR.c,235 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,236 :: 		while(!ir_in);                       // wait for IR to go high
L_timing_print44:
	BTFSC       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_timing_print45
	GOTO        L_timing_print44
L_timing_print45:
;IR.c,237 :: 		ir_mark[ir_bit] = TMR0L;             // read timer 0
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        TMR0L+0, 0 
	MOVWF       POSTINC1+0 
	MOVLW       0
	MOVWF       POSTINC1+0 
;IR.c,238 :: 		ir_mark[ir_bit] +=(TMR0H<<8);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVFF       R3, FSR0
	MOVFF       R4, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVFF       R3, FSR1
	MOVFF       R4, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;IR.c,239 :: 		TMR0H = 0;                           // zero timer 0
	CLRF        TMR0H+0 
;IR.c,240 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,241 :: 		while(ir_in);                        // wait for IR to go low
L_timing_print46:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_timing_print47
	GOTO        L_timing_print46
L_timing_print47:
;IR.c,242 :: 		ir_space[ir_bit] = TMR0L;            // read timer 0
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR1H 
	MOVF        TMR0L+0, 0 
	MOVWF       POSTINC1+0 
	MOVLW       0
	MOVWF       POSTINC1+0 
;IR.c,243 :: 		ir_space[ir_bit] += (TMR0H<<8);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       R3 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       R4 
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVFF       R3, FSR0
	MOVFF       R4, FSR0H
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVFF       R3, FSR1
	MOVFF       R4, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
	MOVF        R1, 0 
	MOVWF       POSTINC1+0 
;IR.c,233 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	INCF        timing_print_ir_bit_L0+0, 1 
;IR.c,244 :: 		}
	GOTO        L_timing_print41
L_timing_print42:
;IR.c,246 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	CLRF        timing_print_ir_bit_L0+0 
L_timing_print48:
	MOVLW       31
	SUBWF       timing_print_ir_bit_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_timing_print49
;IR.c,247 :: 		IntToStr(ir_bit,fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVLW       0
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,248 :: 		UART1_Write_Text("\r\nbit");
	MOVLW       ?lstr22_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr22_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,249 :: 		UART1_Write_Text(fb_string);         // print bit number
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,250 :: 		IntToStr(ir_mark[ir_bit],fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,251 :: 		UART1_Write_Text("   mark");
	MOVLW       ?lstr23_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr23_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,252 :: 		UART1_Write_Text(fb_string);         // print mark time
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,253 :: 		IntToStr(ir_space[ir_bit],fb_string);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,254 :: 		UART1_Write_Text("    space");
	MOVLW       ?lstr24_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr24_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,255 :: 		UART1_Write_Text(fb_string);         // print space time
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,257 :: 		UART1_Write_Text("   (");
	MOVLW       ?lstr25_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr25_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,258 :: 		print_ir_time(ir_mark[ir_bit]);      // convert T0 value to microseconds
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_mark_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_mark_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+1 
	CALL        _print_ir_time+0, 0
;IR.c,259 :: 		print_ir_time(ir_space[ir_bit]);
	MOVF        timing_print_ir_bit_L0+0, 0 
	MOVWF       R0 
	MOVLW       0
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVLW       timing_print_ir_space_L0+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(timing_print_ir_space_L0+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_print_ir_time_ir_time+1 
	CALL        _print_ir_time+0, 0
;IR.c,260 :: 		UART1_Write_Text(" uS)");
	MOVLW       ?lstr26_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr26_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,246 :: 		for( ir_bit=0 ; ir_bit<(NSAMPLES+1) ; ir_bit++){
	INCF        timing_print_ir_bit_L0+0, 1 
;IR.c,262 :: 		}
	GOTO        L_timing_print48
L_timing_print49:
;IR.c,263 :: 		UART1_Write_Text("\r\n\ndone\r\n");
	MOVLW       ?lstr27_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr27_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,264 :: 		}
L_end_timing_print:
	RETURN      0
; end of _timing_print

_print_ir_time:

;IR.c,268 :: 		void print_ir_time(unsigned int ir_time){
;IR.c,272 :: 		time_ul = ir_time;                        // int to long
	MOVF        FARG_print_ir_time_ir_time+0, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        FARG_print_ir_time_ir_time+1, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVLW       0
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,273 :: 		time_ul *= 65UL;
	MOVF        print_ir_time_time_ul_L0+0, 0 
	MOVWF       R0 
	MOVF        print_ir_time_time_ul_L0+1, 0 
	MOVWF       R1 
	MOVF        print_ir_time_time_ul_L0+2, 0 
	MOVWF       R2 
	MOVF        print_ir_time_time_ul_L0+3, 0 
	MOVWF       R3 
	MOVLW       65
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVLW       0
	MOVWF       R6 
	MOVLW       0
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        R1, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVF        R2, 0 
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVF        R3, 0 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,274 :: 		time_ul /= 4UL;
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	MOVF        R4, 0 
	MOVWF       print_ir_time_time_ul_L0+0 
	MOVF        R5, 0 
	MOVWF       print_ir_time_time_ul_L0+1 
	MOVF        R6, 0 
	MOVWF       print_ir_time_time_ul_L0+2 
	MOVF        R7, 0 
	MOVWF       print_ir_time_time_ul_L0+3 
;IR.c,276 :: 		IntToStr(time_ui,fb_string);              // convert to string
	MOVF        R4, 0 
	MOVWF       FARG_IntToStr_input+0 
	MOVF        R5, 0 
	MOVWF       FARG_IntToStr_input+1 
	MOVLW       _fb_string+0
	MOVWF       FARG_IntToStr_output+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_IntToStr_output+1 
	CALL        _IntToStr+0, 0
;IR.c,277 :: 		UART1_Write_Text(fb_string);              // and print it
	MOVLW       _fb_string+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(_fb_string+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,278 :: 		}
L_end_print_ir_time:
	RETURN      0
; end of _print_ir_time

_hexout:

;IR.c,281 :: 		void hexout(unsigned char hexval){
;IR.c,285 :: 		temp_hex = hexval;                     // to integer
	MOVF        FARG_hexout_hexval+0, 0 
	MOVWF       hexout_temp_hex_L0+0 
	MOVLW       0
	MOVWF       hexout_temp_hex_L0+1 
;IR.c,286 :: 		IntToHex(temp_hex, hextxt);            // integer to ASCII hex
	MOVF        hexout_temp_hex_L0+0, 0 
	MOVWF       FARG_IntToHex_input+0 
	MOVF        hexout_temp_hex_L0+1, 0 
	MOVWF       FARG_IntToHex_input+1 
	MOVLW       hexout_hextxt_L0+0
	MOVWF       FARG_IntToHex_output+0 
	MOVLW       hi_addr(hexout_hextxt_L0+0)
	MOVWF       FARG_IntToHex_output+1 
	CALL        _IntToHex+0, 0
;IR.c,287 :: 		UART1_Write_Text(hextxt+2);
	MOVLW       hexout_hextxt_L0+2
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(hexout_hextxt_L0+2)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,288 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr28_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr28_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,289 :: 		keephex[0] = hextxt[2];                // store ascii hex for later
	MOVF        hexout_hextxt_L0+2, 0 
	MOVWF       _keephex+0 
;IR.c,290 :: 		keephex[1] = hextxt[3];
	MOVF        hexout_hextxt_L0+3, 0 
	MOVWF       _keephex+1 
;IR.c,291 :: 		keephex[2] = 0;                        // null terminate
	CLRF        _keephex+2 
;IR.c,292 :: 		}
L_end_hexout:
	RETURN      0
; end of _hexout

_nec_print:

;IR.c,306 :: 		void nec_print(void){
;IR.c,310 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,311 :: 		Lcd_Out(1,1, "NEC protocol IR ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr29_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr29_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,312 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr30_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr30_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,314 :: 		while(1){
L_nec_print51:
;IR.c,315 :: 		while(ir_in);                         // wait for IR to go low
L_nec_print53:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_nec_print54
	GOTO        L_nec_print53
L_nec_print54:
;IR.c,317 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       nec_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       nec_print_temp_ir_L0+1 
;IR.c,318 :: 		if ((temp_ir > 500) && (temp_ir < 800)){       // expect 9mS mark
	MOVLW       128
	XORLW       1
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print281
	MOVF        R0, 0 
	SUBLW       244
L__nec_print281:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print57
	MOVLW       128
	XORWF       nec_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       3
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print282
	MOVLW       32
	SUBWF       nec_print_temp_ir_L0+0, 0 
L__nec_print282:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print57
L__nec_print256:
;IR.c,319 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       nec_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       nec_print_temp_ir_L0+1 
;IR.c,320 :: 		if ((temp_ir > 200) && (temp_ir < 400)){   // expect 4.5mS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print283
	MOVF        R0, 0 
	SUBLW       200
L__nec_print283:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print60
	MOVLW       128
	XORWF       nec_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__nec_print284
	MOVLW       144
	SUBWF       nec_print_temp_ir_L0+0, 0 
L__nec_print284:
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print60
L__nec_print255:
;IR.c,321 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
	CLRF        nec_print_count_byte_L0+0 
L_nec_print61:
	MOVLW       4
	SUBWF       nec_print_count_byte_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print62
;IR.c,322 :: 		ir_result[count_byte] = get_nec_byte();
	MOVLW       _ir_result+0
	MOVWF       FLOC__nec_print+0 
	MOVLW       hi_addr(_ir_result+0)
	MOVWF       FLOC__nec_print+1 
	MOVF        nec_print_count_byte_L0+0, 0 
	ADDWF       FLOC__nec_print+0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FLOC__nec_print+1, 1 
	CALL        _get_nec_byte+0, 0
	MOVFF       FLOC__nec_print+0, FSR1
	MOVFF       FLOC__nec_print+1, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;IR.c,321 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++ ){
	INCF        nec_print_count_byte_L0+0, 1 
;IR.c,323 :: 		}
	GOTO        L_nec_print61
L_nec_print62:
;IR.c,324 :: 		}
L_nec_print60:
;IR.c,325 :: 		UART1_Write_Text("\r\nNEC ");
	MOVLW       ?lstr31_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr31_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,326 :: 		Lcd_Out(2,1, "NEC            ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr32_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr32_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,327 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++){
	CLRF        nec_print_count_byte_L0+0 
L_nec_print64:
	MOVLW       4
	SUBWF       nec_print_count_byte_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_nec_print65
;IR.c,328 :: 		hexout(ir_result[count_byte]);
	MOVLW       _ir_result+0
	MOVWF       FSR0 
	MOVLW       hi_addr(_ir_result+0)
	MOVWF       FSR0H 
	MOVF        nec_print_count_byte_L0+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,329 :: 		Lcd_Chr(2,(count_byte * 3)+5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MULWF       nec_print_count_byte_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       5
	ADDWF       FARG_Lcd_Chr_column+0, 1 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,330 :: 		Lcd_Chr(2,(count_byte * 3)+6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MULWF       nec_print_count_byte_L0+0 
	MOVF        PRODL+0, 0 
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       6
	ADDWF       FARG_Lcd_Chr_column+0, 1 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,327 :: 		for(count_byte = 0 ; count_byte < 4 ; count_byte++){
	INCF        nec_print_count_byte_L0+0, 1 
;IR.c,331 :: 		}
	GOTO        L_nec_print64
L_nec_print65:
;IR.c,332 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_nec_print67:
	DECFSZ      R13, 1, 1
	BRA         L_nec_print67
	DECFSZ      R12, 1, 1
	BRA         L_nec_print67
	NOP
;IR.c,333 :: 		}
L_nec_print57:
;IR.c,334 :: 		}
	GOTO        L_nec_print51
;IR.c,336 :: 		}
L_end_nec_print:
	RETURN      0
; end of _nec_print

_get_nec_byte:

;IR.c,339 :: 		unsigned char get_nec_byte(void){
;IR.c,344 :: 		for(n=0 ; n<8 ; n++){
	CLRF        get_nec_byte_n_L0+0 
L_get_nec_byte68:
	MOVLW       8
	SUBWF       get_nec_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_nec_byte69
;IR.c,345 :: 		temp_ir = get_mark();                         // expect ~600uS
	CALL        _get_mark+0, 0
;IR.c,346 :: 		temp_ir = get_space();                        // 500uS = 0, 1.6uS = 1
	CALL        _get_space+0, 0
;IR.c,347 :: 		ir_byte >>= 1;                                // shift in a zero
	RRCF        get_nec_byte_ir_byte_L0+0, 1 
	BCF         get_nec_byte_ir_byte_L0+0, 7 
;IR.c,348 :: 		if (temp_ir > 70){                            // check > 900uS
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_nec_byte286
	MOVF        R0, 0 
	SUBLW       70
L__get_nec_byte286:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_nec_byte71
;IR.c,349 :: 		ir_byte += 0x80;                          // change 0 to a 1 if so
	MOVLW       128
	ADDWF       get_nec_byte_ir_byte_L0+0, 1 
;IR.c,350 :: 		}
L_get_nec_byte71:
;IR.c,344 :: 		for(n=0 ; n<8 ; n++){
	INCF        get_nec_byte_n_L0+0, 1 
;IR.c,351 :: 		}
	GOTO        L_get_nec_byte68
L_get_nec_byte69:
;IR.c,352 :: 		return ir_byte;                                   // return final byte
	MOVF        get_nec_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,353 :: 		}
L_end_get_nec_byte:
	RETURN      0
; end of _get_nec_byte

_get_mark:

;IR.c,356 :: 		int get_mark(void){
;IR.c,357 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IR.c,358 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,359 :: 		while(!ir_in);                       // wait for IR to go high
L_get_mark72:
	BTFSC       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_get_mark73
	GOTO        L_get_mark72
L_get_mark73:
;IR.c,360 :: 		LATE.F0 = 0;                         // LED off
	BCF         LATE+0, 0 
;IR.c,361 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IR.c,362 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IR.c,363 :: 		return retint;
;IR.c,364 :: 		}
L_end_get_mark:
	RETURN      0
; end of _get_mark

_get_space:

;IR.c,367 :: 		int get_space(void){
;IR.c,368 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IR.c,369 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,370 :: 		while(ir_in);                        // wait for IR to go low
L_get_space74:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_get_space75
	GOTO        L_get_space74
L_get_space75:
;IR.c,371 :: 		LATE.F0 = 1;                         // LED on
	BSF         LATE+0, 0 
;IR.c,372 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IR.c,373 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        _retint+0, 0 
	ADDWF       R0, 1 
	MOVF        _retint+1, 0 
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	MOVWF       _retint+0 
	MOVF        R1, 0 
	MOVWF       _retint+1 
;IR.c,374 :: 		return retint;
;IR.c,375 :: 		}
L_end_get_space:
	RETURN      0
; end of _get_space

_get_quiet:

;IR.c,378 :: 		void get_quiet(void){
;IR.c,381 :: 		quiet_flag = 1;
	MOVLW       1
	MOVWF       R4 
;IR.c,382 :: 		TMR0H = 0;
	CLRF        TMR0H+0 
;IR.c,383 :: 		TMR0L = 0;
	CLRF        TMR0L+0 
;IR.c,384 :: 		while(quiet_flag){                        // wait for long quiet time
L_get_quiet76:
	MOVF        R4, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_quiet77
;IR.c,385 :: 		retint = TMR0L;
	MOVF        TMR0L+0, 0 
	MOVWF       _retint+0 
	MOVLW       0
	MOVWF       _retint+1 
;IR.c,386 :: 		retint += (TMR0H<<8);
	MOVF        TMR0H+0, 0 
	MOVWF       R1 
	CLRF        R0 
	MOVF        R0, 0 
	ADDWF       _retint+0, 0 
	MOVWF       R2 
	MOVF        R1, 0 
	ADDWFC      _retint+1, 0 
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       _retint+0 
	MOVF        R3, 0 
	MOVWF       _retint+1 
;IR.c,387 :: 		if (retint > 0x4000){
	MOVF        R3, 0 
	SUBLW       64
	BTFSS       STATUS+0, 2 
	GOTO        L__get_quiet290
	MOVF        R2, 0 
	SUBLW       0
L__get_quiet290:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_quiet78
;IR.c,388 :: 		quiet_flag = 0;
	CLRF        R4 
;IR.c,389 :: 		}
L_get_quiet78:
;IR.c,390 :: 		}
	GOTO        L_get_quiet76
L_get_quiet77:
;IR.c,391 :: 		}
L_end_get_quiet:
	RETURN      0
; end of _get_quiet

_sharp_print:

;IR.c,403 :: 		void sharp_print(void)
;IR.c,407 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,408 :: 		Lcd_Out(1,1, "Sharp protocol  ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr34_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr34_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,409 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr35_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr35_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,411 :: 		while(1){
L_sharp_print79:
;IR.c,412 :: 		while(ir_in);                         // wait for IR to go low
L_sharp_print81:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_sharp_print82
	GOTO        L_sharp_print81
L_sharp_print82:
;IR.c,414 :: 		ir_result[0] = get_sharp_byte(5);         // 5 bit address
	MOVLW       5
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,415 :: 		ir_result[1] = get_sharp_byte(8);         // 8 bit command
	MOVLW       8
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,416 :: 		ir_result[2] = get_sharp_byte(2);         // 2 bits extension or check
	MOVLW       2
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,417 :: 		ir_result[3] = get_sharp_byte(1);         // 1 bit inter-message gap
	MOVLW       1
	MOVWF       FARG_get_sharp_byte_nbits+0 
	CALL        _get_sharp_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,418 :: 		if(ir_result[2]==1){                      // is this a data message?
	MOVF        _ir_result+2, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_sharp_print83
;IR.c,419 :: 		UART1_Write_Text("   add=");
	MOVLW       ?lstr36_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr36_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,420 :: 		Lcd_Out(2,1, "add=   cmd=     ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr37_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr37_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,421 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,422 :: 		Lcd_Chr(2,5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,423 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,424 :: 		UART1_Write_Text(" cmd=");
	MOVLW       ?lstr38_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr38_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,425 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,426 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,427 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,428 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr39_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr39_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,429 :: 		}
L_sharp_print83:
;IR.c,430 :: 		Delay_ms(400);                           // allow repeat messages to be lost
	MOVLW       17
	MOVWF       R11, 0
	MOVLW       60
	MOVWF       R12, 0
	MOVLW       203
	MOVWF       R13, 0
L_sharp_print84:
	DECFSZ      R13, 1, 1
	BRA         L_sharp_print84
	DECFSZ      R12, 1, 1
	BRA         L_sharp_print84
	DECFSZ      R11, 1, 1
	BRA         L_sharp_print84
;IR.c,431 :: 		}
	GOTO        L_sharp_print79
;IR.c,432 :: 		}
L_end_sharp_print:
	RETURN      0
; end of _sharp_print

_get_sharp_byte:

;IR.c,435 :: 		unsigned char get_sharp_byte(char nbits){
;IR.c,440 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sharp_byte_ir_byte_L0+0 
;IR.c,441 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_sharp_byte_n_L0+0 
L_get_sharp_byte85:
	MOVF        FARG_get_sharp_byte_nbits+0, 0 
	SUBWF       get_sharp_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sharp_byte86
;IR.c,442 :: 		temp_ir = get_mark();                     // expect ~320uS
	CALL        _get_mark+0, 0
;IR.c,443 :: 		temp_ir = get_space();                    // 680uS = 0, 1680uS = 1
	CALL        _get_space+0, 0
;IR.c,444 :: 		ir_byte >>= 1;
	RRCF        get_sharp_byte_ir_byte_L0+0, 1 
	BCF         get_sharp_byte_ir_byte_L0+0, 7 
;IR.c,445 :: 		if (temp_ir > 70){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sharp_byte293
	MOVF        R0, 0 
	SUBLW       70
L__get_sharp_byte293:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sharp_byte88
;IR.c,446 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sharp_byte_ir_byte_L0+0, 1 
;IR.c,447 :: 		}
L_get_sharp_byte88:
;IR.c,441 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_sharp_byte_n_L0+0, 1 
;IR.c,448 :: 		}
	GOTO        L_get_sharp_byte85
L_get_sharp_byte86:
;IR.c,449 :: 		ir_byte >>= 8-nbits;                          // convert 1/2/5/8 bits to 8
	MOVF        FARG_get_sharp_byte_nbits+0, 0 
	SUBLW       8
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVF        get_sharp_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__get_sharp_byte294:
	BZ          L__get_sharp_byte295
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L__get_sharp_byte294
L__get_sharp_byte295:
	MOVF        R0, 0 
	MOVWF       get_sharp_byte_ir_byte_L0+0 
;IR.c,450 :: 		return ir_byte;
;IR.c,451 :: 		}
L_end_get_sharp_byte:
	RETURN      0
; end of _get_sharp_byte

_sony_print:

;IR.c,475 :: 		void sony_print(void){
;IR.c,478 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,479 :: 		Lcd_Out(1,1, "Sony protocol   ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr40_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr40_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,480 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr41_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr41_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,482 :: 		while(1){
L_sony_print89:
;IR.c,483 :: 		while(ir_in);                         // wait for IR to go low
L_sony_print91:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_sony_print92
	GOTO        L_sony_print91
L_sony_print92:
;IR.c,485 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sony_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sony_print_temp_ir_L0+1 
;IR.c,486 :: 		if ((temp_ir > 150) && (temp_ir < 200)){       // expect 2.4mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_print297
	MOVF        R0, 0 
	SUBLW       150
L__sony_print297:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_print95
	MOVLW       128
	XORWF       sony_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sony_print298
	MOVLW       200
	SUBWF       sony_print_temp_ir_L0+0, 0 
L__sony_print298:
	BTFSC       STATUS+0, 0 
	GOTO        L_sony_print95
L__sony_print257:
;IR.c,487 :: 		ir_result[0] = get_sony_byte(7);           // 7 bit command
	MOVLW       7
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,488 :: 		ir_result[1] = get_sony_byte(5);           // 5 bit address
	MOVLW       5
	MOVWF       FARG_get_sony_byte_nbits+0 
	CALL        _get_sony_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,489 :: 		UART1_Write_Text("\r\nSony cmd=");
	MOVLW       ?lstr42_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr42_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,490 :: 		Lcd_Out(2,1, "cmd=   addr=    ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr43_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr43_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,491 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,492 :: 		Lcd_Chr(2,5,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       5
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,493 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,494 :: 		UART1_Write_Text(" addr=");
	MOVLW       ?lstr44_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr44_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,495 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,496 :: 		Lcd_Chr(2,13,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,497 :: 		Lcd_Chr(2,14,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,498 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sony_print96:
	DECFSZ      R13, 1, 1
	BRA         L_sony_print96
	DECFSZ      R12, 1, 1
	BRA         L_sony_print96
	NOP
;IR.c,499 :: 		}
L_sony_print95:
;IR.c,500 :: 		}
	GOTO        L_sony_print89
;IR.c,502 :: 		}
L_end_sony_print:
	RETURN      0
; end of _sony_print

_get_sony_byte:

;IR.c,505 :: 		unsigned char get_sony_byte(char nbits){
;IR.c,510 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sony_byte_ir_byte_L0+0 
;IR.c,511 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_sony_byte_n_L0+0 
L_get_sony_byte97:
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBWF       get_sony_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte98
;IR.c,512 :: 		temp_ir = get_space();                    // expect ~510uS
	CALL        _get_space+0, 0
;IR.c,513 :: 		temp_ir = get_mark();                     // 650uS = 0, 1.2uS = 1
	CALL        _get_mark+0, 0
;IR.c,514 :: 		ir_byte >>= 1;
	RRCF        get_sony_byte_ir_byte_L0+0, 1 
	BCF         get_sony_byte_ir_byte_L0+0, 7 
;IR.c,515 :: 		if (temp_ir > 60){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sony_byte300
	MOVF        R0, 0 
	SUBLW       60
L__get_sony_byte300:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sony_byte100
;IR.c,516 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sony_byte_ir_byte_L0+0, 1 
;IR.c,517 :: 		}
L_get_sony_byte100:
;IR.c,511 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_sony_byte_n_L0+0, 1 
;IR.c,518 :: 		}
	GOTO        L_get_sony_byte97
L_get_sony_byte98:
;IR.c,519 :: 		ir_byte >>= 8-nbits;                          // convert 5/7 bits to 8
	MOVF        FARG_get_sony_byte_nbits+0, 0 
	SUBLW       8
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	SUBWFB      R1, 1 
	MOVF        R0, 0 
	MOVWF       R1 
	MOVF        get_sony_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
	MOVF        R1, 0 
L__get_sony_byte301:
	BZ          L__get_sony_byte302
	RRCF        R0, 1 
	BCF         R0, 7 
	ADDLW       255
	GOTO        L__get_sony_byte301
L__get_sony_byte302:
	MOVF        R0, 0 
	MOVWF       get_sony_byte_ir_byte_L0+0 
;IR.c,520 :: 		return ir_byte;
;IR.c,521 :: 		}
L_end_get_sony_byte:
	RETURN      0
; end of _get_sony_byte

_sam_print:

;IR.c,531 :: 		void sam_print(void){
;IR.c,534 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,535 :: 		Lcd_Out(1,1, "Samsung protocol");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr46_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr46_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,536 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr47_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr47_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,538 :: 		while(1){
L_sam_print101:
;IR.c,539 :: 		while(ir_in);                         // wait for IR to go low
L_sam_print103:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_sam_print104
	GOTO        L_sam_print103
L_sam_print104:
;IR.c,541 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sam_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sam_print_temp_ir_L0+1 
;IR.c,542 :: 		ir_result[4] = get_space();                   // throw away the result
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+4 
;IR.c,543 :: 		if ((temp_ir > 200) && (temp_ir < 350)){       // expect 4.5mS mark
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       sam_print_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sam_print304
	MOVF        sam_print_temp_ir_L0+0, 0 
	SUBLW       200
L__sam_print304:
	BTFSC       STATUS+0, 0 
	GOTO        L_sam_print107
	MOVLW       128
	XORWF       sam_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sam_print305
	MOVLW       94
	SUBWF       sam_print_temp_ir_L0+0, 0 
L__sam_print305:
	BTFSC       STATUS+0, 0 
	GOTO        L_sam_print107
L__sam_print258:
;IR.c,544 :: 		ir_result[0] = get_sam_byte();            // 8 bits custom byte
	CALL        _get_sam_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,545 :: 		ir_result[1] = get_sam_byte();            // 8 bits custom byte
	CALL        _get_sam_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,546 :: 		ir_result[2] = get_sam_byte();            // 8 bits data byte
	CALL        _get_sam_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,547 :: 		ir_result[3] = get_sam_byte();            // 8 bits data byte inverted
	CALL        _get_sam_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,548 :: 		UART1_Write_Text("\r\nSam ");
	MOVLW       ?lstr48_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr48_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,549 :: 		Lcd_Out(2,1, "c   c   d   d~  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr49_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr49_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,550 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,551 :: 		Lcd_Chr(2,2,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,552 :: 		Lcd_Chr(2,3,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,553 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,554 :: 		Lcd_Chr(2,6,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,555 :: 		Lcd_Chr(2,7,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       7
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,556 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,557 :: 		Lcd_Chr(2,10,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,558 :: 		Lcd_Chr(2,11,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,559 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,560 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,561 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,562 :: 		Delay_ms(10);             // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sam_print108:
	DECFSZ      R13, 1, 1
	BRA         L_sam_print108
	DECFSZ      R12, 1, 1
	BRA         L_sam_print108
	NOP
;IR.c,563 :: 		}
L_sam_print107:
;IR.c,564 :: 		}
	GOTO        L_sam_print101
;IR.c,566 :: 		}
L_end_sam_print:
	RETURN      0
; end of _sam_print

_get_sam_byte:

;IR.c,569 :: 		unsigned char get_sam_byte(void){
;IR.c,574 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_sam_byte_ir_byte_L0+0 
;IR.c,575 :: 		for(n=0 ; n<8 ; n++){
	CLRF        get_sam_byte_n_L0+0 
L_get_sam_byte109:
	MOVLW       8
	SUBWF       get_sam_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sam_byte110
;IR.c,576 :: 		temp_ir = get_mark();                    // expect ~300uS
	CALL        _get_mark+0, 0
;IR.c,577 :: 		temp_ir = get_space();                     // 450uS = 0, 1.4uS = 1
	CALL        _get_space+0, 0
;IR.c,578 :: 		ir_byte >>= 1;
	RRCF        get_sam_byte_ir_byte_L0+0, 1 
	BCF         get_sam_byte_ir_byte_L0+0, 7 
;IR.c,579 :: 		if (temp_ir > 60){                        //
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_sam_byte307
	MOVF        R0, 0 
	SUBLW       60
L__get_sam_byte307:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_sam_byte112
;IR.c,580 :: 		ir_byte += 0x80;
	MOVLW       128
	ADDWF       get_sam_byte_ir_byte_L0+0, 1 
;IR.c,581 :: 		}
L_get_sam_byte112:
;IR.c,575 :: 		for(n=0 ; n<8 ; n++){
	INCF        get_sam_byte_n_L0+0, 1 
;IR.c,582 :: 		}
	GOTO        L_get_sam_byte109
L_get_sam_byte110:
;IR.c,583 :: 		return ir_byte;
	MOVF        get_sam_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,584 :: 		}
L_end_get_sam_byte:
	RETURN      0
; end of _get_sam_byte

_rc5_print:

;IR.c,594 :: 		void rc5_print(void){
;IR.c,599 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,600 :: 		Lcd_Out(1,1, "RC5 protocol IR ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr51_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr51_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,601 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr52_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr52_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,603 :: 		while(1){
L_rc5_print113:
;IR.c,604 :: 		while(ir_in);                         // wait for IR to go low
L_rc5_print115:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_rc5_print116
	GOTO        L_rc5_print115
L_rc5_print116:
;IR.c,606 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,607 :: 		irnowm = 0;                                    // init
	CLRF        _irnowm+0 
;IR.c,608 :: 		temp_ir = get_mark();                          // second half of start bit 1
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc5_print_temp_ir_L0+1 
;IR.c,609 :: 		if ((temp_ir > 40) && (temp_ir < 80)){         // expect 890uS mark start bit1
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_print309
	MOVF        R0, 0 
	SUBLW       40
L__rc5_print309:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_print119
	MOVLW       128
	XORWF       rc5_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc5_print310
	MOVLW       80
	SUBWF       rc5_print_temp_ir_L0+0, 0 
L__rc5_print310:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc5_print119
L__rc5_print259:
;IR.c,610 :: 		rc5_byte1 = get_rc5_byte(7);               // start bit2 '1' + toggle + 5 bit address
	MOVLW       7
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_rc5_byte1_L0+0 
;IR.c,611 :: 		rc5_byte2 = get_rc5_byte(6);               // 6 bit command
	MOVLW       6
	MOVWF       FARG_get_rc5_byte_nbits+0 
	CALL        _get_rc5_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc5_print_rc5_byte2_L0+0 
;IR.c,612 :: 		UART1_Write_Text("\r\nrc5");
	MOVLW       ?lstr53_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr53_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,613 :: 		Lcd_Out(2,1, "t=0 ad=   cmd=  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr54_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr54_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,614 :: 		if (rc5_byte1 & 0x20){
	BTFSS       rc5_print_rc5_byte1_L0+0, 5 
	GOTO        L_rc5_print120
;IR.c,615 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr55_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr55_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,616 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,617 :: 		}
	GOTO        L_rc5_print121
L_rc5_print120:
;IR.c,619 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr56_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr56_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,620 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,621 :: 		}
L_rc5_print121:
;IR.c,622 :: 		UART1_Write_Text(" addr=");
	MOVLW       ?lstr57_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr57_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,623 :: 		hexout(rc5_byte1 & 0x1F);                  // 5 bits address
	MOVLW       31
	ANDWF       rc5_print_rc5_byte1_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,624 :: 		Lcd_Chr(2,8,keephex[0]);                   // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,625 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,626 :: 		UART1_Write_Text(" cmd=");
	MOVLW       ?lstr58_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr58_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,627 :: 		hexout(rc5_byte2);
	MOVF        rc5_print_rc5_byte2_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,628 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,629 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,630 :: 		Delay_ms(100);                              // wait for repeat messages to clear
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_rc5_print122:
	DECFSZ      R13, 1, 1
	BRA         L_rc5_print122
	DECFSZ      R12, 1, 1
	BRA         L_rc5_print122
	DECFSZ      R11, 1, 1
	BRA         L_rc5_print122
;IR.c,631 :: 		}
L_rc5_print119:
;IR.c,632 :: 		}
	GOTO        L_rc5_print113
;IR.c,634 :: 		}
L_end_rc5_print:
	RETURN      0
; end of _rc5_print

_get_rc5_byte:

;IR.c,637 :: 		unsigned char get_rc5_byte(char nbits){
;IR.c,640 :: 		irbyte = 0;                                  // initialise
	CLRF        _irbyte+0 
;IR.c,641 :: 		for(n = 0 ; n < nbits ; n++){
	CLRF        get_rc5_byte_n_L0+0 
L_get_rc5_byte123:
	MOVF        FARG_get_rc5_byte_nbits+0, 0 
	SUBWF       get_rc5_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_rc5_byte124
;IR.c,642 :: 		getrc5bit();
	CALL        _getrc5bit+0, 0
;IR.c,641 :: 		for(n = 0 ; n < nbits ; n++){
	INCF        get_rc5_byte_n_L0+0, 1 
;IR.c,643 :: 		}
	GOTO        L_get_rc5_byte123
L_get_rc5_byte124:
;IR.c,644 :: 		return irbyte;
	MOVF        _irbyte+0, 0 
	MOVWF       R0 
;IR.c,645 :: 		}
L_end_get_rc5_byte:
	RETURN      0
; end of _get_rc5_byte

_getrc5bit:

;IR.c,648 :: 		void getrc5bit(void){
;IR.c,650 :: 		if(!irnowm){
	MOVF        _irnowm+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit126
;IR.c,652 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit127
;IR.c,654 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,655 :: 		temp_bit_s = get_space();                         // get 1st half of bit
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,656 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,657 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,658 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit313
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit313:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit128
	CLRF        _irwas2t+0 
L_getrc5bit128:
;IR.c,659 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,660 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,661 :: 		}
	GOTO        L_getrc5bit129
L_getrc5bit127:
;IR.c,664 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,665 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,666 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,667 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit314
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit314:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit130
	CLRF        _irwas2t+0 
L_getrc5bit130:
;IR.c,668 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,669 :: 		}
L_getrc5bit129:
;IR.c,670 :: 		}
	GOTO        L_getrc5bit131
L_getrc5bit126:
;IR.c,673 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc5bit132
;IR.c,675 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,676 :: 		temp_bit_m = get_mark();                          // get 1st half of bit
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,677 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,678 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,679 :: 		if(temp_bit_s < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit315
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit315:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit133
	CLRF        _irwas2t+0 
L_getrc5bit133:
;IR.c,680 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,681 :: 		}
	GOTO        L_getrc5bit134
L_getrc5bit132:
;IR.c,684 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,685 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,686 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,687 :: 		if(temp_bit_m < 80) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc5bit316
	MOVLW       80
	SUBWF       R0, 0 
L__getrc5bit316:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc5bit135
	CLRF        _irwas2t+0 
L_getrc5bit135:
;IR.c,688 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,689 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,690 :: 		}
L_getrc5bit134:
;IR.c,691 :: 		}
L_getrc5bit131:
;IR.c,692 :: 		}
L_end_getrc5bit:
	RETURN      0
; end of _getrc5bit

_rc6_print:

;IR.c,705 :: 		void rc6_print(void){
;IR.c,710 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,711 :: 		Lcd_Out(1,1, "RC6m0, RC6m6-32 ");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr60_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr60_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,712 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr61_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr61_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,714 :: 		while(1){
L_rc6_print136:
;IR.c,715 :: 		while(ir_in);                         // wait for IR to go low
L_rc6_print138:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_rc6_print139
	GOTO        L_rc6_print138
L_rc6_print139:
;IR.c,718 :: 		leader6 = 0;        // init
	CLRF        rc6_print_leader6_L0+0 
;IR.c,720 :: 		while(!leader6){
L_rc6_print140:
	MOVF        rc6_print_leader6_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print141
;IR.c,721 :: 		temp_ir = get_mark();                      // get leader
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,722 :: 		if ((temp_ir > 140) && (temp_ir < 200)){   // expect 2.66mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print318
	MOVF        R0, 0 
	SUBLW       140
L__rc6_print318:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print144
	MOVLW       128
	XORWF       rc6_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print319
	MOVLW       200
	SUBWF       rc6_print_temp_ir_L0+0, 0 
L__rc6_print319:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print144
L__rc6_print261:
;IR.c,723 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,724 :: 		if ((temp_ir > 40) && (temp_ir < 60)){   // expect 889uS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print320
	MOVF        R0, 0 
	SUBLW       40
L__rc6_print320:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print147
	MOVLW       128
	XORWF       rc6_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print321
	MOVLW       60
	SUBWF       rc6_print_temp_ir_L0+0, 0 
L__rc6_print321:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print147
L__rc6_print260:
;IR.c,725 :: 		leader6 = 1;                           // leader found - allow exit loop
	MOVLW       1
	MOVWF       rc6_print_leader6_L0+0 
;IR.c,726 :: 		}
L_rc6_print147:
;IR.c,727 :: 		}
L_rc6_print144:
;IR.c,728 :: 		}
	GOTO        L_rc6_print140
L_rc6_print141:
;IR.c,730 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,731 :: 		irnowm = 0xff;                                 // init
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,732 :: 		rc6_mode = get_rc6_byte(4);                    // start bit2 '1' + 3 bits mode
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_rc6_mode_L0+0 
;IR.c,733 :: 		rc6_mode &= 0x07;                              // remove start bit '1' to leave 3 bits mode
	MOVLW       7
	ANDWF       R0, 0 
	MOVWF       rc6_print_rc6_mode_L0+0 
;IR.c,736 :: 		if (irwas2t){                                  // actually detecting 3t, single toggle bit is double size
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print148
;IR.c,737 :: 		ir_toggle = 1;                             // have found a trailer / toggle bit of 1
	MOVLW       1
	MOVWF       _ir_toggle+0 
;IR.c,738 :: 		irnowm = 0;                                // leave in space state
	CLRF        _irnowm+0 
;IR.c,739 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,740 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,741 :: 		if(temp_bit_s < 70){
	MOVLW       128
	XORWF       _temp_bit_s+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print322
	MOVLW       70
	SUBWF       _temp_bit_s+0, 0 
L__rc6_print322:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print149
;IR.c,742 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,743 :: 		}
L_rc6_print149:
;IR.c,744 :: 		}
	GOTO        L_rc6_print150
L_rc6_print148:
;IR.c,746 :: 		ir_toggle = 0;                             // have found a trailer / toggle bit of 0
	CLRF        _ir_toggle+0 
;IR.c,747 :: 		irnowm = 0xff;                             // leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,748 :: 		temp_ir = get_space();                     // skip over the space
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,749 :: 		temp_ir = get_mark();                      // read the mark
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       rc6_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       rc6_print_temp_ir_L0+1 
;IR.c,750 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,751 :: 		if(temp_bit_m < 70){
	MOVLW       128
	XORWF       _temp_bit_m+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__rc6_print323
	MOVLW       70
	SUBWF       _temp_bit_m+0, 0 
L__rc6_print323:
	BTFSC       STATUS+0, 0 
	GOTO        L_rc6_print151
;IR.c,752 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,753 :: 		}
L_rc6_print151:
;IR.c,754 :: 		}
L_rc6_print150:
;IR.c,756 :: 		if (rc6_mode == 0){
	MOVF        rc6_print_rc6_mode_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print152
;IR.c,758 :: 		ir_result[1] = get_rc6_byte(8);            // control byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,759 :: 		ir_result[2] = get_rc6_byte(8);            // information byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,761 :: 		UART1_Write_Text("rc6 mode 0");
	MOVLW       ?lstr62_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr62_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,762 :: 		Lcd_Out(1,1, "RC6 mode 0      ");          // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr63_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr63_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,763 :: 		Lcd_Out(2,1, "t=0 ct=   inf=  ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr64_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr64_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,764 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print153
;IR.c,765 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr65_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr65_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,766 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,767 :: 		}
	GOTO        L_rc6_print154
L_rc6_print153:
;IR.c,769 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr66_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr66_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,770 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,771 :: 		}
L_rc6_print154:
;IR.c,772 :: 		UART1_Write_Text(" ctrl=");
	MOVLW       ?lstr67_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr67_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,773 :: 		hexout(ir_result[1]);                      // 8 bits control byte
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,774 :: 		Lcd_Chr(2,8,keephex[0]);                   // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,775 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,776 :: 		UART1_Write_Text(" inf=");
	MOVLW       ?lstr68_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr68_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,777 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,778 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,779 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,780 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_rc6_print155:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_print155
	DECFSZ      R12, 1, 1
	BRA         L_rc6_print155
	NOP
;IR.c,781 :: 		}
L_rc6_print152:
;IR.c,783 :: 		if (rc6_mode == 6){
	MOVF        rc6_print_rc6_mode_L0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print156
;IR.c,785 :: 		ir_result[1] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,786 :: 		ir_result[2] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,787 :: 		ir_result[3] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,788 :: 		ir_result[4] = get_rc6_byte(7);               // only 7 bits of byte
	MOVLW       7
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+4 
;IR.c,790 :: 		ir_result[4] <<= 1;                           // leave room for last bit
	MOVF        R0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       _ir_result+4 
;IR.c,791 :: 		if (ir_result[4] & 0x02){                     // penultimate bit was 1
	BTFSS       R1, 1 
	GOTO        L_rc6_print157
;IR.c,792 :: 		if (!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_rc6_print158
;IR.c,793 :: 		ir_result[4]++;                       // last bit must be 1
	INCF        _ir_result+4, 1 
;IR.c,794 :: 		}
L_rc6_print158:
;IR.c,795 :: 		get_mark();
	CALL        _get_mark+0, 0
;IR.c,796 :: 		}
	GOTO        L_rc6_print159
L_rc6_print157:
;IR.c,798 :: 		if (irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print160
;IR.c,799 :: 		ir_result[4]++;                       // last bit must be 1
	INCF        _ir_result+4, 1 
;IR.c,800 :: 		}
	GOTO        L_rc6_print161
L_rc6_print160:
;IR.c,803 :: 		}
L_rc6_print161:
;IR.c,804 :: 		}
L_rc6_print159:
;IR.c,806 :: 		UART1_Write_Text("rc6 mode 6-32 and MCE");
	MOVLW       ?lstr69_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr69_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,807 :: 		Lcd_Out(1,1, "RC6 m6-32 (&MCE)");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr70_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr70_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,808 :: 		Lcd_Out(2,1, "t=0             ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr71_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr71_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,809 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_rc6_print162
;IR.c,810 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr72_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr72_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,811 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,812 :: 		}
	GOTO        L_rc6_print163
L_rc6_print162:
;IR.c,814 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr73_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr73_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,815 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,816 :: 		}
L_rc6_print163:
;IR.c,817 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr74_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr74_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,818 :: 		hexout(ir_result[1]);                         // 4 bits
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,819 :: 		Lcd_Chr(2,8,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,820 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,821 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,822 :: 		Lcd_Chr(2,10,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,823 :: 		Lcd_Chr(2,11,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,824 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,825 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,826 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,827 :: 		hexout(ir_result[4]);
	MOVF        _ir_result+4, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,828 :: 		Lcd_Chr(2,14,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,829 :: 		Lcd_Chr(2,15,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,830 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_rc6_print164:
	DECFSZ      R13, 1, 1
	BRA         L_rc6_print164
	DECFSZ      R12, 1, 1
	BRA         L_rc6_print164
	NOP
;IR.c,831 :: 		}
L_rc6_print156:
;IR.c,832 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr75_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr75_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,833 :: 		}
	GOTO        L_rc6_print136
;IR.c,834 :: 		}
L_end_rc6_print:
	RETURN      0
; end of _rc6_print

_get_rc6_byte:

;IR.c,837 :: 		unsigned char get_rc6_byte(char nbits){
;IR.c,840 :: 		irbyte = 0;                                  // initialise
	CLRF        _irbyte+0 
;IR.c,841 :: 		for(n = 0 ; n < nbits ; n++){
	CLRF        get_rc6_byte_n_L0+0 
L_get_rc6_byte165:
	MOVF        FARG_get_rc6_byte_nbits+0, 0 
	SUBWF       get_rc6_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_rc6_byte166
;IR.c,842 :: 		getrc6bit();
	CALL        _getrc6bit+0, 0
;IR.c,841 :: 		for(n = 0 ; n < nbits ; n++){
	INCF        get_rc6_byte_n_L0+0, 1 
;IR.c,843 :: 		}
	GOTO        L_get_rc6_byte165
L_get_rc6_byte166:
;IR.c,844 :: 		return irbyte;
	MOVF        _irbyte+0, 0 
	MOVWF       R0 
;IR.c,845 :: 		}
L_end_get_rc6_byte:
	RETURN      0
; end of _get_rc6_byte

_getrc6bit:

;IR.c,848 :: 		void getrc6bit(void){
;IR.c,850 :: 		if(!irnowm){
	MOVF        _irnowm+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit168
;IR.c,852 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit169
;IR.c,854 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,855 :: 		temp_bit_s = get_space();                         // get 1st half of bit
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,856 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,857 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,858 :: 		if(temp_bit_m < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit326
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit326:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit170
	CLRF        _irwas2t+0 
L_getrc6bit170:
;IR.c,859 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,860 :: 		}
	GOTO        L_getrc6bit171
L_getrc6bit169:
;IR.c,863 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,864 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,865 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,866 :: 		if(temp_bit_s < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit327
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit327:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit172
	CLRF        _irwas2t+0 
L_getrc6bit172:
;IR.c,867 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,868 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,869 :: 		}
L_getrc6bit171:
;IR.c,870 :: 		}
	GOTO        L_getrc6bit173
L_getrc6bit168:
;IR.c,873 :: 		if(!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_getrc6bit174
;IR.c,875 :: 		irnowm = 0xff;                                    // will leave in mark state
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,876 :: 		temp_bit_m = get_mark();                          // get 1st half of bit
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,877 :: 		temp_bit_s = get_space();                         // get 2nd half of bit (+ maybe half of next)
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_s+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_s+1 
;IR.c,878 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,879 :: 		if(temp_bit_s < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit328
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit328:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit175
	CLRF        _irwas2t+0 
L_getrc6bit175:
;IR.c,880 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,881 :: 		irbyte ++;                                        // change to a 1
	INCF        _irbyte+0, 1 
;IR.c,882 :: 		}
	GOTO        L_getrc6bit176
L_getrc6bit174:
;IR.c,885 :: 		irnowm = 0;                                       // will leave in space state
	CLRF        _irnowm+0 
;IR.c,886 :: 		temp_bit_m = get_mark();                          // get 2nd half of bit (+ maybe half of next)
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       _temp_bit_m+0 
	MOVF        R1, 0 
	MOVWF       _temp_bit_m+1 
;IR.c,887 :: 		irwas2t = 0xff;                                   // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,888 :: 		if(temp_bit_m < 40) irwas2t = 0;                  // if 1t
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__getrc6bit329
	MOVLW       40
	SUBWF       R0, 0 
L__getrc6bit329:
	BTFSC       STATUS+0, 0 
	GOTO        L_getrc6bit177
	CLRF        _irwas2t+0 
L_getrc6bit177:
;IR.c,889 :: 		irbyte <<= 1;                                     // rotate in a 0
	RLCF        _irbyte+0, 1 
	BCF         _irbyte+0, 0 
;IR.c,890 :: 		}
L_getrc6bit176:
;IR.c,891 :: 		}
L_getrc6bit173:
;IR.c,892 :: 		}
L_end_getrc6bit:
	RETURN      0
; end of _getrc6bit

_sky_print:

;IR.c,895 :: 		void sky_print(void){
;IR.c,900 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,901 :: 		Lcd_Out(1,1, "RC6 mode6-20 Sky");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr76_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr76_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,902 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr77_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr77_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,904 :: 		while(1){
L_sky_print178:
;IR.c,905 :: 		while(ir_in);                         // wait for IR to go low
L_sky_print180:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_sky_print181
	GOTO        L_sky_print180
L_sky_print181:
;IR.c,908 :: 		leader6 = 0;        // init
	CLRF        sky_print_leader6_L0+0 
;IR.c,910 :: 		while(!leader6){
L_sky_print182:
	MOVF        sky_print_leader6_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print183
;IR.c,911 :: 		temp_ir = get_mark();                      // get leader
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,912 :: 		if ((temp_ir > 140) && (temp_ir < 200)){   // expect 2.66mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print331
	MOVF        R0, 0 
	SUBLW       140
L__sky_print331:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print186
	MOVLW       128
	XORWF       sky_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print332
	MOVLW       200
	SUBWF       sky_print_temp_ir_L0+0, 0 
L__sky_print332:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print186
L__sky_print263:
;IR.c,913 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,914 :: 		if ((temp_ir > 40) && (temp_ir < 60)){   // expect 889uS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print333
	MOVF        R0, 0 
	SUBLW       40
L__sky_print333:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print189
	MOVLW       128
	XORWF       sky_print_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print334
	MOVLW       60
	SUBWF       sky_print_temp_ir_L0+0, 0 
L__sky_print334:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print189
L__sky_print262:
;IR.c,915 :: 		leader6 = 1;                           // leader found - allow exit loop
	MOVLW       1
	MOVWF       sky_print_leader6_L0+0 
;IR.c,916 :: 		}
L_sky_print189:
;IR.c,917 :: 		}
L_sky_print186:
;IR.c,918 :: 		}
	GOTO        L_sky_print182
L_sky_print183:
;IR.c,920 :: 		irwas2t = 0;                                   // init
	CLRF        _irwas2t+0 
;IR.c,921 :: 		irnowm = 0xff;                                 // init
	MOVLW       255
	MOVWF       _irnowm+0 
;IR.c,922 :: 		rc6_mode = get_rc6_byte(4);                    // start bit2 '1' + 3 bits mode
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_rc6_mode_L0+0 
;IR.c,923 :: 		rc6_mode &= 0x07;                              // remove start bit '1' to leave 3 bits mode
	MOVLW       7
	ANDWF       R0, 0 
	MOVWF       sky_print_rc6_mode_L0+0 
;IR.c,926 :: 		if (irwas2t){                                  // actually detecting 3t, single toggle bit is double size
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print190
;IR.c,927 :: 		ir_toggle = 1;                             // have found a trailer / toggle bit of 1
	MOVLW       1
	MOVWF       _ir_toggle+0 
;IR.c,928 :: 		irnowm = 0;                                // leave in mark state
	CLRF        _irnowm+0 
;IR.c,929 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,930 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,931 :: 		if(temp_bit_s < 70){
	MOVLW       128
	XORWF       _temp_bit_s+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print335
	MOVLW       70
	SUBWF       _temp_bit_s+0, 0 
L__sky_print335:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print191
;IR.c,932 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,933 :: 		}
L_sky_print191:
;IR.c,934 :: 		}
	GOTO        L_sky_print192
L_sky_print190:
;IR.c,936 :: 		ir_toggle = 0;                             // have found a trailer / toggle bit of 0
	CLRF        _ir_toggle+0 
;IR.c,937 :: 		irnowm = 0;                                // leave in mark state
	CLRF        _irnowm+0 
;IR.c,938 :: 		temp_ir = get_space();                     // skip over the mark
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,939 :: 		temp_ir = get_mark();                      // read the space
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       sky_print_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       sky_print_temp_ir_L0+1 
;IR.c,940 :: 		irwas2t = 0xff;                            // assume 2t until checked
	MOVLW       255
	MOVWF       _irwas2t+0 
;IR.c,941 :: 		if(temp_bit_m < 70){
	MOVLW       128
	XORWF       _temp_bit_m+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__sky_print336
	MOVLW       70
	SUBWF       _temp_bit_m+0, 0 
L__sky_print336:
	BTFSC       STATUS+0, 0 
	GOTO        L_sky_print193
;IR.c,942 :: 		irwas2t = 0;                           // if 1t
	CLRF        _irwas2t+0 
;IR.c,943 :: 		}
L_sky_print193:
;IR.c,944 :: 		}
L_sky_print192:
;IR.c,946 :: 		if (rc6_mode == 0){
	MOVF        sky_print_rc6_mode_L0+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print194
;IR.c,948 :: 		ir_result[1] = get_rc6_byte(8);               // control byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,949 :: 		ir_result[2] = get_rc6_byte(8);               // information byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,951 :: 		UART1_Write_Text("rc6 mode 0");
	MOVLW       ?lstr78_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr78_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,952 :: 		Lcd_Out(1,1, "RC6 mode 0      ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr79_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr79_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,953 :: 		Lcd_Out(2,1, "t=0 ct=   inf=  ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr80_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr80_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,954 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print195
;IR.c,955 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr81_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr81_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,956 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,957 :: 		}
	GOTO        L_sky_print196
L_sky_print195:
;IR.c,959 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr82_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr82_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,960 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,961 :: 		}
L_sky_print196:
;IR.c,962 :: 		UART1_Write_Text(" ctrl=");
	MOVLW       ?lstr83_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr83_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,963 :: 		hexout(ir_result[1]);                         // 8 bits control byte
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,964 :: 		Lcd_Chr(2,8,keephex[0]);               // recover character stored by hexout function
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       8
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,965 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,966 :: 		UART1_Write_Text(" inf=");
	MOVLW       ?lstr84_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr84_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,967 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,968 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,969 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,970 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sky_print197:
	DECFSZ      R13, 1, 1
	BRA         L_sky_print197
	DECFSZ      R12, 1, 1
	BRA         L_sky_print197
	NOP
;IR.c,971 :: 		}
L_sky_print194:
;IR.c,973 :: 		if (rc6_mode == 6){
	MOVF        sky_print_rc6_mode_L0+0, 0 
	XORLW       6
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print198
;IR.c,975 :: 		ir_result[1] = get_rc6_byte(4);               // first nibble
	MOVLW       4
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,976 :: 		ir_result[2] = get_rc6_byte(8);               // full byte
	MOVLW       8
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,977 :: 		ir_result[3] = get_rc6_byte(7);               // only 7 bits of byte
	MOVLW       7
	MOVWF       FARG_get_rc6_byte_nbits+0 
	CALL        _get_rc6_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,979 :: 		ir_result[3] <<= 1;                           // leave room for last bit
	MOVF        R0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       _ir_result+3 
;IR.c,980 :: 		if (ir_result[3] & 0x02){                     // penultimate bit was 1
	BTFSS       R1, 1 
	GOTO        L_sky_print199
;IR.c,981 :: 		if (!irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_sky_print200
;IR.c,982 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,983 :: 		}
L_sky_print200:
;IR.c,984 :: 		get_mark();
	CALL        _get_mark+0, 0
;IR.c,985 :: 		}
	GOTO        L_sky_print201
L_sky_print199:
;IR.c,987 :: 		if (irwas2t){
	MOVF        _irwas2t+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print202
;IR.c,988 :: 		ir_result[3]++;                       // last bit must be 1
	INCF        _ir_result+3, 1 
;IR.c,989 :: 		}
	GOTO        L_sky_print203
L_sky_print202:
;IR.c,992 :: 		}
L_sky_print203:
;IR.c,993 :: 		}
L_sky_print201:
;IR.c,995 :: 		UART1_Write_Text("RC6 mode 6-20");
	MOVLW       ?lstr85_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr85_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,996 :: 		Lcd_Out(1,1, "RC6 mode6-20 Sky");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr86_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr86_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,997 :: 		Lcd_Out(2,1, "t=0             ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr87_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr87_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,998 :: 		if (ir_toggle){
	MOVF        _ir_toggle+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_sky_print204
;IR.c,999 :: 		UART1_Write_Text(" t=1");              // toggle bit
	MOVLW       ?lstr88_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr88_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1000 :: 		Lcd_Chr(2,3,'1');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       49
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1001 :: 		}
	GOTO        L_sky_print205
L_sky_print204:
;IR.c,1003 :: 		UART1_Write_Text(" t=0");              // toggle bit
	MOVLW       ?lstr89_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr89_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1004 :: 		Lcd_Chr(2,3,'0');
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVLW       48
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1005 :: 		}
L_sky_print205:
;IR.c,1006 :: 		UART1_Write_Text(" ");
	MOVLW       ?lstr90_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr90_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1007 :: 		hexout(ir_result[1]);                         // 4 bits
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1008 :: 		Lcd_Chr(2,9,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       9
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1009 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1010 :: 		Lcd_Chr(2,10,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1011 :: 		Lcd_Chr(2,11,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       11
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1012 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1013 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1014 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1015 :: 		Delay_ms(10);                              // wait for repeat messages to clear
	MOVLW       104
	MOVWF       R12, 0
	MOVLW       228
	MOVWF       R13, 0
L_sky_print206:
	DECFSZ      R13, 1, 1
	BRA         L_sky_print206
	DECFSZ      R12, 1, 1
	BRA         L_sky_print206
	NOP
;IR.c,1016 :: 		}
L_sky_print198:
;IR.c,1017 :: 		UART1_Write_Text("\r\n");
	MOVLW       ?lstr91_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr91_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1018 :: 		}
	GOTO        L_sky_print178
;IR.c,1019 :: 		}
L_end_sky_print:
	RETURN      0
; end of _sky_print

_tosh_print:

;IR.c,1029 :: 		void tosh_print(void){
;IR.c,1033 :: 		p_wait();                                // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,1034 :: 		Lcd_Out(1,1, "Toshiba protocol");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr92_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr92_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1035 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr93_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr93_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1037 :: 		while(1){
L_tosh_print207:
;IR.c,1038 :: 		while(ir_in);                              // wait for IR to go low
L_tosh_print209:
	BTFSS       RA3_bit+0, BitPos(RA3_bit+0) 
	GOTO        L_tosh_print210
	GOTO        L_tosh_print209
L_tosh_print210:
;IR.c,1039 :: 		irnowm = 1;                                // initilise
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,1040 :: 		tosh_result[0] = get_tosh_byte(3);         // 3 bit code
	MOVLW       3
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+0 
;IR.c,1041 :: 		tosh_result[1] = get_tosh_byte(3);         // 3 bit header
	MOVLW       3
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+1 
;IR.c,1042 :: 		tosh_result[2] = get_tosh_byte(6);         // 6 bit data
	MOVLW       6
	MOVWF       FARG_get_tosh_byte_nbits+0 
	CALL        _get_tosh_byte+0, 0
	MOVF        R0, 0 
	MOVWF       tosh_print_tosh_result_L0+2 
;IR.c,1043 :: 		UART1_Write_Text("\r\nToshiba code=");
	MOVLW       ?lstr94_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr94_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1044 :: 		Lcd_Out(2,1, "code=  h=  d=   ");      // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr95_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr95_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1045 :: 		hexout(tosh_result[0]);
	MOVF        tosh_print_tosh_result_L0+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1046 :: 		Lcd_Chr(2,6,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1047 :: 		UART1_Write_Text(" header=");
	MOVLW       ?lstr96_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr96_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1048 :: 		hexout(tosh_result[1]);
	MOVF        tosh_print_tosh_result_L0+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1049 :: 		Lcd_Chr(2,10,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1050 :: 		UART1_Write_Text(" data=");
	MOVLW       ?lstr97_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr97_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1051 :: 		hexout(tosh_result[2]);
	MOVF        tosh_print_tosh_result_L0+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1052 :: 		Lcd_Chr(2,14,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       14
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1053 :: 		Lcd_Chr(2,15,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1054 :: 		Delay_ms(1);             // wait for repeat messages to clear
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_tosh_print211:
	DECFSZ      R13, 1, 1
	BRA         L_tosh_print211
	DECFSZ      R12, 1, 1
	BRA         L_tosh_print211
	NOP
;IR.c,1055 :: 		}
	GOTO        L_tosh_print207
;IR.c,1057 :: 		}
L_end_tosh_print:
	RETURN      0
; end of _tosh_print

_get_tosh_byte:

;IR.c,1061 :: 		unsigned char get_tosh_byte(char nbits){
;IR.c,1066 :: 		ir_byte = 0;                                  // initialise
	CLRF        get_tosh_byte_ir_byte_L0+0 
;IR.c,1067 :: 		for(n=0 ; n<nbits ; n++){
	CLRF        get_tosh_byte_n_L0+0 
L_get_tosh_byte212:
	MOVF        FARG_get_tosh_byte_nbits+0, 0 
	SUBWF       get_tosh_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte213
;IR.c,1068 :: 		if (irnowm){
	MOVF        _irnowm+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_tosh_byte215
;IR.c,1069 :: 		temp_ir = get_space();                // keep looking for long pulse mark or space
	CALL        _get_space+0, 0
;IR.c,1070 :: 		irnowm = 0;                           // keep pace
	CLRF        _irnowm+0 
;IR.c,1071 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte339
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte339:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte216
;IR.c,1072 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,1073 :: 		irnowm = 1;                       // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,1074 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte340
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte340:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte217
;IR.c,1075 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
;IR.c,1076 :: 		irnowm = 0;                   // keep pace
	CLRF        _irnowm+0 
;IR.c,1077 :: 		}
L_get_tosh_byte217:
;IR.c,1078 :: 		}
L_get_tosh_byte216:
;IR.c,1079 :: 		}
	GOTO        L_get_tosh_byte218
L_get_tosh_byte215:
;IR.c,1081 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,1082 :: 		irnowm = 1;                           // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,1083 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte341
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte341:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte219
;IR.c,1084 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
;IR.c,1085 :: 		irnowm = 0;                       // keep pace
	CLRF        _irnowm+0 
;IR.c,1086 :: 		if (temp_ir < 60) {
	MOVLW       128
	XORWF       R1, 0 
	MOVWF       R2 
	MOVLW       128
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_tosh_byte342
	MOVLW       60
	SUBWF       R0, 0 
L__get_tosh_byte342:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_tosh_byte220
;IR.c,1087 :: 		temp_ir = get_mark();
	CALL        _get_mark+0, 0
;IR.c,1088 :: 		irnowm = 1;                   // keep pace
	MOVLW       1
	MOVWF       _irnowm+0 
;IR.c,1089 :: 		}
L_get_tosh_byte220:
;IR.c,1090 :: 		}
L_get_tosh_byte219:
;IR.c,1092 :: 		}
L_get_tosh_byte218:
;IR.c,1095 :: 		ir_byte <<= 1;                            // shift in a zero
	RLCF        get_tosh_byte_ir_byte_L0+0, 1 
	BCF         get_tosh_byte_ir_byte_L0+0, 0 
;IR.c,1096 :: 		if (irnowm){
	MOVF        _irnowm+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_tosh_byte221
;IR.c,1097 :: 		ir_byte += 0x01;                      // change to a 1
	INCF        get_tosh_byte_ir_byte_L0+0, 1 
;IR.c,1098 :: 		}
L_get_tosh_byte221:
;IR.c,1067 :: 		for(n=0 ; n<nbits ; n++){
	INCF        get_tosh_byte_n_L0+0, 1 
;IR.c,1099 :: 		}
	GOTO        L_get_tosh_byte212
L_get_tosh_byte213:
;IR.c,1100 :: 		return ir_byte;
	MOVF        get_tosh_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,1101 :: 		}
L_end_get_tosh_byte:
	RETURN      0
; end of _get_tosh_byte

_mmc_print:

;IR.c,1105 :: 		void mmc_print(void){
;IR.c,1109 :: 		p_wait();                                      // "Waiting for IR";
	CALL        _p_wait+0, 0
;IR.c,1110 :: 		Lcd_Out(1,1, "BTC kbd protocol");    // Print text to Lcd, 1st row, 1st column
	MOVLW       1
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr99_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr99_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1111 :: 		Lcd_Out(2,1, "waiting for IR  ");    // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr100_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr100_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1113 :: 		while(1){
L_mmc_print222:
;IR.c,1114 :: 		get_quiet();
	CALL        _get_quiet+0, 0
;IR.c,1115 :: 		mmc_header();                              // wait for header
	CALL        _mmc_header+0, 0
;IR.c,1116 :: 		ir_result[0] = get_mmc_byte(3);
	MOVLW       3
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+0 
;IR.c,1117 :: 		ir_result[1] = get_mmc_byte(8);
	MOVLW       8
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+1 
;IR.c,1118 :: 		ir_result[2] = get_mmc_byte(8);
	MOVLW       8
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+2 
;IR.c,1119 :: 		mmc_header();                              // wait for header
	CALL        _mmc_header+0, 0
;IR.c,1120 :: 		ir_result[3] = get_mmc_byte(3);
	MOVLW       3
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+3 
;IR.c,1121 :: 		ir_result[4] = get_mmc_byte(8);
	MOVLW       8
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+4 
;IR.c,1122 :: 		ir_result[5] = get_mmc_byte(8);
	MOVLW       8
	MOVWF       FARG_get_mmc_byte_ndbits+0 
	CALL        _get_mmc_byte+0, 0
	MOVF        R0, 0 
	MOVWF       _ir_result+5 
;IR.c,1123 :: 		UART1_Write_Text("\r\nmmc= ");
	MOVLW       ?lstr101_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr101_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1124 :: 		Lcd_Out(2,1, "                ");          // Print text to Lcd, 2nd row, 1st column
	MOVLW       2
	MOVWF       FARG_Lcd_Out_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Out_column+0 
	MOVLW       ?lstr102_IR+0
	MOVWF       FARG_Lcd_Out_text+0 
	MOVLW       hi_addr(?lstr102_IR+0)
	MOVWF       FARG_Lcd_Out_text+1 
	CALL        _Lcd_Out+0, 0
;IR.c,1125 :: 		hexout(ir_result[0]);
	MOVF        _ir_result+0, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1126 :: 		Lcd_Chr(2,1,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       1
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1127 :: 		hexout(ir_result[1]);
	MOVF        _ir_result+1, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1128 :: 		Lcd_Chr(2,3,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       3
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1129 :: 		Lcd_Chr(2,4,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       4
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1130 :: 		hexout(ir_result[2]);
	MOVF        _ir_result+2, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1131 :: 		Lcd_Chr(2,6,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       6
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1132 :: 		Lcd_Chr(2,7,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       7
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1134 :: 		UART1_Write_Text("- ");
	MOVLW       ?lstr103_IR+0
	MOVWF       FARG_UART1_Write_Text_uart_text+0 
	MOVLW       hi_addr(?lstr103_IR+0)
	MOVWF       FARG_UART1_Write_Text_uart_text+1 
	CALL        _UART1_Write_Text+0, 0
;IR.c,1135 :: 		hexout(ir_result[3]);
	MOVF        _ir_result+3, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1136 :: 		Lcd_Chr(2,10,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       10
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1137 :: 		hexout(ir_result[4]);
	MOVF        _ir_result+4, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1138 :: 		Lcd_Chr(2,12,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       12
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1139 :: 		Lcd_Chr(2,13,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       13
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1140 :: 		hexout(ir_result[5]);
	MOVF        _ir_result+5, 0 
	MOVWF       FARG_hexout_hexval+0 
	CALL        _hexout+0, 0
;IR.c,1141 :: 		Lcd_Chr(2,15,keephex[0]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       15
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+0, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1142 :: 		Lcd_Chr(2,16,keephex[1]);
	MOVLW       2
	MOVWF       FARG_Lcd_Chr_row+0 
	MOVLW       16
	MOVWF       FARG_Lcd_Chr_column+0 
	MOVF        _keephex+1, 0 
	MOVWF       FARG_Lcd_Chr_out_char+0 
	CALL        _Lcd_Chr+0, 0
;IR.c,1144 :: 		Delay_ms(1);                               // wait for repeat messages to clear
	MOVLW       11
	MOVWF       R12, 0
	MOVLW       98
	MOVWF       R13, 0
L_mmc_print224:
	DECFSZ      R13, 1, 1
	BRA         L_mmc_print224
	DECFSZ      R12, 1, 1
	BRA         L_mmc_print224
	NOP
;IR.c,1145 :: 		}
	GOTO        L_mmc_print222
;IR.c,1147 :: 		}
L_end_mmc_print:
	RETURN      0
; end of _mmc_print

_mmc_header:

;IR.c,1149 :: 		void mmc_header(void){
;IR.c,1154 :: 		leader_m = 0;        // init
	CLRF        mmc_header_leader_m_L0+0 
;IR.c,1156 :: 		while(!leader_m){
L_mmc_header225:
	MOVF        mmc_header_leader_m_L0+0, 1 
	BTFSS       STATUS+0, 2 
	GOTO        L_mmc_header226
;IR.c,1157 :: 		temp_ir = get_mark();                          // get leader
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       mmc_header_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       mmc_header_temp_ir_L0+1 
;IR.c,1158 :: 		if ((temp_ir > 60) && (temp_ir < 90)){        // expect 1.2mS mark
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__mmc_header345
	MOVF        R0, 0 
	SUBLW       60
L__mmc_header345:
	BTFSC       STATUS+0, 0 
	GOTO        L_mmc_header229
	MOVLW       128
	XORWF       mmc_header_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__mmc_header346
	MOVLW       90
	SUBWF       mmc_header_temp_ir_L0+0, 0 
L__mmc_header346:
	BTFSC       STATUS+0, 0 
	GOTO        L_mmc_header229
L__mmc_header265:
;IR.c,1159 :: 		temp_ir = get_space();
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       mmc_header_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       mmc_header_temp_ir_L0+1 
;IR.c,1160 :: 		if ((temp_ir > 50) && (temp_ir < 90)){    // expect 1.2mS space
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__mmc_header347
	MOVF        R0, 0 
	SUBLW       50
L__mmc_header347:
	BTFSC       STATUS+0, 0 
	GOTO        L_mmc_header232
	MOVLW       128
	XORWF       mmc_header_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__mmc_header348
	MOVLW       90
	SUBWF       mmc_header_temp_ir_L0+0, 0 
L__mmc_header348:
	BTFSC       STATUS+0, 0 
	GOTO        L_mmc_header232
L__mmc_header264:
;IR.c,1161 :: 		leader_m = 1;                          // leader found - allow exit loop
	MOVLW       1
	MOVWF       mmc_header_leader_m_L0+0 
;IR.c,1162 :: 		}
L_mmc_header232:
;IR.c,1163 :: 		}
L_mmc_header229:
;IR.c,1164 :: 		}
	GOTO        L_mmc_header225
L_mmc_header226:
;IR.c,1165 :: 		mmc_zeros = 0;                                     // initialise
	CLRF        _mmc_zeros+0 
;IR.c,1166 :: 		}
L_end_mmc_header:
	RETURN      0
; end of _mmc_header

_get_mmc_byte:

;IR.c,1168 :: 		unsigned char get_mmc_byte(char ndbits){
;IR.c,1173 :: 		ir_byte = 0;                                       // initialise
	CLRF        get_mmc_byte_ir_byte_L0+0 
;IR.c,1174 :: 		for(n = 0 ; n < ndbits ; n++){
	CLRF        get_mmc_byte_n_L0+0 
L_get_mmc_byte233:
	MOVF        FARG_get_mmc_byte_ndbits+0, 0 
	SUBWF       get_mmc_byte_n_L0+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_byte234
;IR.c,1175 :: 		temp_ir = get_mmc_bit();
	CALL        _get_mmc_bit+0, 0
;IR.c,1176 :: 		ir_byte <<= 1;                                 // shift in a zero
	RLCF        get_mmc_byte_ir_byte_L0+0, 1 
	BCF         get_mmc_byte_ir_byte_L0+0, 0 
;IR.c,1177 :: 		if (temp_ir == 1){
	MOVF        R0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_get_mmc_byte236
;IR.c,1178 :: 		ir_byte |= 1;                              // change to a 1
	BSF         get_mmc_byte_ir_byte_L0+0, 0 
;IR.c,1179 :: 		}
L_get_mmc_byte236:
;IR.c,1174 :: 		for(n = 0 ; n < ndbits ; n++){
	INCF        get_mmc_byte_n_L0+0, 1 
;IR.c,1180 :: 		}
	GOTO        L_get_mmc_byte233
L_get_mmc_byte234:
;IR.c,1181 :: 		return ir_byte;
	MOVF        get_mmc_byte_ir_byte_L0+0, 0 
	MOVWF       R0 
;IR.c,1182 :: 		}
L_end_get_mmc_byte:
	RETURN      0
; end of _get_mmc_byte

_get_mmc_bit:

;IR.c,1184 :: 		char get_mmc_bit(){
;IR.c,1188 :: 		if(mmc_zeros){                                     // earlier zeros to process
	MOVF        _mmc_zeros+0, 1 
	BTFSC       STATUS+0, 2 
	GOTO        L_get_mmc_bit237
;IR.c,1189 :: 		retval = 0;                                    // shift in a 0
	CLRF        get_mmc_bit_retval_L0+0 
;IR.c,1190 :: 		mmc_zeros--;                                   // count 1 less
	DECF        _mmc_zeros+0, 1 
;IR.c,1191 :: 		}
	GOTO        L_get_mmc_bit238
L_get_mmc_bit237:
;IR.c,1193 :: 		mmc_zeros = 0;                                 // initialise
	CLRF        _mmc_zeros+0 
;IR.c,1194 :: 		temp_ir = get_mark();                          // mark is always 400us, so ignore
	CALL        _get_mark+0, 0
	MOVF        R0, 0 
	MOVWF       get_mmc_bit_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       get_mmc_bit_temp_ir_L0+1 
;IR.c,1195 :: 		temp_ir = get_space();                         //
	CALL        _get_space+0, 0
	MOVF        R0, 0 
	MOVWF       get_mmc_bit_temp_ir_L0+0 
	MOVF        R1, 0 
	MOVWF       get_mmc_bit_temp_ir_L0+1 
;IR.c,1196 :: 		if ((temp_ir > 10) && (temp_ir < 45)){         // expect 400uS space for 1
	MOVLW       128
	MOVWF       R2 
	MOVLW       128
	XORWF       R1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit351
	MOVF        R0, 0 
	SUBLW       10
L__get_mmc_bit351:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit241
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit352
	MOVLW       45
	SUBWF       get_mmc_bit_temp_ir_L0+0, 0 
L__get_mmc_bit352:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit241
L__get_mmc_bit270:
;IR.c,1197 :: 		retval = 1;
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1198 :: 		}
L_get_mmc_bit241:
;IR.c,1199 :: 		if ((temp_ir > 45) && (temp_ir < 90)){         // expect 1.1mS space for a zero
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit353
	MOVF        get_mmc_bit_temp_ir_L0+0, 0 
	SUBLW       45
L__get_mmc_bit353:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit244
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit354
	MOVLW       90
	SUBWF       get_mmc_bit_temp_ir_L0+0, 0 
L__get_mmc_bit354:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit244
L__get_mmc_bit269:
;IR.c,1200 :: 		retval = 1;                                // single zero found
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1201 :: 		mmc_zeros = 1;                             // single zero found + another waiting
	MOVLW       1
	MOVWF       _mmc_zeros+0 
;IR.c,1202 :: 		}
L_get_mmc_bit244:
;IR.c,1203 :: 		if ((temp_ir > 90) && (temp_ir < 140)){        // expect 1.8mS space for 2 zeros
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit355
	MOVF        get_mmc_bit_temp_ir_L0+0, 0 
	SUBLW       90
L__get_mmc_bit355:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit247
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit356
	MOVLW       140
	SUBWF       get_mmc_bit_temp_ir_L0+0, 0 
L__get_mmc_bit356:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit247
L__get_mmc_bit268:
;IR.c,1204 :: 		retval = 1;
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1205 :: 		mmc_zeros = 2;                             // single zero found + another waiting
	MOVLW       2
	MOVWF       _mmc_zeros+0 
;IR.c,1206 :: 		}
L_get_mmc_bit247:
;IR.c,1207 :: 		if ((temp_ir > 140) && (temp_ir < 200)){       // expect 2.6mS space for 3 zeros
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit357
	MOVF        get_mmc_bit_temp_ir_L0+0, 0 
	SUBLW       140
L__get_mmc_bit357:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit250
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit358
	MOVLW       200
	SUBWF       get_mmc_bit_temp_ir_L0+0, 0 
L__get_mmc_bit358:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit250
L__get_mmc_bit267:
;IR.c,1208 :: 		retval = 1;
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1209 :: 		mmc_zeros = 3;                             // single zero found + another waiting
	MOVLW       3
	MOVWF       _mmc_zeros+0 
;IR.c,1210 :: 		}
L_get_mmc_bit250:
;IR.c,1211 :: 		if ((temp_ir > 200) && (temp_ir < 250)){       // expect 3.4mS space for 4 zeros
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit359
	MOVF        get_mmc_bit_temp_ir_L0+0, 0 
	SUBLW       200
L__get_mmc_bit359:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit253
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	MOVWF       R0 
	MOVLW       128
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit360
	MOVLW       250
	SUBWF       get_mmc_bit_temp_ir_L0+0, 0 
L__get_mmc_bit360:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit253
L__get_mmc_bit266:
;IR.c,1212 :: 		retval = 1;
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1213 :: 		mmc_zeros = 4;                             // single zero found + another waiting
	MOVLW       4
	MOVWF       _mmc_zeros+0 
;IR.c,1214 :: 		}
L_get_mmc_bit253:
;IR.c,1215 :: 		if (temp_ir > 250) {                           // expect 40mS space for intermessage gap
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       get_mmc_bit_temp_ir_L0+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__get_mmc_bit361
	MOVF        get_mmc_bit_temp_ir_L0+0, 0 
	SUBLW       250
L__get_mmc_bit361:
	BTFSC       STATUS+0, 0 
	GOTO        L_get_mmc_bit254
;IR.c,1216 :: 		retval = 1;
	MOVLW       1
	MOVWF       get_mmc_bit_retval_L0+0 
;IR.c,1217 :: 		mmc_zeros = 4;                             // fill rest of byte with zeros
	MOVLW       4
	MOVWF       _mmc_zeros+0 
;IR.c,1218 :: 		}
L_get_mmc_bit254:
;IR.c,1219 :: 		}
L_get_mmc_bit238:
;IR.c,1220 :: 		return retval;
	MOVF        get_mmc_bit_retval_L0+0, 0 
	MOVWF       R0 
;IR.c,1221 :: 		}
L_end_get_mmc_bit:
	RETURN      0
; end of _get_mmc_bit
